GDAL

- Main Page
- Related Pages
- Classes
- Files
- Download
- Issue Tracker

- File List
- File Members

Typedefs | Functions
ogr_api.h File Reference

C API and defines for OGRFeature, OGRGeometry, and OGRDataSource related classes. More...

`#include "cpl_progress.h"`
`#include "cpl_minixml.h"`
`#include "ogr_core.h"`

Go to the source code of this file.

## Typedefs
typedef void * | OGRGeometryH
| Opaque type for a geometyr.
typedef void * | OGRSpatialReferenceH
| Opaque type for a spatial reference system.
typedef void * | OGRCoordinateTransformationH
| Opaque type for a coordinate transformation object.
typedef void * | OGRFieldDefnH
| Opaque type for a field definition (OGRFieldDefn)
typedef void * | OGRFeatureDefnH
| Opaque type for a feature definition (OGRFeatureDefn)
typedef void * | OGRFeatureH
| Opaque type for a feature (OGRFeature)
typedef void * | OGRStyleTableH
| Opaque type for a style table (OGRStyleTable)
typedef struct OGRGeomFieldDefnHS * | OGRGeomFieldDefnH
| Opaque type for a geometry field definition (OGRGeomFieldDefn)
typedef void * | OGRLayerH
| Opaque type for a layer (OGRLayer)
typedef void * | OGRDataSourceH
| Opaque type for a OGR datasource (OGRDataSource)
typedef void * | OGRSFDriverH
| Opaque type for a OGR driver (OGRSFDriver)
typedef void * | OGRStyleMgrH
| Style manager opaque type.
typedef void * | OGRStyleToolH
| Style tool opaque type.

## Functions
OGRErr | OGR_G_CreateFromWkb (unsigned char *, OGRSpatialReferenceH, OGRGeometryH *, int)
| Create a geometry object of the appropriate type from it's well known binary representation. More...
OGRErr | OGR_G_CreateFromWkt (char **, OGRSpatialReferenceH, OGRGeometryH *)
| Create a geometry object of the appropriate type from it's well known text representation. More...
OGRErr | OGR_G_CreateFromFgf (unsigned char *, OGRSpatialReferenceH, OGRGeometryH *, int, int *)
| Create a geometry object of the appropriate type from it's FGF (FDO Geometry Format) binary representation. More...
void | OGR_G_DestroyGeometry (OGRGeometryH)
| Destroy geometry object. More...
OGRGeometryH | OGR_G_CreateGeometry (OGRwkbGeometryType) CPL_WARN_UNUSED_RESULT
| Create an empty geometry of desired type. More...
OGRGeometryH | OGR_G_ApproximateArcAngles (double dfCenterX, double dfCenterY, double dfZ, double dfPrimaryRadius, double dfSecondaryAxis, double dfRotation, double dfStartAngle, double dfEndAngle, double dfMaxAngleStepSizeDegrees) CPL_WARN_UNUSED_RESULT
| Stroke arc to linestring. More...
OGRGeometryH | OGR_G_ForceToPolygon (OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Convert to polygon. More...
OGRGeometryH | OGR_G_ForceToLineString (OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Convert to line string. More...
OGRGeometryH | OGR_G_ForceToMultiPolygon (OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Convert to multipolygon. More...
OGRGeometryH | OGR_G_ForceToMultiPoint (OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Convert to multipoint. More...
OGRGeometryH | OGR_G_ForceToMultiLineString (OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Convert to multilinestring. More...
OGRGeometryH | OGR_G_ForceTo (OGRGeometryH hGeom, OGRwkbGeometryType eTargetType, char **papszOptions) CPL_WARN_UNUSED_RESULT
| Convert to another geometry type. More...
int | OGR_G_GetDimension (OGRGeometryH)
| Get the dimension of this geometry. More...
int | OGR_G_GetCoordinateDimension (OGRGeometryH)
| Get the dimension of the coordinates in this geometry. More...
int | OGR_G_CoordinateDimension (OGRGeometryH)
| Get the dimension of the coordinates in this geometry. More...
void | OGR_G_SetCoordinateDimension (OGRGeometryH, int)
| Set the coordinate dimension. More...
int | OGR_G_Is3D (OGRGeometryH)
| See whether this geometry has Z coordinates. More...
int | OGR_G_IsMeasured (OGRGeometryH)
| See whether this geometry is measured. More...
void | OGR_G_Set3D (OGRGeometryH, int)
| Add or remove the Z coordinate dimension. More...
void | OGR_G_SetMeasured (OGRGeometryH, int)
| Add or remove the M coordinate dimension. More...
OGRGeometryH | OGR_G_Clone (OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Make a copy of this object. More...
void | OGR_G_GetEnvelope (OGRGeometryH, OGREnvelope *)
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure. More...
void | OGR_G_GetEnvelope3D (OGRGeometryH, OGREnvelope3D *)
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure. More...
OGRErr | OGR_G_ImportFromWkb (OGRGeometryH, unsigned char *, int)
| Assign geometry from well known binary data. More...
OGRErr | OGR_G_ExportToWkb (OGRGeometryH, OGRwkbByteOrder, unsigned char *)
| Convert a geometry well known binary format. More...
OGRErr | OGR_G_ExportToIsoWkb (OGRGeometryH, OGRwkbByteOrder, unsigned char *)
| Convert a geometry into SFSQL 1.2 / ISO SQL/MM Part 3 well known binary format. More...
int | OGR_G_WkbSize (OGRGeometryH hGeom)
| Returns size of related binary representation. More...
OGRErr | OGR_G_ImportFromWkt (OGRGeometryH, char **)
| Assign geometry from well known text data. More...
OGRErr | OGR_G_ExportToWkt (OGRGeometryH, char **)
| Convert a geometry into well known text format. More...
OGRErr | OGR_G_ExportToIsoWkt (OGRGeometryH, char **)
| Convert a geometry into SFSQL 1.2 / ISO SQL/MM Part 3 well known text format. More...
OGRwkbGeometryType | OGR_G_GetGeometryType (OGRGeometryH)
| Fetch geometry type. More...
const char * | OGR_G_GetGeometryName (OGRGeometryH)
| Fetch WKT name for geometry type. More...
void | OGR_G_DumpReadable (OGRGeometryH, FILE *, const char *)
| Dump geometry in well known text format to indicated output file. More...
void | OGR_G_FlattenTo2D (OGRGeometryH)
| Convert geometry to strictly 2D. More...
void | OGR_G_CloseRings (OGRGeometryH)
| Force rings to be closed. More...
OGRGeometryH | OGR_G_CreateFromGML (const char *) CPL_WARN_UNUSED_RESULT
| Create geometry from GML. More...
char * | OGR_G_ExportToGML (OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Convert a geometry into GML format. More...
char * | OGR_G_ExportToGMLEx (OGRGeometryH, char **papszOptions) CPL_WARN_UNUSED_RESULT
| Convert a geometry into GML format. More...
OGRGeometryH | OGR_G_CreateFromGMLTree (const CPLXMLNode *) CPL_WARN_UNUSED_RESULT
| Create geometry from GML.
CPLXMLNode * | OGR_G_ExportToGMLTree (OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Convert a geometry into GML format. More...
CPLXMLNode * | OGR_G_ExportEnvelopeToGMLTree (OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Export the envelope of a geometry as a gml:Box. More...
char * | OGR_G_ExportToKML (OGRGeometryH, const char *pszAltitudeMode) CPL_WARN_UNUSED_RESULT
| Convert a geometry into KML format. More...
char * | OGR_G_ExportToJson (OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Convert a geometry into GeoJSON format. More...
char * | OGR_G_ExportToJsonEx (OGRGeometryH, char **papszOptions) CPL_WARN_UNUSED_RESULT
| Convert a geometry into GeoJSON format. More...
OGRGeometryH | OGR_G_CreateGeometryFromJson (const char *) CPL_WARN_UNUSED_RESULT
| Create a OGR geometry from a GeoJSON geometry object.
void | OGR_G_AssignSpatialReference (OGRGeometryH, OGRSpatialReferenceH)
| Assign spatial reference to this object. More...
OGRSpatialReferenceH | OGR_G_GetSpatialReference (OGRGeometryH)
| Returns spatial reference system for geometry. More...
OGRErr | OGR_G_Transform (OGRGeometryH, OGRCoordinateTransformationH)
| Apply arbitrary coordinate transformation to geometry. More...
OGRErr | OGR_G_TransformTo (OGRGeometryH, OGRSpatialReferenceH)
| Transform geometry to new spatial reference system. More...
OGRGeometryH | OGR_G_Simplify (OGRGeometryH hThis, double tolerance) CPL_WARN_UNUSED_RESULT
| Compute a simplified geometry. More...
OGRGeometryH | OGR_G_SimplifyPreserveTopology (OGRGeometryH hThis, double tolerance) CPL_WARN_UNUSED_RESULT
| Simplify the geometry while preserving topology. More...
OGRGeometryH | OGR_G_DelaunayTriangulation (OGRGeometryH hThis, double dfTolerance, int bOnlyEdges) CPL_WARN_UNUSED_RESULT
| Return a Delaunay triangulation of the vertices of the geometry. More...
void | OGR_G_Segmentize (OGRGeometryH hGeom, double dfMaxLength)
| Modify the geometry such it has no segment longer then the given distance. More...
int | OGR_G_Intersects (OGRGeometryH, OGRGeometryH)
| Do these features intersect? More...
int | OGR_G_Equals (OGRGeometryH, OGRGeometryH)
| Returns TRUE if two geometries are equivalent. More...
int | OGR_G_Disjoint (OGRGeometryH, OGRGeometryH)
| Test for disjointness. More...
int | OGR_G_Touches (OGRGeometryH, OGRGeometryH)
| Test for touching. More...
int | OGR_G_Crosses (OGRGeometryH, OGRGeometryH)
| Test for crossing. More...
int | OGR_G_Within (OGRGeometryH, OGRGeometryH)
| Test for containment. More...
int | OGR_G_Contains (OGRGeometryH, OGRGeometryH)
| Test for containment. More...
int | OGR_G_Overlaps (OGRGeometryH, OGRGeometryH)
| Test for overlap. More...
OGRGeometryH | OGR_G_Boundary (OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Compute boundary. More...
OGRGeometryH | OGR_G_ConvexHull (OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Compute convex hull. More...
OGRGeometryH | OGR_G_Buffer (OGRGeometryH, double, int) CPL_WARN_UNUSED_RESULT
| Compute buffer of geometry. More...
OGRGeometryH | OGR_G_Intersection (OGRGeometryH, OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Compute intersection. More...
OGRGeometryH | OGR_G_Union (OGRGeometryH, OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Compute union. More...
OGRGeometryH | OGR_G_UnionCascaded (OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Compute union using cascading. More...
OGRGeometryH | OGR_G_PointOnSurface (OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Returns a point guaranteed to lie on the surface. More...
OGRGeometryH | OGR_G_Difference (OGRGeometryH, OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Compute difference. More...
OGRGeometryH | OGR_G_SymDifference (OGRGeometryH, OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Compute symmetric difference. More...
double | OGR_G_Distance (OGRGeometryH, OGRGeometryH)
| Compute distance between two geometries. More...
double | OGR_G_Distance3D (OGRGeometryH, OGRGeometryH)
| Returns the 3D distance between two geometries. More...
double | OGR_G_Length (OGRGeometryH)
| Compute length of a geometry. More...
double | OGR_G_Area (OGRGeometryH)
| Compute geometry area. More...
int | OGR_G_Centroid (OGRGeometryH, OGRGeometryH)
| Compute the geometry centroid. More...
OGRGeometryH | OGR_G_Value (OGRGeometryH, double dfDistance) CPL_WARN_UNUSED_RESULT
| Fetch point at given distance along curve. More...
void | OGR_G_Empty (OGRGeometryH)
| Clear geometry information. More...
int | OGR_G_IsEmpty (OGRGeometryH)
| Test if the geometry is empty. More...
int | OGR_G_IsValid (OGRGeometryH)
| Test if the geometry is valid. More...
int | OGR_G_IsSimple (OGRGeometryH)
| Returns TRUE if the geometry is simple. More...
int | OGR_G_IsRing (OGRGeometryH)
| Test if the geometry is a ring. More...
OGRGeometryH | OGR_G_Polygonize (OGRGeometryH) CPL_WARN_UNUSED_RESULT
| Polygonizes a set of sparse edges. More...
int | OGR_G_GetPointCount (OGRGeometryH)
| Fetch number of points from a geometry. More...
int | OGR_G_GetPoints (OGRGeometryH hGeom, void *pabyX, int nXStride, void *pabyY, int nYStride, void *pabyZ, int nZStride)
| Returns all points of line string. More...
int | OGR_G_GetPointsZM (OGRGeometryH hGeom, void *pabyX, int nXStride, void *pabyY, int nYStride, void *pabyZ, int nZStride, void *pabyM, int nMStride)
| Returns all points of line string. More...
double | OGR_G_GetX (OGRGeometryH, int)
| Fetch the x coordinate of a point from a geometry. More...
double | OGR_G_GetY (OGRGeometryH, int)
| Fetch the x coordinate of a point from a geometry. More...
double | OGR_G_GetZ (OGRGeometryH, int)
| Fetch the z coordinate of a point from a geometry. More...
double | OGR_G_GetM (OGRGeometryH, int)
| Fetch the m coordinate of a point from a geometry. More...
void | OGR_G_GetPoint (OGRGeometryH, int iPoint, double *, double *, double *)
| Fetch a point in line string or a point geometry. More...
void | OGR_G_GetPointZM (OGRGeometryH, int iPoint, double *, double *, double *, double *)
| Fetch a point in line string or a point geometry. More...
void | OGR_G_SetPointCount (OGRGeometryH hGeom, int nNewPointCount)
| Set number of points in a geometry. More...
void | OGR_G_SetPoint (OGRGeometryH, int iPoint, double, double, double)
| Set the location of a vertex in a point or linestring geometry. More...
void | OGR_G_SetPoint_2D (OGRGeometryH, int iPoint, double, double)
| Set the location of a vertex in a point or linestring geometry. More...
void | OGR_G_SetPointM (OGRGeometryH, int iPoint, double, double, double)
| Set the location of a vertex in a point or linestring geometry. More...
void | OGR_G_SetPointZM (OGRGeometryH, int iPoint, double, double, double, double)
| Set the location of a vertex in a point or linestring geometry. More...
void | OGR_G_AddPoint (OGRGeometryH, double, double, double)
| Add a point to a geometry (line string or point). More...
void | OGR_G_AddPoint_2D (OGRGeometryH, double, double)
| Add a point to a geometry (line string or point). More...
void | OGR_G_AddPointM (OGRGeometryH, double, double, double)
| Add a point to a geometry (line string or point). More...
void | OGR_G_AddPointZM (OGRGeometryH, double, double, double, double)
| Add a point to a geometry (line string or point). More...
void | OGR_G_SetPoints (OGRGeometryH hGeom, int nPointsIn, void *pabyX, int nXStride, void *pabyY, int nYStride, void *pabyZ, int nZStride)
| Assign all points in a point or a line string geometry. More...
void | OGR_G_SetPointsZM (OGRGeometryH hGeom, int nPointsIn, void *pabyX, int nXStride, void *pabyY, int nYStride, void *pabyZ, int nZStride, void *pabyM, int nMStride)
| Assign all points in a point or a line string geometry. More...
int | OGR_G_GetGeometryCount (OGRGeometryH)
| Fetch the number of elements in a geometry or number of geometries in container. More...
OGRGeometryH | OGR_G_GetGeometryRef (OGRGeometryH, int)
| Fetch geometry from a geometry container. More...
OGRErr | OGR_G_AddGeometry (OGRGeometryH, OGRGeometryH)
| Add a geometry to a geometry container. More...
OGRErr | OGR_G_AddGeometryDirectly (OGRGeometryH, OGRGeometryH)
| Add a geometry directly to an existing geometry container. More...
OGRErr | OGR_G_RemoveGeometry (OGRGeometryH, int, int)
| Remove a geometry from an exiting geometry container. More...
int | OGR_G_HasCurveGeometry (OGRGeometryH, int bLookForNonLinear)
| Returns if this geometry is or has curve geometry. More...
OGRGeometryH | OGR_G_GetLinearGeometry (OGRGeometryH hGeom, double dfMaxAngleStepSizeDegrees, char **papszOptions) CPL_WARN_UNUSED_RESULT
| Return, possibly approximate, linear version of this geometry. More...
OGRGeometryH | OGR_G_GetCurveGeometry (OGRGeometryH hGeom, char **papszOptions) CPL_WARN_UNUSED_RESULT
| Return curve version of this geometry. More...
OGRGeometryH | OGRBuildPolygonFromEdges (OGRGeometryH hLinesAsCollection, int bBestEffort, int bAutoClose, double dfTolerance, OGRErr *peErr) CPL_WARN_UNUSED_RESULT
| Build a ring from a bunch of arcs. More...
void | OGRSetNonLinearGeometriesEnabledFlag (int bFlag)
| Set flag to enable/disable returning non-linear geometries in the C API. More...
int | OGRGetNonLinearGeometriesEnabledFlag (void)
| Get flag to enable/disable returning non-linear geometries in the C API. More...
OGRFieldDefnH | OGR_Fld_Create (const char *, OGRFieldType) CPL_WARN_UNUSED_RESULT
| Create a new field definition. More...
void | OGR_Fld_Destroy (OGRFieldDefnH)
| Destroy a field definition. More...
void | OGR_Fld_SetName (OGRFieldDefnH, const char *)
| Reset the name of this field. More...
const char * | OGR_Fld_GetNameRef (OGRFieldDefnH)
| Fetch name of this field. More...
OGRFieldType | OGR_Fld_GetType (OGRFieldDefnH)
| Fetch type of this field. More...
void | OGR_Fld_SetType (OGRFieldDefnH, OGRFieldType)
| Set the type of this field. More...
OGRFieldSubType | OGR_Fld_GetSubType (OGRFieldDefnH)
| Fetch subtype of this field. More...
void | OGR_Fld_SetSubType (OGRFieldDefnH, OGRFieldSubType)
| Set the subtype of this field. More...
OGRJustification | OGR_Fld_GetJustify (OGRFieldDefnH)
| Get the justification for this field. More...
void | OGR_Fld_SetJustify (OGRFieldDefnH, OGRJustification)
| Set the justification for this field. More...
int | OGR_Fld_GetWidth (OGRFieldDefnH)
| Get the formatting width for this field. More...
void | OGR_Fld_SetWidth (OGRFieldDefnH, int)
| Set the formatting width for this field in characters. More...
int | OGR_Fld_GetPrecision (OGRFieldDefnH)
| Get the formatting precision for this field. More...
void | OGR_Fld_SetPrecision (OGRFieldDefnH, int)
| Set the formatting precision for this field in characters. More...
void | OGR_Fld_Set (OGRFieldDefnH, const char *, OGRFieldType, int, int, OGRJustification)
| Set defining parameters for a field in one call. More...
int | OGR_Fld_IsIgnored (OGRFieldDefnH hDefn)
| Return whether this field should be omitted when fetching features. More...
void | OGR_Fld_SetIgnored (OGRFieldDefnH hDefn, int)
| Set whether this field should be omitted when fetching features. More...
int | OGR_Fld_IsNullable (OGRFieldDefnH hDefn)
| Return whether this field can receive null values. More...
void | OGR_Fld_SetNullable (OGRFieldDefnH hDefn, int)
| Set whether this field can receive null values. More...
const char * | OGR_Fld_GetDefault (OGRFieldDefnH hDefn)
| Get default field value. More...
void | OGR_Fld_SetDefault (OGRFieldDefnH hDefn, const char *)
| Set default field value. More...
int | OGR_Fld_IsDefaultDriverSpecific (OGRFieldDefnH hDefn)
| Returns whether the default value is driver specific. More...
const char * | OGR_GetFieldTypeName (OGRFieldType)
| Fetch human readable name for a field type. More...
const char * | OGR_GetFieldSubTypeName (OGRFieldSubType)
| Fetch human readable name for a field subtype. More...
int | OGR_AreTypeSubTypeCompatible (OGRFieldType eType, OGRFieldSubType eSubType)
| Return if type and subtype are compatible. More...
OGRGeomFieldDefnH | OGR_GFld_Create (const char *, OGRwkbGeometryType) CPL_WARN_UNUSED_RESULT
| Create a new field geometry definition. More...
void | OGR_GFld_Destroy (OGRGeomFieldDefnH)
| Destroy a geometry field definition. More...
void | OGR_GFld_SetName (OGRGeomFieldDefnH, const char *)
| Reset the name of this field. More...
const char * | OGR_GFld_GetNameRef (OGRGeomFieldDefnH)
| Fetch name of this field. More...
OGRwkbGeometryType | OGR_GFld_GetType (OGRGeomFieldDefnH)
| Fetch geometry type of this field. More...
void | OGR_GFld_SetType (OGRGeomFieldDefnH, OGRwkbGeometryType)
| Set the geometry type of this field. More...
OGRSpatialReferenceH | OGR_GFld_GetSpatialRef (OGRGeomFieldDefnH)
| Fetch spatial reference system of this field. More...
void | OGR_GFld_SetSpatialRef (OGRGeomFieldDefnH, OGRSpatialReferenceH hSRS)
| Set the spatial reference of this field. More...
int | OGR_GFld_IsNullable (OGRGeomFieldDefnH hDefn)
| Return whether this geometry field can receive null values. More...
void | OGR_GFld_SetNullable (OGRGeomFieldDefnH hDefn, int)
| Set whether this geometry field can receive null values. More...
int | OGR_GFld_IsIgnored (OGRGeomFieldDefnH hDefn)
| Return whether this field should be omitted when fetching features. More...
void | OGR_GFld_SetIgnored (OGRGeomFieldDefnH hDefn, int)
| Set whether this field should be omitted when fetching features. More...
OGRFeatureDefnH | OGR_FD_Create (const char *) CPL_WARN_UNUSED_RESULT
| Create a new feature definition object to hold the field definitions. More...
void | OGR_FD_Destroy (OGRFeatureDefnH)
| Destroy a feature definition object and release all memory associated with it. More...
void | OGR_FD_Release (OGRFeatureDefnH)
| Drop a reference, and destroy if unreferenced. More...
const char * | OGR_FD_GetName (OGRFeatureDefnH)
| Get name of the OGRFeatureDefn passed as an argument. More...
int | OGR_FD_GetFieldCount (OGRFeatureDefnH)
| Fetch number of fields on the passed feature definition. More...
OGRFieldDefnH | OGR_FD_GetFieldDefn (OGRFeatureDefnH, int)
| Fetch field definition of the passed feature definition. More...
int | OGR_FD_GetFieldIndex (OGRFeatureDefnH, const char *)
| Find field by name. More...
void | OGR_FD_AddFieldDefn (OGRFeatureDefnH, OGRFieldDefnH)
| Add a new field definition to the passed feature definition. More...
OGRErr | OGR_FD_DeleteFieldDefn (OGRFeatureDefnH hDefn, int iField)
| Delete an existing field definition. More...
OGRErr | OGR_FD_ReorderFieldDefns (OGRFeatureDefnH hDefn, int *panMap)
| Reorder the field definitions in the array of the feature definition. More...
OGRwkbGeometryType | OGR_FD_GetGeomType (OGRFeatureDefnH)
| Fetch the geometry base type of the passed feature definition. More...
void | OGR_FD_SetGeomType (OGRFeatureDefnH, OGRwkbGeometryType)
| Assign the base geometry type for the passed layer (the same as the feature definition). More...
int | OGR_FD_IsGeometryIgnored (OGRFeatureDefnH)
| Determine whether the geometry can be omitted when fetching features. More...
void | OGR_FD_SetGeometryIgnored (OGRFeatureDefnH, int)
| Set whether the geometry can be omitted when fetching features. More...
int | OGR_FD_IsStyleIgnored (OGRFeatureDefnH)
| Determine whether the style can be omitted when fetching features. More...
void | OGR_FD_SetStyleIgnored (OGRFeatureDefnH, int)
| Set whether the style can be omitted when fetching features. More...
int | OGR_FD_Reference (OGRFeatureDefnH)
| Increments the reference count by one. More...
int | OGR_FD_Dereference (OGRFeatureDefnH)
| Decrements the reference count by one. More...
int | OGR_FD_GetReferenceCount (OGRFeatureDefnH)
| Fetch current reference count. More...
int | OGR_FD_GetGeomFieldCount (OGRFeatureDefnH hFDefn)
| Fetch number of geometry fields on the passed feature definition. More...
OGRGeomFieldDefnH | OGR_FD_GetGeomFieldDefn (OGRFeatureDefnH hFDefn, int i)
| Fetch geometry field definition of the passed feature definition. More...
int | OGR_FD_GetGeomFieldIndex (OGRFeatureDefnH hFDefn, const char *pszName)
| Find geometry field by name. More...
void | OGR_FD_AddGeomFieldDefn (OGRFeatureDefnH hFDefn, OGRGeomFieldDefnH hGFldDefn)
| Add a new field definition to the passed feature definition. More...
OGRErr | OGR_FD_DeleteGeomFieldDefn (OGRFeatureDefnH hFDefn, int iGeomField)
| Delete an existing geometry field definition. More...
int | OGR_FD_IsSame (OGRFeatureDefnH hFDefn, OGRFeatureDefnH hOtherFDefn)
| Test if the feature definition is identical to the other one. More...
OGRFeatureH | OGR_F_Create (OGRFeatureDefnH) CPL_WARN_UNUSED_RESULT
| Feature factory. More...
void | OGR_F_Destroy (OGRFeatureH)
| Destroy feature. More...
OGRFeatureDefnH | OGR_F_GetDefnRef (OGRFeatureH)
| Fetch feature definition. More...
OGRErr | OGR_F_SetGeometryDirectly (OGRFeatureH, OGRGeometryH)
| Set feature geometry. More...
OGRErr | OGR_F_SetGeometry (OGRFeatureH, OGRGeometryH)
| Set feature geometry. More...
OGRGeometryH | OGR_F_GetGeometryRef (OGRFeatureH)
| Fetch an handle to feature geometry. More...
OGRGeometryH | OGR_F_StealGeometry (OGRFeatureH) CPL_WARN_UNUSED_RESULT
| Take away ownership of geometry. More...
OGRFeatureH | OGR_F_Clone (OGRFeatureH) CPL_WARN_UNUSED_RESULT
| Duplicate feature. More...
int | OGR_F_Equal (OGRFeatureH, OGRFeatureH)
| Test if two features are the same. More...
int | OGR_F_GetFieldCount (OGRFeatureH)
| Fetch number of fields on this feature This will always be the same as the field count for the OGRFeatureDefn. More...
OGRFieldDefnH | OGR_F_GetFieldDefnRef (OGRFeatureH, int)
| Fetch definition for this field. More...
int | OGR_F_GetFieldIndex (OGRFeatureH, const char *)
| Fetch the field index given field name. More...
int | OGR_F_IsFieldSet (OGRFeatureH, int)
| Test if a field has ever been assigned a value or not. More...
void | OGR_F_UnsetField (OGRFeatureH, int)
| Clear a field, marking it as unset. More...
int | OGR_F_IsFieldNull (OGRFeatureH, int)
| Test if a field is null. More...
int | OGR_F_IsFieldSetAndNotNull (OGRFeatureH, int)
| Test if a field is set and not null. More...
void | OGR_F_SetFieldNull (OGRFeatureH, int)
| Clear a field, marking it as null. More...
OGRField * | OGR_F_GetRawFieldRef (OGRFeatureH, int)
| Fetch an handle to the internal field value given the index. More...
int | OGR_RawField_IsUnset (const OGRField *)
| Returns whether a raw field is unset. More...
int | OGR_RawField_IsNull (const OGRField *)
| Returns whether a raw field is null. More...
void | OGR_RawField_SetUnset (OGRField *)
| Mark a raw field as unset. More...
void | OGR_RawField_SetNull (OGRField *)
| Mark a raw field as null. More...
int | OGR_F_GetFieldAsInteger (OGRFeatureH, int)
| Fetch field value as integer. More...
GIntBig | OGR_F_GetFieldAsInteger64 (OGRFeatureH, int)
| Fetch field value as integer 64 bit. More...
double | OGR_F_GetFieldAsDouble (OGRFeatureH, int)
| Fetch field value as a double. More...
const char * | OGR_F_GetFieldAsString (OGRFeatureH, int)
| Fetch field value as a string. More...
const int * | OGR_F_GetFieldAsIntegerList (OGRFeatureH, int, int *)
| Fetch field value as a list of integers. More...
const GIntBig * | OGR_F_GetFieldAsInteger64List (OGRFeatureH, int, int *)
| Fetch field value as a list of 64 bit integers. More...
const double * | OGR_F_GetFieldAsDoubleList (OGRFeatureH, int, int *)
| Fetch field value as a list of doubles. More...
char ** | OGR_F_GetFieldAsStringList (OGRFeatureH, int)
| Fetch field value as a list of strings. More...
GByte * | OGR_F_GetFieldAsBinary (OGRFeatureH, int, int *)
| Fetch field value as binary. More...
int | OGR_F_GetFieldAsDateTime (OGRFeatureH, int, int *, int *, int *, int *, int *, int *, int *)
| Fetch field value as date and time. More...
int | OGR_F_GetFieldAsDateTimeEx (OGRFeatureH hFeat, int iField, int *pnYear, int *pnMonth, int *pnDay, int *pnHour, int *pnMinute, float *pfSecond, int *pnTZFlag)
| Fetch field value as date and time. More...
void | OGR_F_SetFieldInteger (OGRFeatureH, int, int)
| Set field to integer value. More...
void | OGR_F_SetFieldInteger64 (OGRFeatureH, int, GIntBig)
| Set field to 64 bit integer value. More...
void | OGR_F_SetFieldDouble (OGRFeatureH, int, double)
| Set field to double value. More...
void | OGR_F_SetFieldString (OGRFeatureH, int, const char *)
| Set field to string value. More...
void | OGR_F_SetFieldIntegerList (OGRFeatureH, int, int, int *)
| Set field to list of integers value. More...
void | OGR_F_SetFieldInteger64List (OGRFeatureH, int, int, const GIntBig *)
| Set field to list of 64 bit integers value. More...
void | OGR_F_SetFieldDoubleList (OGRFeatureH, int, int, double *)
| Set field to list of doubles value. More...
void | OGR_F_SetFieldStringList (OGRFeatureH, int, char **)
| Set field to list of strings value. More...
void | OGR_F_SetFieldRaw (OGRFeatureH, int, OGRField *)
| Set field. More...
void | OGR_F_SetFieldBinary (OGRFeatureH, int, int, GByte *)
| Set field to binary data. More...
void | OGR_F_SetFieldDateTime (OGRFeatureH, int, int, int, int, int, int, int, int)
| Set field to datetime. More...
void | OGR_F_SetFieldDateTimeEx (OGRFeatureH, int, int, int, int, int, int, float, int)
| Set field to datetime. More...
int | OGR_F_GetGeomFieldCount (OGRFeatureH hFeat)
| Fetch number of geometry fields on this feature This will always be the same as the geometry field count for the OGRFeatureDefn. More...
OGRGeomFieldDefnH | OGR_F_GetGeomFieldDefnRef (OGRFeatureH hFeat, int iField)
| Fetch definition for this geometry field. More...
int | OGR_F_GetGeomFieldIndex (OGRFeatureH hFeat, const char *pszName)
| Fetch the geometry field index given geometry field name. More...
OGRGeometryH | OGR_F_GetGeomFieldRef (OGRFeatureH hFeat, int iField)
| Fetch an handle to feature geometry. More...
OGRErr | OGR_F_SetGeomFieldDirectly (OGRFeatureH hFeat, int iField, OGRGeometryH hGeom)
| Set feature geometry of a specified geometry field. More...
OGRErr | OGR_F_SetGeomField (OGRFeatureH hFeat, int iField, OGRGeometryH hGeom)
| Set feature geometry of a specified geometry field. More...
GIntBig | OGR_F_GetFID (OGRFeatureH)
| Get feature identifier. More...
OGRErr | OGR_F_SetFID (OGRFeatureH, GIntBig)
| Set the feature identifier. More...
void | OGR_F_DumpReadable (OGRFeatureH, FILE *)
| Dump this feature in a human readable form. More...
OGRErr | OGR_F_SetFrom (OGRFeatureH, OGRFeatureH, int)
| Set one feature from another. More...
OGRErr | OGR_F_SetFromWithMap (OGRFeatureH, OGRFeatureH, int, int *)
| Set one feature from another. More...
const char * | OGR_F_GetStyleString (OGRFeatureH)
| Fetch style string for this feature. More...
void | OGR_F_SetStyleString (OGRFeatureH, const char *)
| Set feature style string. More...
void | OGR_F_SetStyleStringDirectly (OGRFeatureH, char *)
| Set feature style string. More...
OGRStyleTableH | OGR_F_GetStyleTable (OGRFeatureH)
| Return style table.
void | OGR_F_SetStyleTableDirectly (OGRFeatureH, OGRStyleTableH)
| Set style table and take ownership.
void | OGR_F_SetStyleTable (OGRFeatureH, OGRStyleTableH)
| Set style table.
const char * | OGR_F_GetNativeData (OGRFeatureH)
| Returns the native data for the feature. More...
void | OGR_F_SetNativeData (OGRFeatureH, const char *)
| Sets the native data for the feature. More...
const char * | OGR_F_GetNativeMediaType (OGRFeatureH)
| Returns the native media type for the feature. More...
void | OGR_F_SetNativeMediaType (OGRFeatureH, const char *)
| Sets the native media type for the feature. More...
void | OGR_F_FillUnsetWithDefault (OGRFeatureH hFeat, int bNotNullableOnly, char **papszOptions)
| Fill unset fields with default values that might be defined. More...
int | OGR_F_Validate (OGRFeatureH, int nValidateFlags, int bEmitError)
| Validate that a feature meets constraints of its schema. More...
const char * | OGR_L_GetName (OGRLayerH)
| Return the layer name. More...
OGRwkbGeometryType | OGR_L_GetGeomType (OGRLayerH)
| Return the layer geometry type. More...
OGRGeometryH | OGR_L_GetSpatialFilter (OGRLayerH)
| This function returns the current spatial filter for this layer. More...
void | OGR_L_SetSpatialFilter (OGRLayerH, OGRGeometryH)
| Set a new spatial filter. More...
void | OGR_L_SetSpatialFilterRect (OGRLayerH, double, double, double, double)
| Set a new rectangular spatial filter. More...
void | OGR_L_SetSpatialFilterEx (OGRLayerH, int iGeomField, OGRGeometryH hGeom)
| Set a new spatial filter. More...
void | OGR_L_SetSpatialFilterRectEx (OGRLayerH, int iGeomField, double dfMinX, double dfMinY, double dfMaxX, double dfMaxY)
| Set a new rectangular spatial filter. More...
OGRErr | OGR_L_SetAttributeFilter (OGRLayerH, const char *)
| Set a new attribute query. More...
void | OGR_L_ResetReading (OGRLayerH)
| Reset feature reading to start on the first feature. More...
OGRFeatureH | OGR_L_GetNextFeature (OGRLayerH) CPL_WARN_UNUSED_RESULT
| Fetch the next available feature from this layer. More...
OGRErr | OGR_L_SetNextByIndex (OGRLayerH, GIntBig)
| Move read cursor to the nIndex'th feature in the current resultset. More...
OGRFeatureH | OGR_L_GetFeature (OGRLayerH, GIntBig) CPL_WARN_UNUSED_RESULT
| Fetch a feature by its identifier. More...
OGRErr | OGR_L_SetFeature (OGRLayerH, OGRFeatureH) CPL_WARN_UNUSED_RESULT
| Rewrite an existing feature. More...
OGRErr | OGR_L_CreateFeature (OGRLayerH, OGRFeatureH) CPL_WARN_UNUSED_RESULT
| Create and write a new feature within a layer. More...
OGRErr | OGR_L_DeleteFeature (OGRLayerH, GIntBig) CPL_WARN_UNUSED_RESULT
| Delete feature from layer. More...
OGRFeatureDefnH | OGR_L_GetLayerDefn (OGRLayerH)
| Fetch the schema information for this layer. More...
OGRSpatialReferenceH | OGR_L_GetSpatialRef (OGRLayerH)
| Fetch the spatial reference system for this layer. More...
int | OGR_L_FindFieldIndex (OGRLayerH, const char *, int bExactMatch)
| Find the index of field in a layer. More...
GIntBig | OGR_L_GetFeatureCount (OGRLayerH, int)
| Fetch the feature count in this layer. More...
OGRErr | OGR_L_GetExtent (OGRLayerH, OGREnvelope *, int)
| Fetch the extent of this layer. More...
OGRErr | OGR_L_GetExtentEx (OGRLayerH, int iGeomField, OGREnvelope *psExtent, int bForce)
| Fetch the extent of this layer, on the specified geometry field. More...
int | OGR_L_TestCapability (OGRLayerH, const char *)
| Test if this layer supported the named capability. More...
OGRErr | OGR_L_CreateField (OGRLayerH, OGRFieldDefnH, int)
| Create a new field on a layer. More...
OGRErr | OGR_L_CreateGeomField (OGRLayerH hLayer, OGRGeomFieldDefnH hFieldDefn, int bForce)
| Create a new geometry field on a layer. More...
OGRErr | OGR_L_DeleteField (OGRLayerH, int iField)
| Delete an existing field on a layer. More...
OGRErr | OGR_L_ReorderFields (OGRLayerH, int *panMap)
| Reorder all the fields of a layer. More...
OGRErr | OGR_L_ReorderField (OGRLayerH, int iOldFieldPos, int iNewFieldPos)
| Reorder an existing field on a layer. More...
OGRErr | OGR_L_AlterFieldDefn (OGRLayerH, int iField, OGRFieldDefnH hNewFieldDefn, int nFlags)
| Alter the definition of an existing field on a layer. More...
OGRErr | OGR_L_StartTransaction (OGRLayerH) CPL_WARN_UNUSED_RESULT
| For datasources which support transactions, StartTransaction creates a transaction. More...
OGRErr | OGR_L_CommitTransaction (OGRLayerH) CPL_WARN_UNUSED_RESULT
| For datasources which support transactions, CommitTransaction commits a transaction. More...
OGRErr | OGR_L_RollbackTransaction (OGRLayerH)
| For datasources which support transactions, RollbackTransaction will roll back a datasource to its state before the start of the current transaction. More...
OGRErr | OGR_L_SyncToDisk (OGRLayerH)
| Flush pending changes to disk. More...
const char * | OGR_L_GetFIDColumn (OGRLayerH)
| This method returns the name of the underlying database column being used as the FID column, or "" if not supported. More...
const char * | OGR_L_GetGeometryColumn (OGRLayerH)
| This method returns the name of the underlying database column being used as the geometry column, or "" if not supported. More...
OGRStyleTableH | OGR_L_GetStyleTable (OGRLayerH)
| Get style table.
void | OGR_L_SetStyleTableDirectly (OGRLayerH, OGRStyleTableH)
| Set style table (and take ownership)
void | OGR_L_SetStyleTable (OGRLayerH, OGRStyleTableH)
| Set style table.
OGRErr | OGR_L_SetIgnoredFields (OGRLayerH, const char **)
| Set which fields can be omitted when retrieving features from the layer. More...
OGRErr | OGR_L_Intersection (OGRLayerH, OGRLayerH, OGRLayerH, char **, GDALProgressFunc, void *)
| Intersection of two layers. More...
OGRErr | OGR_L_Union (OGRLayerH, OGRLayerH, OGRLayerH, char **, GDALProgressFunc, void *)
| Union of two layers. More...
OGRErr | OGR_L_SymDifference (OGRLayerH, OGRLayerH, OGRLayerH, char **, GDALProgressFunc, void *)
| Symmetrical difference of two layers. More...
OGRErr | OGR_L_Identity (OGRLayerH, OGRLayerH, OGRLayerH, char **, GDALProgressFunc, void *)
| Identify the features of this layer with the ones from the identity layer. More...
OGRErr | OGR_L_Update (OGRLayerH, OGRLayerH, OGRLayerH, char **, GDALProgressFunc, void *)
| Update this layer with features from the update layer. More...
OGRErr | OGR_L_Clip (OGRLayerH, OGRLayerH, OGRLayerH, char **, GDALProgressFunc, void *)
| Clip off areas that are not covered by the method layer. More...
OGRErr | OGR_L_Erase (OGRLayerH, OGRLayerH, OGRLayerH, char **, GDALProgressFunc, void *)
| Remove areas that are covered by the method layer. More...
void | OGR_DS_Destroy (OGRDataSourceH)
| Closes opened datasource and releases allocated resources. More...
const char * | OGR_DS_GetName (OGRDataSourceH)
| Returns the name of the data source. More...
int | OGR_DS_GetLayerCount (OGRDataSourceH)
| Get the number of layers in this data source. More...
OGRLayerH | OGR_DS_GetLayer (OGRDataSourceH, int)
| Fetch a layer by index. More...
OGRLayerH | OGR_DS_GetLayerByName (OGRDataSourceH, const char *)
| Fetch a layer by name. More...
OGRErr | OGR_DS_DeleteLayer (OGRDataSourceH, int)
| Delete the indicated layer from the datasource. More...
OGRSFDriverH | OGR_DS_GetDriver (OGRDataSourceH)
| Returns the driver that the dataset was opened with. More...
OGRLayerH | OGR_DS_CreateLayer (OGRDataSourceH, const char *, OGRSpatialReferenceH, OGRwkbGeometryType, char **)
| This function attempts to create a new layer on the data source with the indicated name, coordinate system, geometry type. More...
OGRLayerH | OGR_DS_CopyLayer (OGRDataSourceH, OGRLayerH, const char *, char **)
| Duplicate an existing layer. More...
int | OGR_DS_TestCapability (OGRDataSourceH, const char *)
| Test if capability is available. More...
OGRLayerH | OGR_DS_ExecuteSQL (OGRDataSourceH, const char *, OGRGeometryH, const char *)
| Execute an SQL statement against the data store. More...
void | OGR_DS_ReleaseResultSet (OGRDataSourceH, OGRLayerH)
| Release results of OGR_DS_ExecuteSQL(). More...
OGRErr | OGR_DS_SyncToDisk (OGRDataSourceH)
| Flush pending changes to disk. More...
OGRStyleTableH | OGR_DS_GetStyleTable (OGRDataSourceH)
| Get style table.
void | OGR_DS_SetStyleTableDirectly (OGRDataSourceH, OGRStyleTableH)
| Set style table (and take ownership)
void | OGR_DS_SetStyleTable (OGRDataSourceH, OGRStyleTableH)
| Set style table.
const char * | OGR_Dr_GetName (OGRSFDriverH)
| Fetch name of driver (file format). More...
OGRDataSourceH | OGR_Dr_Open (OGRSFDriverH, const char *, int) CPL_WARN_UNUSED_RESULT
| Attempt to open file with this driver. More...
int | OGR_Dr_TestCapability (OGRSFDriverH, const char *)
| Test if capability is available. More...
OGRDataSourceH | OGR_Dr_CreateDataSource (OGRSFDriverH, const char *, char **) CPL_WARN_UNUSED_RESULT
| This function attempts to create a new data source based on the passed driver. More...
OGRDataSourceH | OGR_Dr_CopyDataSource (OGRSFDriverH, OGRDataSourceH, const char *, char **) CPL_WARN_UNUSED_RESULT
| This function creates a new datasource by copying all the layers from the source datasource. More...
OGRErr | OGR_Dr_DeleteDataSource (OGRSFDriverH, const char *)
| Delete a datasource. More...
OGRDataSourceH | OGROpen (const char *, int, OGRSFDriverH *) CPL_WARN_UNUSED_RESULT
| Open a file / data source with one of the registered drivers. More...
OGRDataSourceH | OGROpenShared (const char *, int, OGRSFDriverH *) CPL_WARN_UNUSED_RESULT
| Open a file / data source with one of the registered drivers if not already opened, or increment reference count of already opened data source previously opened with OGROpenShared() More...
OGRErr | OGRReleaseDataSource (OGRDataSourceH)
| Drop a reference to this datasource, and if the reference count drops to zero close (destroy) the datasource. More...
int | OGRGetDriverCount (void)
| Fetch the number of registered drivers. More...
OGRSFDriverH | OGRGetDriver (int)
| Fetch the indicated driver. More...
OGRSFDriverH | OGRGetDriverByName (const char *)
| Fetch the indicated driver. More...
void | OGRRegisterAll (void)
| Register all drivers. More...
void | OGRCleanupAll (void)
| Clean-up all drivers (including raster ones starting with GDAL 2.0. More...
OGRStyleMgrH | OGR_SM_Create (OGRStyleTableH hStyleTable) CPL_WARN_UNUSED_RESULT
| OGRStyleMgr factory. More...
void | OGR_SM_Destroy (OGRStyleMgrH hSM)
| Destroy Style Manager. More...
const char * | OGR_SM_InitFromFeature (OGRStyleMgrH hSM, OGRFeatureH hFeat)
| Initialize style manager from the style string of a feature. More...
int | OGR_SM_InitStyleString (OGRStyleMgrH hSM, const char *pszStyleString)
| Initialize style manager from the style string. More...
int | OGR_SM_GetPartCount (OGRStyleMgrH hSM, const char *pszStyleString)
| Get the number of parts in a style. More...
OGRStyleToolH | OGR_SM_GetPart (OGRStyleMgrH hSM, int nPartId, const char *pszStyleString)
| Fetch a part (style tool) from the current style. More...
int | OGR_SM_AddPart (OGRStyleMgrH hSM, OGRStyleToolH hST)
| Add a part (style tool) to the current style. More...
int | OGR_SM_AddStyle (OGRStyleMgrH hSM, const char *pszStyleName, const char *pszStyleString)
| Add a style to the current style table. More...
OGRStyleToolH | OGR_ST_Create (OGRSTClassId eClassId) CPL_WARN_UNUSED_RESULT
| OGRStyleTool factory. More...
void | OGR_ST_Destroy (OGRStyleToolH hST)
| Destroy Style Tool. More...
OGRSTClassId | OGR_ST_GetType (OGRStyleToolH hST)
| Determine type of Style Tool. More...
OGRSTUnitId | OGR_ST_GetUnit (OGRStyleToolH hST)
| Get Style Tool units. More...
void | OGR_ST_SetUnit (OGRStyleToolH hST, OGRSTUnitId eUnit, double dfGroundPaperScale)
| Set Style Tool units. More...
const char * | OGR_ST_GetParamStr (OGRStyleToolH hST, int eParam, int *bValueIsNull)
| Get Style Tool parameter value as string. More...
int | OGR_ST_GetParamNum (OGRStyleToolH hST, int eParam, int *bValueIsNull)
| Get Style Tool parameter value as an integer. More...
double | OGR_ST_GetParamDbl (OGRStyleToolH hST, int eParam, int *bValueIsNull)
| Get Style Tool parameter value as a double. More...
void | OGR_ST_SetParamStr (OGRStyleToolH hST, int eParam, const char *pszValue)
| Set Style Tool parameter value from a string. More...
void | OGR_ST_SetParamNum (OGRStyleToolH hST, int eParam, int nValue)
| Set Style Tool parameter value from an integer. More...
void | OGR_ST_SetParamDbl (OGRStyleToolH hST, int eParam, double dfValue)
| Set Style Tool parameter value from a double. More...
const char * | OGR_ST_GetStyleString (OGRStyleToolH hST)
| Get the style string for this Style Tool. More...
int | OGR_ST_GetRGBFromString (OGRStyleToolH hST, const char *pszColor, int *pnRed, int *pnGreen, int *pnBlue, int *pnAlpha)
| Return the r,g,b,a components of a color encoded in #RRGGBB[AA] format. More...
OGRStyleTableH | OGR_STBL_Create (void) CPL_WARN_UNUSED_RESULT
| OGRStyleTable factory. More...
void | OGR_STBL_Destroy (OGRStyleTableH hSTBL)
| Destroy Style Table. More...
int | OGR_STBL_AddStyle (OGRStyleTableH hStyleTable, const char *pszName, const char *pszStyleString)
| Add a new style in the table. More...
int | OGR_STBL_SaveStyleTable (OGRStyleTableH hStyleTable, const char *pszFilename)
| Save a style table to a file. More...
int | OGR_STBL_LoadStyleTable (OGRStyleTableH hStyleTable, const char *pszFilename)
| Load a style table from a file. More...
const char * | OGR_STBL_Find (OGRStyleTableH hStyleTable, const char *pszName)
| Get a style string by name. More...
void | OGR_STBL_ResetStyleStringReading (OGRStyleTableH hStyleTable)
| Reset the next style pointer to 0. More...
const char * | OGR_STBL_GetNextStyle (OGRStyleTableH hStyleTable)
| Get the next style string from the table. More...
const char * | OGR_STBL_GetLastStyleName (OGRStyleTableH hStyleTable)
| Get the style name of the last style string fetched with OGR_STBL_GetNextStyle. More...

## Detailed Description

C API and defines for OGRFeature, OGRGeometry, and OGRDataSource related classes.

See also: ogr_geometry.h, ogr_feature.h, ogrsf_frmts.h, ogr_featurestyle.h

## Function Documentation

int OGR_AreTypeSubTypeCompatible | ( | OGRFieldType | eType,
|  | OGRFieldSubType | eSubType
| ) |  |

Return if type and subtype are compatible.

Parameters

  eType | the field type.
  eSubType | the field subtype.

Returns
  TRUE if type and subtype are compatible

Since
  GDAL 2.0

OGRDataSourceH OGR_Dr_CopyDataSource | ( | OGRSFDriverH | hDriver,
|  | OGRDataSourceH | hSrcDS,
|  | const char * | pszNewName,
|  | char ** | papszOptions
| ) |  |

This function creates a new datasource by copying all the layers from the source datasource.

It is important to call OGR_DS_Destroy() when the datasource is no longer used to ensure that all data has been properly flushed to disk.

Deprecated:
  Use GDALCreateCopy() in GDAL 2.0

Parameters

  hDriver | handle to the driver on which data source creation is based.
  hSrcDS | source datasource
  pszNewName | the name for the new data source.
  papszOptions | a StringList of name=value options. Options are driver specific, and driver information can be found at the following url: http://www.gdal.org/ogr_formats.html

Returns
  NULL is returned on failure, or a new OGRDataSource handle on success.

OGRDataSourceH OGR_Dr_CreateDataSource | ( | OGRSFDriverH | hDriver,
|  | const char * | pszName,
|  | char ** | papszOptions
| ) |  |

This function attempts to create a new data source based on the passed driver.

The papszOptions argument can be used to control driver specific creation options. These options are normally documented in the format specific documentation.

It is important to call OGR_DS_Destroy() when the datasource is no longer used to ensure that all data has been properly flushed to disk.

Deprecated:
  Use GDALCreate() in GDAL 2.0

Parameters

  hDriver | handle to the driver on which data source creation is based.
  pszName | the name for the new data source. UTF-8 encoded.
  papszOptions | a StringList of name=value options. Options are driver specific, and driver information can be found at the following url: http://www.gdal.org/ogr_formats.html

Returns
  NULL is returned on failure, or a new OGRDataSource handle on success.

OGRErr OGR_Dr_DeleteDataSource | ( | OGRSFDriverH | hDriver,
|  | const char * | pszDataSource
| ) |  |

Delete a datasource.

Delete (from the disk, in the database, ...) the named datasource. Normally it would be safest if the datasource was not open at the time.

Whether this is a supported operation on this driver case be tested using TestCapability() on ODrCDeleteDataSource.

Deprecated:
  Use GDALDeleteDataset() in GDAL 2

Parameters

  hDriver | handle to the driver on which data source deletion is based.
  pszDataSource | the name of the datasource to delete.

Returns
  OGRERR_NONE on success, and OGRERR_UNSUPPORTED_OPERATION if this is not supported by this driver.

const char * OGR_Dr_GetName | ( | OGRSFDriverH | hDriver | ) |

Fetch name of driver (file format).

This name should be relatively short (10-40 characters), and should reflect the underlying file format. For instance "ESRI Shapefile".

This function is the same as the C++ method OGRSFDriver::GetName().

Parameters

  hDriver | handle to the driver to get the name from.

Returns
  driver name. This is an internal string and should not be modified or freed.

OGRDataSourceH OGR_Dr_Open | ( | OGRSFDriverH | hDriver,
|  | const char * | pszName,
|  | int | bUpdate
| ) |  |

Attempt to open file with this driver.

NOTE: Starting with GDAL 2.0, it is NOT safe to cast the returned handle to OGRDataSource*. If a C++ object is needed, the handle should be cast to GDALDataset*. Similarly, the returned OGRSFDriverH handle should be cast to GDALDriver*, and NOT* OGRSFDriver*.

Deprecated:
  Use GDALOpenEx() in GDAL 2.0

Parameters

  hDriver | handle to the driver that is used to open file.
  pszName | the name of the file, or data source to try and open.
  bUpdate | TRUE if update access is required, otherwise FALSE (the default).

Returns
  NULL on error or if the pass name is not supported by this driver, otherwise an handle to a GDALDataset. This GDALDataset should be closed by deleting the object when it is no longer needed.

int OGR_Dr_TestCapability | ( | OGRSFDriverH | hDriver,
|  | const char * | pszCap
| ) |  |

Test if capability is available.

One of the following data source capability names can be passed into this function, and a TRUE or FALSE value will be returned indicating whether or not the capability is available for this object.

- ODrCCreateDataSource: True if this driver can support creating data sources.

- ODrCDeleteDataSource: True if this driver supports deleting data sources.

The #define macro forms of the capability names should be used in preference to the strings themselves to avoid misspelling.

Deprecated:
  Use GDALGetMetadataItem(hDriver, GDAL_DCAP_CREATE) in GDAL 2.0

Parameters

  hDriver | handle to the driver to test the capability against.
  pszCap | the capability to test.

Returns
  TRUE if capability available otherwise FALSE.

OGRLayerH OGR_DS_CopyLayer | ( | OGRDataSourceH | hDS,
|  | OGRLayerH | hSrcLayer,
|  | const char * | pszNewName,
|  | char ** | papszOptions
| ) |  |

Duplicate an existing layer.

This function creates a new layer, duplicate the field definitions of the source layer and then duplicate each features of the source layer. The papszOptions argument can be used to control driver specific creation options. These options are normally documented in the format specific documentation. The source layer may come from another dataset.

Deprecated:
  Use GDALDatasetCopyLayer() in GDAL 2.0

Parameters

  hDS | handle to the data source where to create the new layer
  hSrcLayer | handle to the source layer.
  pszNewName | the name of the layer to create.
  papszOptions | a StringList of name=value options. Options are driver specific.

Returns
  an handle to the layer, or NULL if an error occurs.

OGRLayerH OGR_DS_CreateLayer | ( | OGRDataSourceH | hDS,
|  | const char * | pszName,
|  | OGRSpatialReferenceH | hSpatialRef,
|  | OGRwkbGeometryType | eType,
|  | char ** | papszOptions
| ) |  |

This function attempts to create a new layer on the data source with the indicated name, coordinate system, geometry type.

The papszOptions argument can be used to control driver specific creation options. These options are normally documented in the format specific documentation.

Deprecated:
  Use GDALDatasetCreateLayer() in GDAL 2.0

Parameters

  hDS | The dataset handle.
  pszName | the name for the new layer. This should ideally not match any existing layer on the datasource.
  hSpatialRef | handle to the coordinate system to use for the new layer, or NULL if no coordinate system is available.
  eType | the geometry type for the layer. Use wkbUnknown if there are no constraints on the types geometry to be written.
  papszOptions | a StringList of name=value options. Options are driver specific, and driver information can be found at the following url: http://www.gdal.org/ogr_formats.html

Returns
  NULL is returned on failure, or a new OGRLayer handle on success.

Example:

1 #include "ogrsf_frmts.h"
2 #include "cpl_string.h"
3
4 ...
5
6 OGRLayerH *hLayer;
7 char **papszOptions;
8
9 if( OGR_DS_TestCapability( hDS, ODsCCreateLayer ) )
10 {
11 ...
12 }
13
14 papszOptions = CSLSetNameValue( papszOptions, "DIM", "2" );
15 hLayer = OGR_DS_CreateLayer( hDS, "NewLayer", NULL, wkbUnknown,
16 papszOptions );
17 CSLDestroy( papszOptions );
18
19 if( hLayer == NULL )
20 {
21 ...
22 }

OGRErr OGR_DS_DeleteLayer | ( | OGRDataSourceH | hDS,
|  | int | iLayer
| ) |  |

Delete the indicated layer from the datasource.

If this method is supported the ODsCDeleteLayer capability will test TRUE on the OGRDataSource.

Deprecated:
  Use GDALDatasetDeleteLayer() in GDAL 2.0

Parameters

  hDS | handle to the datasource
  iLayer | the index of the layer to delete.

Returns
  OGRERR_NONE on success, or OGRERR_UNSUPPORTED_OPERATION if deleting layers is not supported for this datasource.

void OGR_DS_Destroy | ( | OGRDataSourceH | hDataSource | ) |

Closes opened datasource and releases allocated resources.

This method is the same as the C++ method OGRDataSource::DestroyDataSource().

Deprecated:
  Use GDALClose() in GDAL 2.0

Parameters

  hDataSource | handle to allocated datasource object.

OGRLayerH OGR_DS_ExecuteSQL | ( | OGRDataSourceH | hDS,
|  | const char * | pszSQLCommand,
|  | OGRGeometryH | hSpatialFilter,
|  | const char * | pszDialect
| ) |  |

Execute an SQL statement against the data store.

The result of an SQL query is either NULL for statements that are in error, or that have no results set, or an OGRLayer handle representing a results set from the query. Note that this OGRLayer is in addition to the layers in the data store and must be destroyed with OGR_DS_ReleaseResultSet() before the data source is closed (destroyed).

For more information on the SQL dialect supported internally by OGR review the OGR SQL document. Some drivers (i.e. Oracle and PostGIS) pass the SQL directly through to the underlying RDBMS.

Starting with OGR 1.10, the SQLITE dialect can also be used.

Deprecated:
  Use GDALDatasetExecuteSQL() in GDAL 2.0

Parameters

  hDS | handle to the data source on which the SQL query is executed.
  pszSQLCommand | the SQL statement to execute.
  hSpatialFilter | handle to a geometry which represents a spatial filter. Can be NULL.
  pszDialect | allows control of the statement dialect. If set to NULL, the OGR SQL engine will be used, except for RDBMS drivers that will use their dedicated SQL engine, unless OGRSQL is explicitly passed as the dialect. Starting with OGR 1.10, the SQLITE dialect can also be used.

Returns
  an handle to a OGRLayer containing the results of the query. Deallocate with OGR_DS_ReleaseResultSet().

OGRSFDriverH OGR_DS_GetDriver | ( | OGRDataSourceH | hDS | ) |

Returns the driver that the dataset was opened with.

NOTE: Starting with GDAL 2.0, it is NOT safe to cast the returned handle to OGRSFDriver*. If a C++ object is needed, the handle should be cast to GDALDriver*.

Deprecated:
  Use GDALGetDatasetDriver() in GDAL 2.0

Parameters

  hDS | handle to the datasource

Returns
  NULL if driver info is not available, or pointer to a driver owned by the OGRSFDriverManager.

OGRLayerH OGR_DS_GetLayer | ( | OGRDataSourceH | hDS,
|  | int | iLayer
| ) |  |

Fetch a layer by index.

The returned layer remains owned by the OGRDataSource and should not be deleted by the application.

Deprecated:
  Use GDALDatasetGetLayer() in GDAL 2.0

Parameters

  hDS | handle to the data source from which to get the layer.
  iLayer | a layer number between 0 and OGR_DS_GetLayerCount()-1.

Returns
  an handle to the layer, or NULL if iLayer is out of range or an error occurs.

OGRLayerH OGR_DS_GetLayerByName | ( | OGRDataSourceH | hDS,
|  | const char * | pszLayerName
| ) |  |

Fetch a layer by name.

The returned layer remains owned by the OGRDataSource and should not be deleted by the application.

Deprecated:
  Use GDALDatasetGetLayerByName() in GDAL 2.0

Parameters

  hDS | handle to the data source from which to get the layer.
  pszLayerName | Layer the layer name of the layer to fetch.

Returns
  an handle to the layer, or NULL if the layer is not found or an error occurs.

int OGR_DS_GetLayerCount | ( | OGRDataSourceH | hDS | ) |

Get the number of layers in this data source.

Deprecated:
  Use GDALDatasetGetLayerCount() in GDAL 2.0

Parameters

  hDS | handle to the data source from which to get the number of layers.

Returns
  layer count.

const char * OGR_DS_GetName | ( | OGRDataSourceH | hDS | ) |

Returns the name of the data source.

This string should be sufficient to open the data source if passed to the same OGRSFDriver that this data source was opened with, but it need not be exactly the same string that was used to open the data source. Normally this is a filename.

Deprecated:
  Use GDALGetDescription() in GDAL 2.0

Parameters

  hDS | handle to the data source to get the name from.

Returns
  pointer to an internal name string which should not be modified or freed by the caller.

void OGR_DS_ReleaseResultSet | ( | OGRDataSourceH | hDS,
|  | OGRLayerH | hLayer
| ) |  |

Release results of OGR_DS_ExecuteSQL().

This function should only be used to deallocate OGRLayers resulting from an OGR_DS_ExecuteSQL() call on the same OGRDataSource. Failure to deallocate a results set before destroying the OGRDataSource may cause errors.

Deprecated:
  Use GDALDatasetReleaseResultSet() in GDAL 2.0

Parameters

  hDS | an handle to the data source on which was executed an SQL query.
  hLayer | handle to the result of a previous OGR_DS_ExecuteSQL() call.

OGRErr OGR_DS_SyncToDisk | ( | OGRDataSourceH |  | ) |

Flush pending changes to disk.

See GDALDataset::FlushCache()

int OGR_DS_TestCapability | ( | OGRDataSourceH | hDS,
|  | const char * | pszCapability
| ) |  |

Test if capability is available.

One of the following data source capability names can be passed into this function, and a TRUE or FALSE value will be returned indicating whether or not the capability is available for this object.

- ODsCCreateLayer: True if this datasource can create new layers.

- ODsCDeleteLayer: True if this datasource can delete existing layers.

- ODsCCreateGeomFieldAfterCreateLayer: True if the layers of this datasource support CreateGeomField() just after layer creation.

- ODsCCurveGeometries: True if this datasource supports writing curve geometries. (GDAL 2.0). In that case, OLCCurveGeometries must also be declared in layers of that dataset.

The #define macro forms of the capability names should be used in preference to the strings themselves to avoid misspelling.

Deprecated:
  Use GDALDatasetTestCapability() in GDAL 2.0

Parameters

  hDS | handle to the data source against which to test the capability.
  pszCapability | the capability to test.

Returns
  TRUE if capability available otherwise FALSE.

OGRFeatureH OGR_F_Clone | ( | OGRFeatureH | hFeat | ) |

Duplicate feature.

The newly created feature is owned by the caller, and will have it's own reference to the OGRFeatureDefn.

This function is the same as the C++ method OGRFeature::Clone().

Parameters

  hFeat | handle to the feature to clone.

Returns
  an handle to the new feature, exactly matching this feature.

OGRFeatureH OGR_F_Create | ( | OGRFeatureDefnH | hDefn | ) |

Feature factory.

Note that the OGRFeature will increment the reference count of it's defining OGRFeatureDefn. Destruction of the OGRFeatureDefn before destruction of all OGRFeatures that depend on it is likely to result in a crash.

This function is the same as the C++ method OGRFeature::OGRFeature().

Parameters

  hDefn | handle to the feature class (layer) definition to which the feature will adhere.

Returns
  an handle to the new feature object with null fields and no geometry, or, starting with GDAL 2.1, NULL in case out of memory situation.

void OGR_F_Destroy | ( | OGRFeatureH | hFeat | ) |

Destroy feature.

The feature is deleted, but within the context of the GDAL/OGR heap. This is necessary when higher level applications use GDAL/OGR from a DLL and they want to delete a feature created within the DLL. If the delete is done in the calling application the memory will be freed onto the application heap which is inappropriate.

This function is the same as the C++ method OGRFeature::DestroyFeature().

Parameters

  hFeat | handle to the feature to destroy.

void OGR_F_DumpReadable | ( | OGRFeatureH | hFeat,
|  | FILE * | fpOut
| ) |  |

Dump this feature in a human readable form.

This dumps the attributes, and geometry; however, it doesn't definition information (other than field types and names), nor does it report the geometry spatial reference system.

This function is the same as the C++ method OGRFeature::DumpReadable().

Parameters

  hFeat | handle to the feature to dump.
  fpOut | the stream to write to, such as strout.

int OGR_F_Equal | ( | OGRFeatureH | hFeat,
|  | OGRFeatureH | hOtherFeat
| ) |  |

Test if two features are the same.

Two features are considered equal if the share them (handle equality) same OGRFeatureDefn, have the same field values, and the same geometry (as tested by OGR_G_Equal()) as well as the same feature id.

This function is the same as the C++ method OGRFeature::Equal().

Parameters

  hFeat | handle to one of the feature.
  hOtherFeat | handle to the other feature to test this one against.

Returns
  TRUE if they are equal, otherwise FALSE.

void OGR_F_FillUnsetWithDefault | ( | OGRFeatureH | hFeat,
|  | int | bNotNullableOnly,
|  | char ** | papszOptions
| ) |  |

Fill unset fields with default values that might be defined.

This function is the same as the C++ method OGRFeature::FillUnsetWithDefault().

Parameters

  hFeat | handle to the feature.
  bNotNullableOnly | if we should fill only unset fields with a not-null constraint.
  papszOptions | unused currently. Must be set to NULL.

Since
  GDAL 2.0

OGRFeatureDefnH OGR_F_GetDefnRef | ( | OGRFeatureH | hFeat | ) |

Fetch feature definition.

This function is the same as the C++ method OGRFeature::GetDefnRef().

Parameters

  hFeat | handle to the feature to get the feature definition from.

Returns
  an handle to the feature definition object on which feature depends.

GIntBig OGR_F_GetFID | ( | OGRFeatureH | hFeat | ) |

Get feature identifier.

This function is the same as the C++ method OGRFeature::GetFID(). Note: since GDAL 2.0, this method returns a GIntBig (previously a long)

Parameters

  hFeat | handle to the feature from which to get the feature identifier.

Returns
  feature id or OGRNullFID if none has been assigned.

GByte* OGR_F_GetFieldAsBinary | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int * | pnBytes
| ) |  |

Fetch field value as binary.

This method only works for OFTBinary and OFTString fields.

This function is the same as the C++ method OGRFeature::GetFieldAsBinary().

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.
  pnBytes | location to place count of bytes returned.

Returns
  the field value. This list is internal, and should not be modified, or freed. Its lifetime may be very brief.

int OGR_F_GetFieldAsDateTime | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int * | pnYear,
|  | int * | pnMonth,
|  | int * | pnDay,
|  | int * | pnHour,
|  | int * | pnMinute,
|  | int * | pnSecond,
|  | int * | pnTZFlag
| ) |  |

Fetch field value as date and time.

Currently this method only works for OFTDate, OFTTime and OFTDateTime fields.

This function is the same as the C++ method OGRFeature::GetFieldAsDateTime().

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.
  pnYear | (including century)
  pnMonth | (1-12)
  pnDay | (1-31)
  pnHour | (0-23)
  pnMinute | (0-59)
  pnSecond | (0-59)
  pnTZFlag | (0=unknown, 1=localtime, 100=GMT, see data model for details)

Returns
  TRUE on success or FALSE on failure.

See also
  Use OGR_F_GetFieldAsDateTimeEx() for second with millisecond accuracy.

int OGR_F_GetFieldAsDateTimeEx | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int * | pnYear,
|  | int * | pnMonth,
|  | int * | pnDay,
|  | int * | pnHour,
|  | int * | pnMinute,
|  | float * | pfSecond,
|  | int * | pnTZFlag
| ) |  |

Fetch field value as date and time.

Currently this method only works for OFTDate, OFTTime and OFTDateTime fields.

This function is the same as the C++ method OGRFeature::GetFieldAsDateTime().

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.
  pnYear | (including century)
  pnMonth | (1-12)
  pnDay | (1-31)
  pnHour | (0-23)
  pnMinute | (0-59)
  pfSecond | (0-59 with millisecond accuracy)
  pnTZFlag | (0=unknown, 1=localtime, 100=GMT, see data model for details)

Returns
  TRUE on success or FALSE on failure.

Since
  GDAL 2.0

double OGR_F_GetFieldAsDouble | ( | OGRFeatureH | hFeat,
|  | int | iField
| ) |  |

Fetch field value as a double.

OFTString features will be translated using CPLAtof(). OFTInteger fields will be cast to double. Other field types, or errors will result in a return value of zero.

This function is the same as the C++ method OGRFeature::GetFieldAsDouble().

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns
  the field value.

const double* OGR_F_GetFieldAsDoubleList | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int * | pnCount
| ) |  |

Fetch field value as a list of doubles.

Currently this function only works for OFTRealList fields.

This function is the same as the C++ method OGRFeature::GetFieldAsDoubleList().

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.
  pnCount | an integer to put the list count (number of doubles) into.

Returns
  the field value. This list is internal, and should not be modified, or freed. Its lifetime may be very brief. If *pnCount is zero on return the returned pointer may be NULL or non-NULL.

int OGR_F_GetFieldAsInteger | ( | OGRFeatureH | hFeat,
|  | int | iField
| ) |  |

Fetch field value as integer.

OFTString features will be translated using atoi(). OFTReal fields will be cast to integer. Other field types, or errors will result in a return value of zero.

This function is the same as the C++ method OGRFeature::GetFieldAsInteger().

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns
  the field value.

GIntBig OGR_F_GetFieldAsInteger64 | ( | OGRFeatureH | hFeat,
|  | int | iField
| ) |  |

Fetch field value as integer 64 bit.

OFTInteger are promoted to 64 bit. OFTString features will be translated using CPLAtoGIntBig(). OFTReal fields will be cast to integer. Other field types, or errors will result in a return value of zero.

This function is the same as the C++ method OGRFeature::GetFieldAsInteger64().

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns
  the field value.

Since
  GDAL 2.0

const GIntBig* OGR_F_GetFieldAsInteger64List | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int * | pnCount
| ) |  |

Fetch field value as a list of 64 bit integers.

Currently this function only works for OFTInteger64List fields.

This function is the same as the C++ method OGRFeature::GetFieldAsInteger64List().

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.
  pnCount | an integer to put the list count (number of integers) into.

Returns
  the field value. This list is internal, and should not be modified, or freed. Its lifetime may be very brief. If *pnCount is zero on return the returned pointer may be NULL or non-NULL.

Since
  GDAL 2.0

const int* OGR_F_GetFieldAsIntegerList | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int * | pnCount
| ) |  |

Fetch field value as a list of integers.

Currently this function only works for OFTIntegerList fields.

This function is the same as the C++ method OGRFeature::GetFieldAsIntegerList().

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.
  pnCount | an integer to put the list count (number of integers) into.

Returns
  the field value. This list is internal, and should not be modified, or freed. Its lifetime may be very brief. If *pnCount is zero on return the returned pointer may be NULL or non-NULL.

const char* OGR_F_GetFieldAsString | ( | OGRFeatureH | hFeat,
|  | int | iField
| ) |  |

Fetch field value as a string.

OFTReal and OFTInteger fields will be translated to string using sprintf(), but not necessarily using the established formatting rules. Other field types, or errors will result in a return value of zero.

This function is the same as the C++ method OGRFeature::GetFieldAsString().

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns
  the field value. This string is internal, and should not be modified, or freed. Its lifetime may be very brief.

char** OGR_F_GetFieldAsStringList | ( | OGRFeatureH | hFeat,
|  | int | iField
| ) |  |

Fetch field value as a list of strings.

Currently this method only works for OFTStringList fields.

The returned list is terminated by a NULL pointer. The number of elements can also be calculated using CSLCount().

This function is the same as the C++ method OGRFeature::GetFieldAsStringList().

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns
  the field value. This list is internal, and should not be modified, or freed. Its lifetime may be very brief.

int OGR_F_GetFieldCount | ( | OGRFeatureH | hFeat | ) |

Fetch number of fields on this feature This will always be the same as the field count for the OGRFeatureDefn.

This function is the same as the C++ method OGRFeature::GetFieldCount().

Parameters

  hFeat | handle to the feature to get the fields count from.

Returns
  count of fields.

OGRFieldDefnH OGR_F_GetFieldDefnRef | ( | OGRFeatureH | hFeat,
|  | int | i
| ) |  |

Fetch definition for this field.

This function is the same as the C++ method OGRFeature::GetFieldDefnRef().

Parameters

  hFeat | handle to the feature on which the field is found.
  i | the field to fetch, from 0 to GetFieldCount()-1.

Returns
  an handle to the field definition (from the OGRFeatureDefn). This is an internal reference, and should not be deleted or modified.

int OGR_F_GetFieldIndex | ( | OGRFeatureH | hFeat,
|  | const char * | pszName
| ) |  |

Fetch the field index given field name.

This is a cover for the OGRFeatureDefn::GetFieldIndex() method.

This function is the same as the C++ method OGRFeature::GetFieldIndex().

Parameters

  hFeat | handle to the feature on which the field is found.
  pszName | the name of the field to search for.

Returns
  the field index, or -1 if no matching field is found.

OGRGeometryH OGR_F_GetGeometryRef | ( | OGRFeatureH | hFeat | ) |

Fetch an handle to feature geometry.

This function is the same as the C++ method OGRFeature::GetGeometryRef().

Parameters

  hFeat | handle to the feature to get geometry from.

Returns
  an handle to internal feature geometry. This object should not be modified.

int OGR_F_GetGeomFieldCount | ( | OGRFeatureH | hFeat | ) |

Fetch number of geometry fields on this feature This will always be the same as the geometry field count for the OGRFeatureDefn.

This function is the same as the C++ method OGRFeature::GetGeomFieldCount().

Parameters

  hFeat | handle to the feature to get the geometry fields count from.

Returns
  count of geometry fields.

Since
  GDAL 1.11

OGRGeomFieldDefnH OGR_F_GetGeomFieldDefnRef | ( | OGRFeatureH | hFeat,
|  | int | i
| ) |  |

Fetch definition for this geometry field.

This function is the same as the C++ method OGRFeature::GetGeomFieldDefnRef().

Parameters

  hFeat | handle to the feature on which the field is found.
  i | the field to fetch, from 0 to GetGeomFieldCount()-1.

Returns
  an handle to the field definition (from the OGRFeatureDefn). This is an internal reference, and should not be deleted or modified.

Since
  GDAL 1.11

int OGR_F_GetGeomFieldIndex | ( | OGRFeatureH | hFeat,
|  | const char * | pszName
| ) |  |

Fetch the geometry field index given geometry field name.

This is a cover for the OGRFeatureDefn::GetGeomFieldIndex() method.

This function is the same as the C++ method OGRFeature::GetGeomFieldIndex().

Parameters

  hFeat | handle to the feature on which the geometry field is found.
  pszName | the name of the geometry field to search for.

Returns
  the geometry field index, or -1 if no matching geometry field is found.

Since
  GDAL 1.11

OGRGeometryH OGR_F_GetGeomFieldRef | ( | OGRFeatureH | hFeat,
|  | int | iField
| ) |  |

Fetch an handle to feature geometry.

This function is the same as the C++ method OGRFeature::GetGeomFieldRef().

Parameters

  hFeat | handle to the feature to get geometry from.
  iField | geometry field to get.

Returns
  an handle to internal feature geometry. This object should not be modified.

Since
  GDAL 1.11

const char* OGR_F_GetNativeData | ( | OGRFeatureH | hFeat | ) |

Returns the native data for the feature.

The native data is the representation in a "natural" form that comes from the driver that created this feature, or that is aimed at an output driver. The native data may be in different format, which is indicated by OGR_F_GetNativeMediaType().

Note that most drivers do not support storing the native data in the feature object, and if they do, generally the NATIVE_DATA open option must be passed at dataset opening.

The "native data" does not imply it is something more performant or powerful than what can be obtained with the rest of the API, but it may be useful in round-tripping scenarios where some characteristics of the underlying format are not captured otherwise by the OGR abstraction.

This function is the same as the C++ method OGRFeature::GetNativeData().

Parameters

  hFeat | handle to the feature.

Returns
  a string with the native data, or NULL if there is none.

Since
  GDAL 2.1

See also
  https://trac.osgeo.org/gdal/wiki/rfc60_improved_roundtripping_in_ogr

const char* OGR_F_GetNativeMediaType | ( | OGRFeatureH | hFeat | ) |

Returns the native media type for the feature.

The native media type is the identifier for the format of the native data. It follows the IANA RFC 2045 (see https://en.wikipedia.org/wiki/Media_type), e.g. "application/vnd.geo+json" for JSon.

This function is the same as the C function OGR_F_GetNativeMediaType().

Parameters

  hFeat | handle to the feature.

Returns
  a string with the native media type, or NULL if there is none.

Since
  GDAL 2.1

See also
  https://trac.osgeo.org/gdal/wiki/rfc60_improved_roundtripping_in_ogr

OGRField* OGR_F_GetRawFieldRef | ( | OGRFeatureH | hFeat,
|  | int | iField
| ) |  |

Fetch an handle to the internal field value given the index.

This function is the same as the C++ method OGRFeature::GetRawFieldRef().

Parameters

  hFeat | handle to the feature on which field is found.
  iField | the field to fetch, from 0 to GetFieldCount()-1.

Returns
  the returned handle is to an internal data structure, and should not be freed, or modified.

const char* OGR_F_GetStyleString | ( | OGRFeatureH | hFeat | ) |

Fetch style string for this feature.

Set the OGR Feature Style Specification for details on the format of this string, and ogr_featurestyle.h for services available to parse it.

This function is the same as the C++ method OGRFeature::GetStyleString().

Parameters

  hFeat | handle to the feature to get the style from.

Returns
  a reference to a representation in string format, or NULL if there isn't one.

int OGR_F_IsFieldNull | ( | OGRFeatureH | hFeat,
|  | int | iField
| ) |  |

Test if a field is null.

This function is the same as the C++ method OGRFeature::IsFieldNull().

Parameters

  hFeat | handle to the feature on which the field is.
  iField | the field to test.

Returns
  TRUE if the field is null, otherwise false.

Since
  GDAL 2.2

int OGR_F_IsFieldSet | ( | OGRFeatureH | hFeat,
|  | int | iField
| ) |  |

Test if a field has ever been assigned a value or not.

This function is the same as the C++ method OGRFeature::IsFieldSet().

Parameters

  hFeat | handle to the feature on which the field is.
  iField | the field to test.

Returns
  TRUE if the field has been set, otherwise false.

int OGR_F_IsFieldSetAndNotNull | ( | OGRFeatureH | hFeat,
|  | int | iField
| ) |  |

Test if a field is set and not null.

This function is the same as the C++ method OGRFeature::IsFieldSetAndNotNull().

Parameters

  hFeat | handle to the feature on which the field is.
  iField | the field to test.

Returns
  TRUE if the field is set and not null, otherwise false.

Since
  GDAL 2.2

OGRErr OGR_F_SetFID | ( | OGRFeatureH | hFeat,
|  | GIntBig | nFID
| ) |  |

Set the feature identifier.

For specific types of features this operation may fail on illegal features ids. Generally it always succeeds. Feature ids should be greater than or equal to zero, with the exception of OGRNullFID (-1) indicating that the feature id is unknown.

This function is the same as the C++ method OGRFeature::SetFID().

Parameters

  hFeat | handle to the feature to set the feature id to.
  nFID | the new feature identifier value to assign.

Returns
  On success OGRERR_NONE, or on failure some other value.

void OGR_F_SetFieldBinary | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int | nBytes,
|  | GByte * | pabyData
| ) |  |

Set field to binary data.

This function currently on has an effect of OFTBinary fields.

This function is the same as the C++ method OGRFeature::SetField().

Note
  This method has only an effect on the in-memory feature object. If this object comes from a layer and the modifications must be serialized back to the datasource, OGR_L_SetFeature() must be used afterwards. Or if this is a new feature, OGR_L_CreateFeature() must be used afterwards.

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to set, from 0 to GetFieldCount()-1.
  nBytes | the number of bytes in pabyData array.
  pabyData | the data to apply.

void OGR_F_SetFieldDateTime | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int | nYear,
|  | int | nMonth,
|  | int | nDay,
|  | int | nHour,
|  | int | nMinute,
|  | int | nSecond,
|  | int | nTZFlag
| ) |  |

Set field to datetime.

This method currently only has an effect for OFTDate, OFTTime and OFTDateTime fields.

Note
  This method has only an effect on the in-memory feature object. If this object comes from a layer and the modifications must be serialized back to the datasource, OGR_L_SetFeature() must be used afterwards. Or if this is a new feature, OGR_L_CreateFeature() must be used afterwards.

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to set, from 0 to GetFieldCount()-1.
  nYear | (including century)
  nMonth | (1-12)
  nDay | (1-31)
  nHour | (0-23)
  nMinute | (0-59)
  nSecond | (0-59)
  nTZFlag | (0=unknown, 1=localtime, 100=GMT, see data model for details)

See also
  Use OGR_F_SetFieldDateTimeEx() for second with millisecond accuracy.

void OGR_F_SetFieldDateTimeEx | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int | nYear,
|  | int | nMonth,
|  | int | nDay,
|  | int | nHour,
|  | int | nMinute,
|  | float | fSecond,
|  | int | nTZFlag
| ) |  |

Set field to datetime.

This method currently only has an effect for OFTDate, OFTTime and OFTDateTime fields.

Note
  This method has only an effect on the in-memory feature object. If this object comes from a layer and the modifications must be serialized back to the datasource, OGR_L_SetFeature() must be used afterwards. Or if this is a new feature, OGR_L_CreateFeature() must be used afterwards.

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to set, from 0 to GetFieldCount()-1.
  nYear | (including century)
  nMonth | (1-12)
  nDay | (1-31)
  nHour | (0-23)
  nMinute | (0-59)
  fSecond | (0-59, with millisecond accuracy)
  nTZFlag | (0=unknown, 1=localtime, 100=GMT, see data model for details)

Since
  GDAL 2.0

void OGR_F_SetFieldDouble | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | double | dfValue
| ) |  |

Set field to double value.

OFTInteger, OFTInteger64 and OFTReal fields will be set directly. OFTString fields will be assigned a string representation of the value, but not necessarily taking into account formatting constraints on this field. Other field types may be unaffected.

This function is the same as the C++ method OGRFeature::SetField().

Note
  This method has only an effect on the in-memory feature object. If this object comes from a layer and the modifications must be serialized back to the datasource, OGR_L_SetFeature() must be used afterwards. Or if this is a new feature, OGR_L_CreateFeature() must be used afterwards.

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.
  dfValue | the value to assign.

void OGR_F_SetFieldDoubleList | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int | nCount,
|  | double * | padfValues
| ) |  |

Set field to list of doubles value.

This function currently on has an effect of OFTIntegerList, OFTInteger64List, OFTRealList fields.

This function is the same as the C++ method OGRFeature::SetField().

Note
  This method has only an effect on the in-memory feature object. If this object comes from a layer and the modifications must be serialized back to the datasource, OGR_L_SetFeature() must be used afterwards. Or if this is a new feature, OGR_L_CreateFeature() must be used afterwards.

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to set, from 0 to GetFieldCount()-1.
  nCount | the number of values in the list being assigned.
  padfValues | the values to assign.

void OGR_F_SetFieldInteger | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int | nValue
| ) |  |

Set field to integer value.

OFTInteger, OFTInteger64 and OFTReal fields will be set directly. OFTString fields will be assigned a string representation of the value, but not necessarily taking into account formatting constraints on this field. Other field types may be unaffected.

This function is the same as the C++ method OGRFeature::SetField().

Note
  This method has only an effect on the in-memory feature object. If this object comes from a layer and the modifications must be serialized back to the datasource, OGR_L_SetFeature() must be used afterwards. Or if this is a new feature, OGR_L_CreateFeature() must be used afterwards.

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.
  nValue | the value to assign.

void OGR_F_SetFieldInteger64 | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | GIntBig | nValue
| ) |  |

Set field to 64 bit integer value.

OFTInteger, OFTInteger64 and OFTReal fields will be set directly. OFTString fields will be assigned a string representation of the value, but not necessarily taking into account formatting constraints on this field. Other field types may be unaffected.

This function is the same as the C++ method OGRFeature::SetField().

Note
  This method has only an effect on the in-memory feature object. If this object comes from a layer and the modifications must be serialized back to the datasource, OGR_L_SetFeature() must be used afterwards. Or if this is a new feature, OGR_L_CreateFeature() must be used afterwards.

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.
  nValue | the value to assign.

Since
  GDAL 2.0

void OGR_F_SetFieldInteger64List | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int | nCount,
|  | const GIntBig * | panValues
| ) |  |

Set field to list of 64 bit integers value.

This function currently on has an effect of OFTIntegerList, OFTInteger64List and OFTRealList fields.

This function is the same as the C++ method OGRFeature::SetField().

Note
  This method has only an effect on the in-memory feature object. If this object comes from a layer and the modifications must be serialized back to the datasource, OGR_L_SetFeature() must be used afterwards. Or if this is a new feature, OGR_L_CreateFeature() must be used afterwards.

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to set, from 0 to GetFieldCount()-1.
  nCount | the number of values in the list being assigned.
  panValues | the values to assign.

Since
  GDAL 2.0

void OGR_F_SetFieldIntegerList | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | int | nCount,
|  | int * | panValues
| ) |  |

Set field to list of integers value.

This function currently on has an effect of OFTIntegerList, OFTInteger64List and OFTRealList fields.

This function is the same as the C++ method OGRFeature::SetField().

Note
  This method has only an effect on the in-memory feature object. If this object comes from a layer and the modifications must be serialized back to the datasource, OGR_L_SetFeature() must be used afterwards. Or if this is a new feature, OGR_L_CreateFeature() must be used afterwards.

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to set, from 0 to GetFieldCount()-1.
  nCount | the number of values in the list being assigned.
  panValues | the values to assign.

void OGR_F_SetFieldNull | ( | OGRFeatureH | hFeat,
|  | int | iField
| ) |  |

Clear a field, marking it as null.

This function is the same as the C++ method OGRFeature::SetFieldNull().

Parameters

  hFeat | handle to the feature on which the field is.
  iField | the field to set to null.

Since
  GDAL 2.2

void OGR_F_SetFieldRaw | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | OGRField * | psValue
| ) |  |

Set field.

The passed value OGRField must be of exactly the same type as the target field, or an application crash may occur. The passed value is copied, and will not be affected. It remains the responsibility of the caller.

This function is the same as the C++ method OGRFeature::SetField().

Note
  This method has only an effect on the in-memory feature object. If this object comes from a layer and the modifications must be serialized back to the datasource, OGR_L_SetFeature() must be used afterwards. Or if this is a new feature, OGR_L_CreateFeature() must be used afterwards.

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.
  psValue | handle on the value to assign.

void OGR_F_SetFieldString | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | const char * | pszValue
| ) |  |

Set field to string value.

OFTInteger fields will be set based on an atoi() conversion of the string. OFTInteger64 fields will be set based on an CPLAtoGIntBig() conversion of the string. OFTReal fields will be set based on an CPLAtof() conversion of the string. Other field types may be unaffected.

This function is the same as the C++ method OGRFeature::SetField().

Note
  This method has only an effect on the in-memory feature object. If this object comes from a layer and the modifications must be serialized back to the datasource, OGR_L_SetFeature() must be used afterwards. Or if this is a new feature, OGR_L_CreateFeature() must be used afterwards.

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to fetch, from 0 to GetFieldCount()-1.
  pszValue | the value to assign.

void OGR_F_SetFieldStringList | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | char ** | papszValues
| ) |  |

Set field to list of strings value.

This function currently on has an effect of OFTStringList fields.

This function is the same as the C++ method OGRFeature::SetField().

Note
  This method has only an effect on the in-memory feature object. If this object comes from a layer and the modifications must be serialized back to the datasource, OGR_L_SetFeature() must be used afterwards. Or if this is a new feature, OGR_L_CreateFeature() must be used afterwards.

Parameters

  hFeat | handle to the feature that owned the field.
  iField | the field to set, from 0 to GetFieldCount()-1.
  papszValues | the values to assign.

OGRErr OGR_F_SetFrom | ( | OGRFeatureH | hFeat,
|  | OGRFeatureH | hOtherFeat,
|  | int | bForgiving
| ) |  |

Set one feature from another.

Overwrite the contents of this feature from the geometry and attributes of another. The hOtherFeature does not need to have the same OGRFeatureDefn. Field values are copied by corresponding field names. Field types do not have to exactly match. OGR_F_SetField*() function conversion rules will be applied as needed.

This function is the same as the C++ method OGRFeature::SetFrom().

Parameters

  hFeat | handle to the feature to set to.
  hOtherFeat | handle to the feature from which geometry, and field values will be copied.
  bForgiving | TRUE if the operation should continue despite lacking output fields matching some of the source fields.

Returns
  OGRERR_NONE if the operation succeeds, even if some values are not transferred, otherwise an error code.

OGRErr OGR_F_SetFromWithMap | ( | OGRFeatureH | hFeat,
|  | OGRFeatureH | hOtherFeat,
|  | int | bForgiving,
|  | int * | panMap
| ) |  |

Set one feature from another.

Overwrite the contents of this feature from the geometry and attributes of another. The hOtherFeature does not need to have the same OGRFeatureDefn. Field values are copied according to the provided indices map. Field types do not have to exactly match. OGR_F_SetField*() function conversion rules will be applied as needed. This is more efficient than OGR_F_SetFrom() in that this doesn't lookup the fields by their names. Particularly useful when the field names don't match.

This function is the same as the C++ method OGRFeature::SetFrom().

Parameters

  hFeat | handle to the feature to set to.
  hOtherFeat | handle to the feature from which geometry, and field values will be copied.
  panMap | Array of the indices of the destination feature's fields stored at the corresponding index of the source feature's fields. A value of -1 should be used to ignore the source's field. The array should not be NULL and be as long as the number of fields in the source feature.
  bForgiving | TRUE if the operation should continue despite lacking output fields matching some of the source fields.

Returns
  OGRERR_NONE if the operation succeeds, even if some values are not transferred, otherwise an error code.

OGRErr OGR_F_SetGeometry | ( | OGRFeatureH | hFeat,
|  | OGRGeometryH | hGeom
| ) |  |

Set feature geometry.

This function updates the features geometry, and operate exactly as SetGeometryDirectly(), except that this function does not assume ownership of the passed geometry, but instead makes a copy of it.

This function is the same as the C++ OGRFeature::SetGeometry().

Note
  This method has only an effect on the in-memory feature object. If this object comes from a layer and the modifications must be serialized back to the datasource, OGR_L_SetFeature() must be used afterwards. Or if this is a new feature, OGR_L_CreateFeature() must be used afterwards.

Parameters

  hFeat | handle to the feature on which new geometry is applied to.
  hGeom | handle to the new geometry to apply to feature.

Returns
  OGRERR_NONE if successful, or OGR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the OGRFeatureDefn (checking not yet implemented).

OGRErr OGR_F_SetGeometryDirectly | ( | OGRFeatureH | hFeat,
|  | OGRGeometryH | hGeom
| ) |  |

Set feature geometry.

This function updates the features geometry, and operate exactly as SetGeometry(), except that this function assumes ownership of the passed geometry (even in case of failure of that function).

This function is the same as the C++ method OGRFeature::SetGeometryDirectly.

Note
  This method has only an effect on the in-memory feature object. If this object comes from a layer and the modifications must be serialized back to the datasource, OGR_L_SetFeature() must be used afterwards. Or if this is a new feature, OGR_L_CreateFeature() must be used afterwards.

Parameters

  hFeat | handle to the feature on which to apply the geometry.
  hGeom | handle to the new geometry to apply to feature.

Returns
  OGRERR_NONE if successful, or OGR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the OGRFeatureDefn (checking not yet implemented).

OGRErr OGR_F_SetGeomField | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | OGRGeometryH | hGeom
| ) |  |

Set feature geometry of a specified geometry field.

This function updates the features geometry, and operate exactly as SetGeometryDirectly(), except that this function does not assume ownership of the passed geometry, but instead makes a copy of it.

This function is the same as the C++ OGRFeature::SetGeomField().

Parameters

  hFeat | handle to the feature on which new geometry is applied to.
  iField | geometry field to set.
  hGeom | handle to the new geometry to apply to feature.

Returns
  OGRERR_NONE if successful, or OGR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the OGRFeatureDefn (checking not yet implemented).

OGRErr OGR_F_SetGeomFieldDirectly | ( | OGRFeatureH | hFeat,
|  | int | iField,
|  | OGRGeometryH | hGeom
| ) |  |

Set feature geometry of a specified geometry field.

This function updates the features geometry, and operate exactly as SetGeomField(), except that this function assumes ownership of the passed geometry (even in case of failure of that function).

This function is the same as the C++ method OGRFeature::SetGeomFieldDirectly.

Parameters

  hFeat | handle to the feature on which to apply the geometry.
  iField | geometry field to set.
  hGeom | handle to the new geometry to apply to feature.

Returns
  OGRERR_NONE if successful, or OGRERR_FAILURE if the index is invalid, or OGR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the OGRFeatureDefn (checking not yet implemented).

Since
  GDAL 1.11

void OGR_F_SetNativeData | ( | OGRFeatureH | hFeat,
|  | const char * | pszNativeData
| ) |  |

Sets the native data for the feature.

The native data is the representation in a "natural" form that comes from the driver that created this feature, or that is aimed at an output driver. The native data may be in different format, which is indicated by OGR_F_GetNativeMediaType().

This function is the same as the C++ method OGRFeature::SetNativeData().

Parameters

  hFeat | handle to the feature.
  pszNativeData | a string with the native data, or NULL if there is none.

Since
  GDAL 2.1

See also
  https://trac.osgeo.org/gdal/wiki/rfc60_improved_roundtripping_in_ogr

void OGR_F_SetNativeMediaType | ( | OGRFeatureH | hFeat,
|  | const char * | pszNativeMediaType
| ) |  |

Sets the native media type for the feature.

The native media type is the identifier for the format of the native data. It follows the IANA RFC 2045 (see https://en.wikipedia.org/wiki/Media_type), e.g. "application/vnd.geo+json" for JSon.

This function is the same as the C++ method OGRFeature::SetNativeMediaType().

Parameters

  hFeat | handle to the feature.
  pszNativeMediaType | a string with the native media type, or NULL if there is none.

Since
  GDAL 2.1

See also
  https://trac.osgeo.org/gdal/wiki/rfc60_improved_roundtripping_in_ogr

void OGR_F_SetStyleString | ( | OGRFeatureH | hFeat,
|  | const char * | pszStyle
| ) |  |

Set feature style string.

This method operate exactly as OGR_F_SetStyleStringDirectly() except that it does not assume ownership of the passed string, but instead makes a copy of it.

This function is the same as the C++ method OGRFeature::SetStyleString().

Parameters

  hFeat | handle to the feature to set style to.
  pszStyle | the style string to apply to this feature, cannot be NULL.

void OGR_F_SetStyleStringDirectly | ( | OGRFeatureH | hFeat,
|  | char * | pszStyle
| ) |  |

Set feature style string.

This method operate exactly as OGR_F_SetStyleString() except that it assumes ownership of the passed string.

This function is the same as the C++ method OGRFeature::SetStyleStringDirectly().

Parameters

  hFeat | handle to the feature to set style to.
  pszStyle | the style string to apply to this feature, cannot be NULL.

OGRGeometryH OGR_F_StealGeometry | ( | OGRFeatureH | hFeat | ) |

Take away ownership of geometry.

Fetch the geometry from this feature, and clear the reference to the geometry on the feature. This is a mechanism for the application to take over ownership of the geometry from the feature without copying. Sort of an inverse to OGR_FSetGeometryDirectly().

After this call the OGRFeature will have a NULL geometry.

Returns
  the pointer to the geometry.

void OGR_F_UnsetField | ( | OGRFeatureH | hFeat,
|  | int | iField
| ) |  |

Clear a field, marking it as unset.

This function is the same as the C++ method OGRFeature::UnsetField().

Parameters

  hFeat | handle to the feature on which the field is.
  iField | the field to unset.

int OGR_F_Validate | ( | OGRFeatureH | hFeat,
|  | int | nValidateFlags,
|  | int | bEmitError
| ) |  |

Validate that a feature meets constraints of its schema.

The scope of test is specified with the nValidateFlags parameter.

Regarding OGR_F_VAL_WIDTH, the test is done assuming the string width must be interpreted as the number of UTF-8 characters. Some drivers might interpret the width as the number of bytes instead. So this test is rather conservative (if it fails, then it will fail for all interpretations).

This function is the same as the C++ method OGRFeature::Validate().

Parameters

  hFeat | handle to the feature to validate.
  nValidateFlags | OGR_F_VAL_ALL or combination of OGR_F_VAL_NULL, OGR_F_VAL_GEOM_TYPE, OGR_F_VAL_WIDTH and OGR_F_VAL_ALLOW_NULL_WHEN_DEFAULT with '|' operator
  bEmitError | TRUE if a CPLError() must be emitted when a check fails

Returns
  TRUE if all enabled validation tests pass.

Since
  GDAL 2.0

void OGR_FD_AddFieldDefn | ( | OGRFeatureDefnH | hDefn,
|  | OGRFieldDefnH | hNewField
| ) |  |

Add a new field definition to the passed feature definition.

To add a new field definition to a layer definition, do not use this function directly, but use OGR_L_CreateField() instead.

This function should only be called while there are no OGRFeature objects in existence based on this OGRFeatureDefn. The OGRFieldDefn passed in is copied, and remains the responsibility of the caller.

This function is the same as the C++ method OGRFeatureDefn::AddFieldDefn().

Parameters

  hDefn | handle to the feature definition to add the field definition to.
  hNewField | handle to the new field definition.

void OGR_FD_AddGeomFieldDefn | ( | OGRFeatureDefnH | hDefn,
|  | OGRGeomFieldDefnH | hNewGeomField
| ) |  |

Add a new field definition to the passed feature definition.

To add a new field definition to a layer definition, do not use this function directly, but use OGR_L_CreateGeomField() instead.

This function should only be called while there are no OGRFeature objects in existence based on this OGRFeatureDefn. The OGRGeomFieldDefn passed in is copied, and remains the responsibility of the caller.

This function is the same as the C++ method OGRFeatureDefn::AddGeomFieldDefn().

Parameters

  hDefn | handle to the feature definition to add the geometry field definition to.
  hNewGeomField | handle to the new field definition.

Since
  GDAL 1.11

OGRFeatureDefnH OGR_FD_Create | ( | const char * | pszName | ) |

Create a new feature definition object to hold the field definitions.

The OGRFeatureDefn maintains a reference count, but this starts at zero, and should normally be incremented by the owner.

This function is the same as the C++ method OGRFeatureDefn::OGRFeatureDefn().

Parameters

  pszName | the name to be assigned to this layer/class. It does not need to be unique.

Returns
  handle to the newly created feature definition.

OGRErr OGR_FD_DeleteFieldDefn | ( | OGRFeatureDefnH | hDefn,
|  | int | iField
| ) |  |

Delete an existing field definition.

To delete an existing field definition from a layer definition, do not use this function directly, but use OGR_L_DeleteField() instead.

This method should only be called while there are no OGRFeature objects in existence based on this OGRFeatureDefn.

This method is the same as the C++ method OGRFeatureDefn::DeleteFieldDefn().

Parameters

  hDefn | handle to the feature definition.
  iField | the index of the field definition.

Returns
  OGRERR_NONE in case of success.

Since
  OGR 1.9.0

OGRErr OGR_FD_DeleteGeomFieldDefn | ( | OGRFeatureDefnH | hDefn,
|  | int | iGeomField
| ) |  |

Delete an existing geometry field definition.

To delete an existing geometry field definition from a layer definition, do not use this function directly, but use OGR_L_DeleteGeomField() instead (not implemented yet).

This method should only be called while there are no OGRFeature objects in existence based on this OGRFeatureDefn.

This method is the same as the C++ method OGRFeatureDefn::DeleteGeomFieldDefn().

Parameters

  hDefn | handle to the feature definition.
  iGeomField | the index of the geometry field definition.

Returns
  OGRERR_NONE in case of success.

Since
  GDAL 1.11

int OGR_FD_Dereference | ( | OGRFeatureDefnH | hDefn | ) |

Decrements the reference count by one.

This function is the same as the C++ method OGRFeatureDefn::Dereference().

Parameters

  hDefn | handle to the feature definition on witch OGRFeature are based on.

Returns
  the updated reference count.

void OGR_FD_Destroy | ( | OGRFeatureDefnH | hDefn | ) |

Destroy a feature definition object and release all memory associated with it.

This function is the same as the C++ method OGRFeatureDefn::~OGRFeatureDefn().

Parameters

  hDefn | handle to the feature definition to be destroyed.

int OGR_FD_GetFieldCount | ( | OGRFeatureDefnH | hDefn | ) |

Fetch number of fields on the passed feature definition.

This function is the same as the C++ OGRFeatureDefn::GetFieldCount().

Parameters

  hDefn | handle to the feature definition to get the fields count from.

Returns
  count of fields.

OGRFieldDefnH OGR_FD_GetFieldDefn | ( | OGRFeatureDefnH | hDefn,
|  | int | iField
| ) |  |

Fetch field definition of the passed feature definition.

This function is the same as the C++ method OGRFeatureDefn::GetFieldDefn().

Starting with GDAL 1.7.0, this method will also issue an error if the index is not valid.

Parameters

  hDefn | handle to the feature definition to get the field definition from.
  iField | the field to fetch, between 0 and GetFieldCount()-1.

Returns
  an handle to an internal field definition object or NULL if invalid index. This object should not be modified or freed by the application.

int OGR_FD_GetFieldIndex | ( | OGRFeatureDefnH | hDefn,
|  | const char * | pszFieldName
| ) |  |

Find field by name.

The field index of the first field matching the passed field name (case insensitively) is returned.

This function is the same as the C++ method OGRFeatureDefn::GetFieldIndex.

Parameters

  hDefn | handle to the feature definition to get field index from.
  pszFieldName | the field name to search for.

Returns
  the field index, or -1 if no match found.

int OGR_FD_GetGeomFieldCount | ( | OGRFeatureDefnH | hDefn | ) |

Fetch number of geometry fields on the passed feature definition.

This function is the same as the C++ OGRFeatureDefn::GetGeomFieldCount().

Parameters

  hDefn | handle to the feature definition to get the fields count from.

Returns
  count of geometry fields.

Since
  GDAL 1.11

OGRGeomFieldDefnH OGR_FD_GetGeomFieldDefn | ( | OGRFeatureDefnH | hDefn,
|  | int | iGeomField
| ) |  |

Fetch geometry field definition of the passed feature definition.

This function is the same as the C++ method OGRFeatureDefn::GetGeomFieldDefn().

Parameters

  hDefn | handle to the feature definition to get the field definition from.
  iGeomField | the geometry field to fetch, between 0 and GetGeomFieldCount() - 1.

Returns
  an handle to an internal field definition object or NULL if invalid index. This object should not be modified or freed by the application.

Since
  GDAL 1.11

int OGR_FD_GetGeomFieldIndex | ( | OGRFeatureDefnH | hDefn,
|  | const char * | pszGeomFieldName
| ) |  |

Find geometry field by name.

The geometry field index of the first geometry field matching the passed field name (case insensitively) is returned.

This function is the same as the C++ method OGRFeatureDefn::GetGeomFieldIndex.

Parameters

  hDefn | handle to the feature definition to get field index from.
  pszGeomFieldName | the geometry field name to search for.

Returns
  the geometry field index, or -1 if no match found.

OGRwkbGeometryType OGR_FD_GetGeomType | ( | OGRFeatureDefnH | hDefn | ) |

Fetch the geometry base type of the passed feature definition.

This function is the same as the C++ method OGRFeatureDefn::GetGeomType().

Starting with GDAL 1.11, this method returns GetGeomFieldDefn(0)->GetType().

Parameters

  hDefn | handle to the feature definition to get the geometry type from.

Returns
  the base type for all geometry related to this definition.

const char* OGR_FD_GetName | ( | OGRFeatureDefnH | hDefn | ) |

Get name of the OGRFeatureDefn passed as an argument.

This function is the same as the C++ method OGRFeatureDefn::GetName().

Parameters

  hDefn | handle to the feature definition to get the name from.

Returns
  the name. This name is internal and should not be modified, or freed.

int OGR_FD_GetReferenceCount | ( | OGRFeatureDefnH | hDefn | ) |

Fetch current reference count.

This function is the same as the C++ method OGRFeatureDefn::GetReferenceCount().

Parameters

  hDefn | handle to the feature definition on witch OGRFeature are based on.

Returns
  the current reference count.

int OGR_FD_IsGeometryIgnored | ( | OGRFeatureDefnH | hDefn | ) |

Determine whether the geometry can be omitted when fetching features.

This function is the same as the C++ method OGRFeatureDefn::IsGeometryIgnored().

Starting with GDAL 1.11, this method returns GetGeomFieldDefn(0)->IsIgnored().

Parameters

  hDefn | handle to the feature definition on witch OGRFeature are based on.

Returns
  ignore state

int OGR_FD_IsSame | ( | OGRFeatureDefnH | hFDefn,
|  | OGRFeatureDefnH | hOtherFDefn
| ) |  |

Test if the feature definition is identical to the other one.

Parameters

  hFDefn | handle to the feature definition on witch OGRFeature are based on.
  hOtherFDefn | handle to the other feature definition to compare to.

Returns
  TRUE if the feature definition is identical to the other one.

Since
  OGR 1.11

int OGR_FD_IsStyleIgnored | ( | OGRFeatureDefnH | hDefn | ) |

Determine whether the style can be omitted when fetching features.

This function is the same as the C++ method OGRFeatureDefn::IsStyleIgnored().

Parameters

  hDefn | handle to the feature definition on which OGRFeature are based on.

Returns
  ignore state

int OGR_FD_Reference | ( | OGRFeatureDefnH | hDefn | ) |

Increments the reference count by one.

The reference count is used keep track of the number of OGRFeature objects referencing this definition.

This function is the same as the C++ method OGRFeatureDefn::Reference().

Parameters

  hDefn | handle to the feature definition on witch OGRFeature are based on.

Returns
  the updated reference count.

void OGR_FD_Release | ( | OGRFeatureDefnH | hDefn | ) |

Drop a reference, and destroy if unreferenced.

This function is the same as the C++ method OGRFeatureDefn::Release().

Parameters

  hDefn | handle to the feature definition to be released.

OGRErr OGR_FD_ReorderFieldDefns | ( | OGRFeatureDefnH | hDefn,
|  | int * | panMap
| ) |  |

Reorder the field definitions in the array of the feature definition.

To reorder the field definitions in a layer definition, do not use this function directly, but use OGR_L_ReorderFields() instead.

This method should only be called while there are no OGRFeature objects in existence based on this OGRFeatureDefn.

This method is the same as the C++ method OGRFeatureDefn::ReorderFieldDefns().

Parameters

  hDefn | handle to the feature definition.
  panMap | an array of GetFieldCount() elements which is a permutation of [0, GetFieldCount()-1]. panMap is such that, for each field definition at position i after reordering, its position before reordering was panMap[i].

Returns
  OGRERR_NONE in case of success.

Since
  OGR 2.1.0

void OGR_FD_SetGeometryIgnored | ( | OGRFeatureDefnH | hDefn,
|  | int | bIgnore
| ) |  |

Set whether the geometry can be omitted when fetching features.

This function is the same as the C++ method OGRFeatureDefn::SetGeometryIgnored().

Starting with GDAL 1.11, this method calls GetGeomFieldDefn(0)->SetIgnored().

Parameters

  hDefn | handle to the feature definition on witch OGRFeature are based on.
  bIgnore | ignore state

void OGR_FD_SetGeomType | ( | OGRFeatureDefnH | hDefn,
|  | OGRwkbGeometryType | eType
| ) |  |

Assign the base geometry type for the passed layer (the same as the feature definition).

All geometry objects using this type must be of the defined type or a derived type. The default upon creation is wkbUnknown which allows for any geometry type. The geometry type should generally not be changed after any OGRFeatures have been created against this definition.

This function is the same as the C++ method OGRFeatureDefn::SetGeomType().

Starting with GDAL 1.11, this method calls GetGeomFieldDefn(0)->SetType().

Parameters

  hDefn | handle to the layer or feature definition to set the geometry type to.
  eType | the new type to assign.

void OGR_FD_SetStyleIgnored | ( | OGRFeatureDefnH | hDefn,
|  | int | bIgnore
| ) |  |

Set whether the style can be omitted when fetching features.

This function is the same as the C++ method OGRFeatureDefn::SetStyleIgnored().

Parameters

  hDefn | handle to the feature definition on witch OGRFeature are based on.
  bIgnore | ignore state

OGRFieldDefnH OGR_Fld_Create | ( | const char * | pszName,
|  | OGRFieldType | eType
| ) |  |

Create a new field definition.

By default, fields have no width, precision, are nullable and not ignored.

This function is the same as the CPP method OGRFieldDefn::OGRFieldDefn().

Parameters

  pszName | the name of the new field definition.
  eType | the type of the new field definition.

Returns
  handle to the new field definition.

void OGR_Fld_Destroy | ( | OGRFieldDefnH | hDefn | ) |

Destroy a field definition.

Parameters

  hDefn | handle to the field definition to destroy.

const char* OGR_Fld_GetDefault | ( | OGRFieldDefnH | hDefn | ) |

Get default field value.

This function is the same as the C++ method OGRFieldDefn::GetDefault().

Parameters

  hDefn | handle to the field definition.

Returns
  default field value or NULL.

Since
  GDAL 2.0

OGRJustification OGR_Fld_GetJustify | ( | OGRFieldDefnH | hDefn | ) |

Get the justification for this field.

This function is the same as the CPP method OGRFieldDefn::GetJustify().

Note: no driver is know to use the concept of field justification.

Parameters

  hDefn | handle to the field definition to get justification from.

Returns
  the justification.

const char* OGR_Fld_GetNameRef | ( | OGRFieldDefnH | hDefn | ) |

Fetch name of this field.

This function is the same as the CPP method OGRFieldDefn::GetNameRef().

Parameters

  hDefn | handle to the field definition.

Returns
  the name of the field definition.

int OGR_Fld_GetPrecision | ( | OGRFieldDefnH | hDefn | ) |

Get the formatting precision for this field.

This should normally be zero for fields of types other than OFTReal.

This function is the same as the CPP method OGRFieldDefn::GetPrecision().

Parameters

  hDefn | handle to the field definition to get precision from.

Returns
  the precision.

OGRFieldSubType OGR_Fld_GetSubType | ( | OGRFieldDefnH | hDefn | ) |

Fetch subtype of this field.

This function is the same as the CPP method OGRFieldDefn::GetSubType().

Parameters

  hDefn | handle to the field definition to get subtype from.

Returns
  field subtype.

Since
  GDAL 2.0

OGRFieldType OGR_Fld_GetType | ( | OGRFieldDefnH | hDefn | ) |

Fetch type of this field.

This function is the same as the CPP method OGRFieldDefn::GetType().

Parameters

  hDefn | handle to the field definition to get type from.

Returns
  field type.

int OGR_Fld_GetWidth | ( | OGRFieldDefnH | hDefn | ) |

Get the formatting width for this field.

This function is the same as the CPP method OGRFieldDefn::GetWidth().

Parameters

  hDefn | handle to the field definition to get width from.

Returns
  the width, zero means no specified width.

int OGR_Fld_IsDefaultDriverSpecific | ( | OGRFieldDefnH | hDefn | ) |

Returns whether the default value is driver specific.

Driver specific default values are those that are not NULL, a numeric value, a literal value enclosed between single quote characters, CURRENT_TIMESTAMP, CURRENT_TIME, CURRENT_DATE or datetime literal value.

This function is the same as the C++ method OGRFieldDefn::IsDefaultDriverSpecific().

Parameters

  hDefn | handle to the field definition

Returns
  TRUE if the default value is driver specific.

Since
  GDAL 2.0

int OGR_Fld_IsIgnored | ( | OGRFieldDefnH | hDefn | ) |

Return whether this field should be omitted when fetching features.

This method is the same as the C++ method OGRFieldDefn::IsIgnored().

Parameters

  hDefn | handle to the field definition

Returns
  ignore state

int OGR_Fld_IsNullable | ( | OGRFieldDefnH | hDefn | ) |

Return whether this field can receive null values.

By default, fields are nullable.

Even if this method returns FALSE (i.e not-nullable field), it doesn't mean that OGRFeature::IsFieldSet() will necessary return TRUE, as fields can be temporary unset and null/not-null validation is usually done when OGRLayer::CreateFeature()/SetFeature() is called.

This method is the same as the C++ method OGRFieldDefn::IsNullable().

Parameters

  hDefn | handle to the field definition

Returns
  TRUE if the field is authorized to be null.

Since
  GDAL 2.0

void OGR_Fld_Set | ( | OGRFieldDefnH | hDefn,
|  | const char * | pszNameIn,
|  | OGRFieldType | eTypeIn,
|  | int | nWidthIn,
|  | int | nPrecisionIn,
|  | OGRJustification | eJustifyIn
| ) |  |

Set defining parameters for a field in one call.

This function is the same as the CPP method OGRFieldDefn::Set().

Parameters

  hDefn | handle to the field definition to set to.
  pszNameIn | the new name to assign.
  eTypeIn | the new type (one of the OFT values like OFTInteger).
  nWidthIn | the preferred formatting width. Defaults to zero indicating undefined.
  nPrecisionIn | number of decimals places for formatting, defaults to zero indicating undefined.
  eJustifyIn | the formatting justification (OJLeft or OJRight), defaults to OJUndefined.

void OGR_Fld_SetDefault | ( | OGRFieldDefnH | hDefn,
|  | const char * | pszDefault
| ) |  |

Set default field value.

The default field value is taken into account by drivers (generally those with a SQL interface) that support it at field creation time. OGR will generally not automatically set the default field value to null fields by itself when calling OGRFeature::CreateFeature() / OGRFeature::SetFeature(), but will let the low-level layers to do the job. So retrieving the feature from the layer is recommended.

The accepted values are NULL, a numeric value, a literal value enclosed between single quote characters (and inner single quote characters escaped by repetition of the single quote character), CURRENT_TIMESTAMP, CURRENT_TIME, CURRENT_DATE or a driver specific expression (that might be ignored by other drivers). For a datetime literal value, format should be 'YYYY/MM/DD HH:MM:SS[.sss]' (considered as UTC time).

Drivers that support writing DEFAULT clauses will advertize the GDAL_DCAP_DEFAULT_FIELDS driver metadata item.

This function is the same as the C++ method OGRFieldDefn::SetDefault().

Parameters

  hDefn | handle to the field definition.
  pszDefault | new default field value or NULL pointer.

Since
  GDAL 2.0

void OGR_Fld_SetIgnored | ( | OGRFieldDefnH | hDefn,
|  | int | ignore
| ) |  |

Set whether this field should be omitted when fetching features.

This method is the same as the C++ method OGRFieldDefn::SetIgnored().

Parameters

  hDefn | handle to the field definition
  ignore | ignore state

void OGR_Fld_SetJustify | ( | OGRFieldDefnH | hDefn,
|  | OGRJustification | eJustify
| ) |  |

Set the justification for this field.

Note: no driver is know to use the concept of field justification.

This function is the same as the CPP method OGRFieldDefn::SetJustify().

Parameters

  hDefn | handle to the field definition to set justification to.
  eJustify | the new justification.

void OGR_Fld_SetName | ( | OGRFieldDefnH | hDefn,
|  | const char * | pszName
| ) |  |

Reset the name of this field.

This function is the same as the CPP method OGRFieldDefn::SetName().

Parameters

  hDefn | handle to the field definition to apply the new name to.
  pszName | the new name to apply.

void OGR_Fld_SetNullable | ( | OGRFieldDefnH | hDefn,
|  | int | bNullableIn
| ) |  |

Set whether this field can receive null values.

By default, fields are nullable, so this method is generally called with FALSE to set a not-null constraint.

Drivers that support writing not-null constraint will advertize the GDAL_DCAP_NOTNULL_FIELDS driver metadata item.

This method is the same as the C++ method OGRFieldDefn::SetNullable().

Parameters

  hDefn | handle to the field definition
  bNullableIn | FALSE if the field must have a not-null constraint.

Since
  GDAL 2.0

void OGR_Fld_SetPrecision | ( | OGRFieldDefnH | hDefn,
|  | int | nPrecision
| ) |  |

Set the formatting precision for this field in characters.

This should normally be zero for fields of types other than OFTReal.

This function is the same as the CPP method OGRFieldDefn::SetPrecision().

Parameters

  hDefn | handle to the field definition to set precision to.
  nPrecision | the new precision.

void OGR_Fld_SetSubType | ( | OGRFieldDefnH | hDefn,
|  | OGRFieldSubType | eSubType
| ) |  |

Set the subtype of this field.

This should never be done to an OGRFieldDefn that is already part of an OGRFeatureDefn.

This function is the same as the CPP method OGRFieldDefn::SetSubType().

Parameters

  hDefn | handle to the field definition to set type to.
  eSubType | the new field subtype.

Since
  GDAL 2.0

void OGR_Fld_SetType | ( | OGRFieldDefnH | hDefn,
|  | OGRFieldType | eType
| ) |  |

Set the type of this field.

This should never be done to an OGRFieldDefn that is already part of an OGRFeatureDefn.

This function is the same as the CPP method OGRFieldDefn::SetType().

Parameters

  hDefn | handle to the field definition to set type to.
  eType | the new field type.

void OGR_Fld_SetWidth | ( | OGRFieldDefnH | hDefn,
|  | int | nNewWidth
| ) |  |

Set the formatting width for this field in characters.

This function is the same as the CPP method OGRFieldDefn::SetWidth().

Parameters

  hDefn | handle to the field definition to set width to.
  nNewWidth | the new width.

OGRErr OGR_G_AddGeometry | ( | OGRGeometryH | hGeom,
|  | OGRGeometryH | hNewSubGeom
| ) |  |

Add a geometry to a geometry container.

Some subclasses of OGRGeometryCollection restrict the types of geometry that can be added, and may return an error. The passed geometry is cloned to make an internal copy.

There is no SFCOM analog to this method.

This function is the same as the CPP method OGRGeometryCollection::addGeometry.

For a polygon, hNewSubGeom must be a linearring. If the polygon is empty, the first added subgeometry will be the exterior ring. The next ones will be the interior rings.

Parameters

  hGeom | existing geometry container.
  hNewSubGeom | geometry to add to the container.

Returns
  OGRERR_NONE if successful, or OGRERR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the type of existing geometry.

OGRErr OGR_G_AddGeometryDirectly | ( | OGRGeometryH | hGeom,
|  | OGRGeometryH | hNewSubGeom
| ) |  |

Add a geometry directly to an existing geometry container.

Some subclasses of OGRGeometryCollection restrict the types of geometry that can be added, and may return an error. Ownership of the passed geometry is taken by the container rather than cloning as addGeometry() does.

This function is the same as the CPP method OGRGeometryCollection::addGeometryDirectly.

There is no SFCOM analog to this method.

For a polygon, hNewSubGeom must be a linearring. If the polygon is empty, the first added subgeometry will be the exterior ring. The next ones will be the interior rings.

Parameters

  hGeom | existing geometry.
  hNewSubGeom | geometry to add to the existing geometry.

Returns
  OGRERR_NONE if successful, or OGRERR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the type of geometry container.

void OGR_G_AddPoint | ( | OGRGeometryH | hGeom,
|  | double | dfX,
|  | double | dfY,
|  | double | dfZ
| ) |  |

Add a point to a geometry (line string or point).

The vertex count of the line string is increased by one, and assigned from the passed location value.

Parameters

  hGeom | handle to the geometry to add a point to.
  dfX | x coordinate of point to add.
  dfY | y coordinate of point to add.
  dfZ | z coordinate of point to add.

void OGR_G_AddPoint_2D | ( | OGRGeometryH | hGeom,
|  | double | dfX,
|  | double | dfY
| ) |  |

Add a point to a geometry (line string or point).

The vertex count of the line string is increased by one, and assigned from the passed location value.

Parameters

  hGeom | handle to the geometry to add a point to.
  dfX | x coordinate of point to add.
  dfY | y coordinate of point to add.

void OGR_G_AddPointM | ( | OGRGeometryH | hGeom,
|  | double | dfX,
|  | double | dfY,
|  | double | dfM
| ) |  |

Add a point to a geometry (line string or point).

The vertex count of the line string is increased by one, and assigned from the passed location value.

Parameters

  hGeom | handle to the geometry to add a point to.
  dfX | x coordinate of point to add.
  dfY | y coordinate of point to add.
  dfM | m coordinate of point to add.

void OGR_G_AddPointZM | ( | OGRGeometryH | hGeom,
|  | double | dfX,
|  | double | dfY,
|  | double | dfZ,
|  | double | dfM
| ) |  |

Add a point to a geometry (line string or point).

The vertex count of the line string is increased by one, and assigned from the passed location value.

Parameters

  hGeom | handle to the geometry to add a point to.
  dfX | x coordinate of point to add.
  dfY | y coordinate of point to add.
  dfZ | z coordinate of point to add.
  dfM | m coordinate of point to add.

OGRGeometryH OGR_G_ApproximateArcAngles | ( | double | dfCenterX,
|  | double | dfCenterY,
|  | double | dfZ,
|  | double | dfPrimaryRadius,
|  | double | dfSecondaryRadius,
|  | double | dfRotation,
|  | double | dfStartAngle,
|  | double | dfEndAngle,
|  | double | dfMaxAngleStepSizeDegrees
| ) |  |

Stroke arc to linestring.

Stroke an arc of a circle to a linestring based on a center point, radius, start angle and end angle, all angles in degrees.

If the dfMaxAngleStepSizeDegrees is zero, then a default value will be used. This is currently 4 degrees unless the user has overridden the value with the OGR_ARC_STEPSIZE configuration variable.

See also
  CPLSetConfigOption()

Parameters

  dfCenterX | center X
  dfCenterY | center Y
  dfZ | center Z
  dfPrimaryRadius | X radius of ellipse.
  dfSecondaryRadius | Y radius of ellipse.
  dfRotation | rotation of the ellipse clockwise.
  dfStartAngle | angle to first point on arc (clockwise of X-positive)
  dfEndAngle | angle to last point on arc (clockwise of X-positive)
  dfMaxAngleStepSizeDegrees | the largest step in degrees along the arc, zero to use the default setting.

Returns
  OGRLineString geometry representing an approximation of the arc.

Since
  OGR 1.8.0

double OGR_G_Area | ( | OGRGeometryH | hGeom | ) |

Compute geometry area.

Computes the area for an OGRLinearRing, OGRPolygon or OGRMultiPolygon. Undefined for all other geometry types (returns zero).

This function utilizes the C++ get_Area() methods such as OGRPolygon::get_Area().

Parameters

  hGeom | the geometry to operate on.

Returns
  the area or 0.0 for unsupported geometry types.

Since
  OGR 1.8.0

void OGR_G_AssignSpatialReference | ( | OGRGeometryH | hGeom,
|  | OGRSpatialReferenceH | hSRS
| ) |  |

Assign spatial reference to this object.

Any existing spatial reference is replaced, but under no circumstances does this result in the object being reprojected. It is just changing the interpretation of the existing geometry. Note that assigning a spatial reference increments the reference count on the OGRSpatialReference, but does not copy it.

This is similar to the SFCOM IGeometry::put_SpatialReference() method.

This function is the same as the CPP method OGRGeometry::assignSpatialReference.

Parameters

  hGeom | handle on the geometry to apply the new spatial reference system.
  hSRS | handle on the new spatial reference system to apply.

OGRGeometryH OGR_G_Boundary | ( | OGRGeometryH | hTarget | ) |

Compute boundary.

A new geometry object is created and returned containing the boundary of the geometry on which the method is invoked.

This function is the same as the C++ method OGR_G_Boundary().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hTarget | The Geometry to calculate the boundary of.

Returns
  a handle to a newly allocated geometry now owned by the caller, or NULL on failure.

Since
  OGR 1.8.0

OGRGeometryH OGR_G_Buffer | ( | OGRGeometryH | hTarget,
|  | double | dfDist,
|  | int | nQuadSegs
| ) |  |

Compute buffer of geometry.

Builds a new geometry containing the buffer region around the geometry on which it is invoked. The buffer is a polygon containing the region within the buffer distance of the original geometry.

Some buffer sections are properly described as curves, but are converted to approximate polygons. The nQuadSegs parameter can be used to control how many segments should be used to define a 90 degree curve - a quadrant of a circle. A value of 30 is a reasonable default. Large values result in large numbers of vertices in the resulting buffer geometry while small numbers reduce the accuracy of the result.

This function is the same as the C++ method OGRGeometry::Buffer().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hTarget | the geometry.
  dfDist | the buffer distance to be applied. Should be expressed into the same unit as the coordinates of the geometry.
  nQuadSegs | the number of segments used to approximate a 90 degree (quadrant) of curvature.

Returns
  the newly created geometry, or NULL if an error occurs.

int OGR_G_Centroid | ( | OGRGeometryH | hGeom,
|  | OGRGeometryH | hCentroidPoint
| ) |  |

Compute the geometry centroid.

The centroid location is applied to the passed in OGRPoint object. The centroid is not necessarily within the geometry.

This method relates to the SFCOM ISurface::get_Centroid() method however the current implementation based on GEOS can operate on other geometry types such as multipoint, linestring, geometrycollection such as multipolygons. OGC SF SQL 1.1 defines the operation for surfaces (polygons). SQL/MM-Part 3 defines the operation for surfaces and multisurfaces (multipolygons).

This function is the same as the C++ method OGRGeometry::Centroid().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Returns
  OGRERR_NONE on success or OGRERR_FAILURE on error.

OGRGeometryH OGR_G_Clone | ( | OGRGeometryH | hGeom | ) |

Make a copy of this object.

This function relates to the SFCOM IGeometry::clone() method.

This function is the same as the CPP method OGRGeometry::clone().

Parameters

  hGeom | handle on the geometry to clone from.

Returns
  an handle on the copy of the geometry with the spatial reference system as the original.

void OGR_G_CloseRings | ( | OGRGeometryH | hGeom | ) |

Force rings to be closed.

If this geometry, or any contained geometries has polygon rings that are not closed, they will be closed by adding the starting point at the end.

Parameters

  hGeom | handle to the geometry.

int OGR_G_Contains | ( | OGRGeometryH | hThis,
|  | OGRGeometryH | hOther
| ) |  |

Test for containment.

Tests if this geometry contains the other geometry.

This function is the same as the C++ method OGRGeometry::Contains().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hThis | the geometry to compare.
  hOther | the other geometry to compare.

Returns
  TRUE if hThis contains hOther geometry, otherwise FALSE.

OGRGeometryH OGR_G_ConvexHull | ( | OGRGeometryH | hTarget | ) |

Compute convex hull.

A new geometry object is created and returned containing the convex hull of the geometry on which the method is invoked.

This function is the same as the C++ method OGRGeometry::ConvexHull().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hTarget | The Geometry to calculate the convex hull of.

Returns
  a handle to a newly allocated geometry now owned by the caller, or NULL on failure.

int OGR_G_CoordinateDimension | ( | OGRGeometryH | hGeom | ) |

Get the dimension of the coordinates in this geometry.

This function is the same as the CPP method OGRGeometry::CoordinateDimension().

Parameters

  hGeom | handle on the geometry to get the dimension of the coordinates from.

Returns
  this will return 2 for XY, 3 for XYZ and XYM, and 4 for XYZM data.

Since
  GDAL 2.1

OGRErr OGR_G_CreateFromFgf | ( | unsigned char * | pabyData,
|  | OGRSpatialReferenceH | hSRS,
|  | OGRGeometryH * | phGeometry,
|  | int | nBytes,
|  | int * | pnBytesConsumed
| ) |  |

Create a geometry object of the appropriate type from it's FGF (FDO Geometry Format) binary representation.

See OGRGeometryFactory::createFromFgf()

OGRGeometryH OGR_G_CreateFromGML | ( | const char * | pszGML | ) |

Create geometry from GML.

This method translates a fragment of GML containing only the geometry portion into a corresponding OGRGeometry. There are many limitations on the forms of GML geometries supported by this parser, but they are too numerous to list here.

The following GML2 elements are parsed : Point, LineString, Polygon, MultiPoint, MultiLineString, MultiPolygon, MultiGeometry.

(OGR >= 1.8.0) The following GML3 elements are parsed : Surface, MultiSurface, PolygonPatch, Triangle, Rectangle, Curve, MultiCurve, CompositeCurve, LineStringSegment, Arc, Circle, CompositeSurface, OrientableSurface, Solid, Tin, TriangulatedSurface.

Arc and Circle elements are stroked to linestring, by using a 4 degrees step, unless the user has overridden the value with the OGR_ARC_STEPSIZE configuration variable.

The C++ method OGRGeometryFactory::createFromGML() is the same as this function.

Parameters

  pszGML | The GML fragment for the geometry.

Returns
  a geometry on success, or NULL on error.

OGRErr OGR_G_CreateFromWkb | ( | unsigned char * | pabyData,
|  | OGRSpatialReferenceH | hSRS,
|  | OGRGeometryH * | phGeometry,
|  | int | nBytes
| ) |  |

Create a geometry object of the appropriate type from it's well known binary representation.

Note that if nBytes is passed as zero, no checking can be done on whether the pabyData is sufficient. This can result in a crash if the input data is corrupt. This function returns no indication of the number of bytes from the data source actually used to represent the returned geometry object. Use OGR_G_WkbSize() on the returned geometry to establish the number of bytes it required in WKB format.

The OGRGeometryFactory::createFromWkb() CPP method is the same as this function.

Parameters

  pabyData | pointer to the input BLOB data.
  hSRS | handle to the spatial reference to be assigned to the created geometry object. This may be NULL.
  phGeometry | the newly created geometry object will be assigned to the indicated handle on return. This will be NULL in case of failure. If not NULL, *phGeometry should be freed with OGR_G_DestroyGeometry() after use.
  nBytes | the number of bytes of data available in pabyData, or -1 if it is not known, but assumed to be sufficient.

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

OGRErr OGR_G_CreateFromWkt | ( | char ** | ppszData,
|  | OGRSpatialReferenceH | hSRS,
|  | OGRGeometryH * | phGeometry
| ) |  |

Create a geometry object of the appropriate type from it's well known text representation.

The OGRGeometryFactory::createFromWkt CPP method is the same as this function.

Parameters

  ppszData | input zero terminated string containing well known text representation of the geometry to be created. The pointer is updated to point just beyond that last character consumed.
  hSRS | handle to the spatial reference to be assigned to the created geometry object. This may be NULL.
  phGeometry | the newly created geometry object will be assigned to the indicated handle on return. This will be NULL if the method fails. If not NULL, *phGeometry should be freed with OGR_G_DestroyGeometry() after use.

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

OGRGeometryH OGR_G_CreateGeometry | ( | OGRwkbGeometryType | eGeometryType | ) |

Create an empty geometry of desired type.

This is equivalent to allocating the desired geometry with new, but the allocation is guaranteed to take place in the context of the GDAL/OGR heap.

This function is the same as the CPP method OGRGeometryFactory::createGeometry.

Parameters

  eGeometryType | the type code of the geometry to be created.

Returns
  handle to the newly create geometry or NULL on failure. Should be freed with OGR_G_DestroyGeometry() after use.

int OGR_G_Crosses | ( | OGRGeometryH | hThis,
|  | OGRGeometryH | hOther
| ) |  |

Test for crossing.

Tests if this geometry and the other geometry are crossing.

This function is the same as the C++ method OGRGeometry::Crosses().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hThis | the geometry to compare.
  hOther | the other geometry to compare.

Returns
  TRUE if they are crossing, otherwise FALSE.

OGRGeometryH OGR_G_DelaunayTriangulation | ( | OGRGeometryH | hThis,
|  | double | dfTolerance,
|  | int | bOnlyEdges
| ) |  |

Return a Delaunay triangulation of the vertices of the geometry.

This function is the same as the C++ method OGRGeometry::DelaunayTriangulation().

This function is built on the GEOS library, v3.4 or above. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hThis | the geometry.
  dfTolerance | optional snapping tolerance to use for improved robustness
  bOnlyEdges | if TRUE, will return a MULTILINESTRING, otherwise it will return a GEOMETRYCOLLECTION containing triangular POLYGONs.

Returns
  the geometry resulting from the Delaunay triangulation or NULL if an error occurs.

Since
  OGR 2.1

void OGR_G_DestroyGeometry | ( | OGRGeometryH | hGeom | ) |

Destroy geometry object.

Equivalent to invoking delete on a geometry, but it guaranteed to take place within the context of the GDAL/OGR heap.

This function is the same as the CPP method OGRGeometryFactory::destroyGeometry.

Parameters

  hGeom | handle to the geometry to delete.

OGRGeometryH OGR_G_Difference | ( | OGRGeometryH | hThis,
|  | OGRGeometryH | hOther
| ) |  |

Compute difference.

Generates a new geometry which is the region of this geometry with the region of the other geometry removed.

This function is the same as the C++ method OGRGeometry::Difference().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hThis | the geometry.
  hOther | the other geometry.

Returns
  a new geometry representing the difference or NULL if the difference is empty or an error occurs.

int OGR_G_Disjoint | ( | OGRGeometryH | hThis,
|  | OGRGeometryH | hOther
| ) |  |

Test for disjointness.

Tests if this geometry and the other geometry are disjoint.

This function is the same as the C++ method OGRGeometry::Disjoint().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hThis | the geometry to compare.
  hOther | the other geometry to compare.

Returns
  TRUE if they are disjoint, otherwise FALSE.

double OGR_G_Distance | ( | OGRGeometryH | hFirst,
|  | OGRGeometryH | hOther
| ) |  |

Compute distance between two geometries.

Returns the shortest distance between the two geometries. The distance is expressed into the same unit as the coordinates of the geometries.

This function is the same as the C++ method OGRGeometry::Distance().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hFirst | the first geometry to compare against.
  hOther | the other geometry to compare against.

Returns
  the distance between the geometries or -1 if an error occurs.

double OGR_G_Distance3D | ( | OGRGeometryH | hFirst,
|  | OGRGeometryH | hOther
| ) |  |

Returns the 3D distance between two geometries.

The distance is expressed into the same unit as the coordinates of the geometries.

This method is built on the SFCGAL library, check it for the definition of the geometry operation. If OGR is built without the SFCGAL library, this method will always return -1.0

This function is the same as the C++ method OGRGeometry::Distance3D().

Parameters

  hFirst | the first geometry to compare against.
  hOther | the other geometry to compare against.

Returns
  distance between the two geometries

Since
  GDAL 2.2

Returns
  the distance between the geometries or -1 if an error occurs.

void OGR_G_DumpReadable | ( | OGRGeometryH | hGeom,
|  | FILE * | fp,
|  | const char * | pszPrefix
| ) |  |

Dump geometry in well known text format to indicated output file.

This method is the same as the CPP method OGRGeometry::dumpReadable.

Parameters

  hGeom | handle on the geometry to dump.
  fp | the text file to write the geometry to.
  pszPrefix | the prefix to put on each line of output.

void OGR_G_Empty | ( | OGRGeometryH | hGeom | ) |

Clear geometry information.

This restores the geometry to it's initial state after construction, and before assignment of actual geometry.

This function relates to the SFCOM IGeometry::Empty() method.

This function is the same as the CPP method OGRGeometry::empty().

Parameters

  hGeom | handle on the geometry to empty.

int OGR_G_Equals | ( | OGRGeometryH | hGeom,
|  | OGRGeometryH | hOther
| ) |  |

Returns TRUE if two geometries are equivalent.

This operation implements the SQL/MM ST_OrderingEquals() operation.

The comparison is done in a structural way, that is to say that the geometry types must be identical, as well as the number and ordering of sub-geometries and vertices. Or equivalently, two geometries are considered equal by this method if their WKT/WKB representation is equal. Note: this must be distinguished for equality in a spatial way (which is the purpose of the ST_Equals() operation).

This function is the same as the CPP method OGRGeometry::Equals() method.

Parameters

  hGeom | handle on the first geometry.
  hOther | handle on the other geometry to test against.

Returns
  TRUE if equivalent or FALSE otherwise.

CPLXMLNode* OGR_G_ExportEnvelopeToGMLTree | ( | OGRGeometryH | hGeometry | ) |

Export the envelope of a geometry as a gml:Box.

char* OGR_G_ExportToGML | ( | OGRGeometryH | hGeometry | ) |

Convert a geometry into GML format.

The GML geometry is expressed directly in terms of GML basic data types assuming the this is available in the gml namespace. The returned string should be freed with CPLFree() when no longer required.

This method is the same as the C++ method OGRGeometry::exportToGML().

Parameters

  hGeometry | handle to the geometry.

Returns
  A GML fragment or NULL in case of error.

char* OGR_G_ExportToGMLEx | ( | OGRGeometryH | hGeometry,
|  | char ** | papszOptions
| ) |  |

Convert a geometry into GML format.

The GML geometry is expressed directly in terms of GML basic data types assuming the this is available in the gml namespace. The returned string should be freed with CPLFree() when no longer required.

The supported options are :

- FORMAT=GML2/GML3/GML32 (GML2 or GML32 added in GDAL 2.1). If not set, it will default to GML 2.1.2 output.
- GML3_LINESTRING_ELEMENT=curve. (Only valid for FORMAT=GML3) To use gml:Curve element for linestrings. Otherwise gml:LineString will be used .
- GML3_LONGSRS=YES/NO. (Only valid for FORMAT=GML3, deprecated by SRSNAME_FORMAT in GDAL >=2.2). Defaults to YES. If YES, SRS with EPSG authority will be written with the "urn:ogc:def:crs:EPSG::" prefix. In the case the SRS is a SRS without explicit AXIS order, but that the same SRS authority code imported with ImportFromEPSGA() should be treated as lat/long or northing/easting, then the function will take care of coordinate order swapping. If set to NO, SRS with EPSG authority will be written with the "EPSG:" prefix, even if they are in lat/long order.
- SRSNAME_FORMAT=SHORT/OGC_URN/OGC_URL (Only valid for FORMAT=GML3, added in GDAL 2.2). Defaults to OGC_URN. If SHORT, then srsName will be in the form AUTHORITY_NAME:AUTHORITY_CODE If OGC_URN, then srsName will be in the form urn:ogc:def:crs:AUTHORITY_NAME::AUTHORITY_CODE If OGC_URL, then srsName will be in the form http://www.opengis.net/def/crs/AUTHORITY_NAME/0/AUTHORITY_CODE For OGC_URN and OGC_URL, in the case the SRS is a SRS without explicit AXIS order, but that the same SRS authority code imported with ImportFromEPSGA() should be treated as lat/long or northing/easting, then the function will take care of coordinate order swapping.
- GMLID=astring. If specified, a gml:id attribute will be written in the top-level geometry element with the provided value. Required for GML 3.2 compatibility.

- SRSDIMENSION_LOC=POSLIST/GEOMETRY/GEOMETRY,POSLIST. (Only valid for FORMAT=GML3/GML32, GDAL >= 2.0) Default to POSLIST. For 2.5D geometries, define the location where to attach the srsDimension attribute. There are diverging implementations. Some put in on the <gml:posList> element, other on the top geometry element.

- NAMESPACE_DECL=YES/NO. If set to YES, xmlns:gml="http://www.opengis.net/gml" will be added to the root node for GML < 3.2 or xmlns:gml="http://www.opengis.net/gml/3.2" for GML 3.2

Note that curve geometries like CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE are not supported in GML 2.

This method is the same as the C++ method OGRGeometry::exportToGML().

Parameters

  hGeometry | handle to the geometry.
  papszOptions | NULL-terminated list of options.

Returns
  A GML fragment or NULL in case of error.

Since
  OGR 1.8.0

CPLXMLNode* OGR_G_ExportToGMLTree | ( | OGRGeometryH | hGeometry | ) |

Convert a geometry into GML format.

OGRErr OGR_G_ExportToIsoWkb | ( | OGRGeometryH | hGeom,
|  | OGRwkbByteOrder | eOrder,
|  | unsigned char * | pabyDstBuffer
| ) |  |

Convert a geometry into SFSQL 1.2 / ISO SQL/MM Part 3 well known binary format.

This function relates to the SFCOM IWks::ExportToWKB() method. It exports the SFSQL 1.2 and ISO SQL/MM Part 3 extended dimension (Z&M) WKB types.

This function is the same as the CPP method OGRGeometry::exportToWkb(OGRwkbByteOrder, unsigned char *, OGRwkbVariant) with eWkbVariant = wkbVariantIso.

Parameters

  hGeom | handle on the geometry to convert to a well know binary data from.
  eOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  pabyDstBuffer | a buffer into which the binary representation is written. This buffer must be at least OGR_G_WkbSize() byte in size.

Returns
  Currently OGRERR_NONE is always returned.

Since
  GDAL 2.0

OGRErr OGR_G_ExportToIsoWkt | ( | OGRGeometryH | hGeom,
|  | char ** | ppszSrcText
| ) |  |

Convert a geometry into SFSQL 1.2 / ISO SQL/MM Part 3 well known text format.

This function relates to the SFCOM IWks::ExportToWKT() method. It exports the SFSQL 1.2 and ISO SQL/MM Part 3 extended dimension (Z&M) WKB types.

This function is the same as the CPP method OGRGeometry::exportToWkt(wkbVariantIso).

Parameters

  hGeom | handle on the geometry to convert to a text format from.
  ppszSrcText | a text buffer is allocated by the program, and assigned to the passed pointer. After use, *ppszDstText should be freed with CPLFree().

Returns
  Currently OGRERR_NONE is always returned.

Since
  GDAL 2.0

char* OGR_G_ExportToJson | ( | OGRGeometryH | hGeometry | ) |

Convert a geometry into GeoJSON format.

The returned string should be freed with CPLFree() when no longer required.

This method is the same as the C++ method OGRGeometry::exportToJson().

Parameters

  hGeometry | handle to the geometry.

Returns
  A GeoJSON fragment or NULL in case of error.

char* OGR_G_ExportToJsonEx | ( | OGRGeometryH | hGeometry,
|  | char ** | papszOptions
| ) |  |

Convert a geometry into GeoJSON format.

The returned string should be freed with CPLFree() when no longer required.

The following options are supported :

- COORDINATE_PRECISION=number: maximum number of figures after decimal separator to write in coordinates.
- SIGNIFICANT_FIGURES=number: maximum number of significant figures (GDAL >= 2.1).

If COORDINATE_PRECISION is defined, SIGNIFICANT_FIGURES will be ignored if specified. When none are defined, the default is COORDINATE_PRECISION=15.

This method is the same as the C++ method OGRGeometry::exportToJson().

Parameters

  hGeometry | handle to the geometry.
  papszOptions | a null terminated list of options.

Returns
  A GeoJSON fragment or NULL in case of error.

Since
  OGR 1.9.0

char* OGR_G_ExportToKML | ( | OGRGeometryH | hGeometry,
|  | const char * | pszAltitudeMode
| ) |  |

Convert a geometry into KML format.

The returned string should be freed with CPLFree() when no longer required.

This method is the same as the C++ method OGRGeometry::exportToKML().

Parameters

  hGeometry | handle to the geometry.
  pszAltitudeMode | value to write in altitudeMode element, or NULL.

Returns
  A KML fragment or NULL in case of error.

OGRErr OGR_G_ExportToWkb | ( | OGRGeometryH | hGeom,
|  | OGRwkbByteOrder | eOrder,
|  | unsigned char * | pabyDstBuffer
| ) |  |

Convert a geometry well known binary format.

This function relates to the SFCOM IWks::ExportToWKB() method.

For backward compatibility purposes, it exports the Old-style 99-402 extended dimension (Z) WKB types for types Point, LineString, Polygon, MultiPoint, MultiLineString, MultiPolygon and GeometryCollection. For other geometry types, it is equivalent to OGR_G_ExportToIsoWkb().

This function is the same as the CPP method OGRGeometry::exportToWkb(OGRwkbByteOrder, unsigned char *, OGRwkbVariant) with eWkbVariant = wkbVariantOldOgc.

Parameters

  hGeom | handle on the geometry to convert to a well know binary data from.
  eOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  pabyDstBuffer | a buffer into which the binary representation is written. This buffer must be at least OGR_G_WkbSize() byte in size.

Returns
  Currently OGRERR_NONE is always returned.

OGRErr OGR_G_ExportToWkt | ( | OGRGeometryH | hGeom,
|  | char ** | ppszSrcText
| ) |  |

Convert a geometry into well known text format.

This function relates to the SFCOM IWks::ExportToWKT() method.

For backward compatibility purposes, it exports the Old-style 99-402 extended dimension (Z) WKB types for types Point, LineString, Polygon, MultiPoint, MultiLineString, MultiPolygon and GeometryCollection. For other geometry types, it is equivalent to OGR_G_ExportToIsoWkt().

This function is the same as the CPP method OGRGeometry::exportToWkt().

Parameters

  hGeom | handle on the geometry to convert to a text format from.
  ppszSrcText | a text buffer is allocated by the program, and assigned to the passed pointer. After use, *ppszDstText should be freed with CPLFree().

Returns
  Currently OGRERR_NONE is always returned.

void OGR_G_FlattenTo2D | ( | OGRGeometryH | hGeom | ) |

Convert geometry to strictly 2D.

In a sense this converts all Z coordinates to 0.0.

This function is the same as the CPP method OGRGeometry::flattenTo2D().

Parameters

  hGeom | handle on the geometry to convert.

OGRGeometryH OGR_G_ForceTo | ( | OGRGeometryH | hGeom,
|  | OGRwkbGeometryType | eTargetType,
|  | char ** | papszOptions
| ) |  |

Convert to another geometry type.

This function is the same as the C++ method OGRGeometryFactory::forceTo().

Parameters

  hGeom | the input geometry - ownership is passed to the method.
  eTargetType | target output geometry type.
  papszOptions | options as a null-terminated list of strings or NULL.

Returns
  new geometry.

Since
  GDAL 2.0

OGRGeometryH OGR_G_ForceToLineString | ( | OGRGeometryH | hGeom | ) |

Convert to line string.

This function is the same as the C++ method OGRGeometryFactory::forceToLineString().

Parameters

  hGeom | handle to the geometry to convert (ownership surrendered).

Returns
  the converted geometry (ownership to caller).

Since
  GDAL/OGR 1.10.0

OGRGeometryH OGR_G_ForceToMultiLineString | ( | OGRGeometryH | hGeom | ) |

Convert to multilinestring.

This function is the same as the C++ method OGRGeometryFactory::forceToMultiLineString().

Parameters

  hGeom | handle to the geometry to convert (ownership surrendered).

Returns
  the converted geometry (ownership to caller).

Since
  GDAL/OGR 1.8.0

OGRGeometryH OGR_G_ForceToMultiPoint | ( | OGRGeometryH | hGeom | ) |

Convert to multipoint.

This function is the same as the C++ method OGRGeometryFactory::forceToMultiPoint().

Parameters

  hGeom | handle to the geometry to convert (ownership surrendered).

Returns
  the converted geometry (ownership to caller).

Since
  GDAL/OGR 1.8.0

OGRGeometryH OGR_G_ForceToMultiPolygon | ( | OGRGeometryH | hGeom | ) |

Convert to multipolygon.

This function is the same as the C++ method OGRGeometryFactory::forceToMultiPolygon().

Parameters

  hGeom | handle to the geometry to convert (ownership surrendered).

Returns
  the converted geometry (ownership to caller).

Since
  GDAL/OGR 1.8.0

OGRGeometryH OGR_G_ForceToPolygon | ( | OGRGeometryH | hGeom | ) |

Convert to polygon.

This function is the same as the C++ method OGRGeometryFactory::forceToPolygon().

Parameters

  hGeom | handle to the geometry to convert (ownership surrendered).

Returns
  the converted geometry (ownership to caller).

Since
  GDAL/OGR 1.8.0

int OGR_G_GetCoordinateDimension | ( | OGRGeometryH | hGeom | ) |

Get the dimension of the coordinates in this geometry.

This function is the same as the CPP method OGRGeometry::getCoordinateDimension().

Parameters

  hGeom | handle on the geometry to get the dimension of the coordinates from.

Deprecated:
  use OGR_G_CoordinateDimension(), OGR_G_Is3D(), or OGR_G_IsMeasured().

Returns
  this will return 2 or 3.

OGRGeometryH OGR_G_GetCurveGeometry | ( | OGRGeometryH | hGeom,
|  | char ** | papszOptions
| ) |  |

Return curve version of this geometry.

Returns a geometry that has possibly CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE in it, by de-approximating linear into curve geometries.

If the geometry has no curve portion, the returned geometry will be a clone of it.

The ownership of the returned geometry belongs to the caller.

The reverse function is OGR_G_GetLinearGeometry().

This function is the same as C++ method OGRGeometry::getCurveGeometry().

Parameters

  hGeom | the geometry to operate on.
  papszOptions | options as a null-terminated list of strings. Unused for now. Must be set to NULL.

Returns
  a new geometry.

Since
  GDAL 2.0

int OGR_G_GetDimension | ( | OGRGeometryH | hGeom | ) |

Get the dimension of this geometry.

This function corresponds to the SFCOM IGeometry::GetDimension() method. It indicates the dimension of the geometry, but does not indicate the dimension of the underlying space (as indicated by OGR_G_GetCoordinateDimension() function).

This function is the same as the CPP method OGRGeometry::getDimension().

Parameters

  hGeom | handle on the geometry to get the dimension from.

Returns
  0 for points, 1 for lines and 2 for surfaces.

void OGR_G_GetEnvelope | ( | OGRGeometryH | hGeom,
|  | OGREnvelope * | psEnvelope
| ) |  |

Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.

This function is the same as the CPP method OGRGeometry::getEnvelope().

Parameters

  hGeom | handle of the geometry to get envelope from.
  psEnvelope | the structure in which to place the results.

void OGR_G_GetEnvelope3D | ( | OGRGeometryH | hGeom,
|  | OGREnvelope3D * | psEnvelope
| ) |  |

Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.

This function is the same as the CPP method OGRGeometry::getEnvelope().

Parameters

  hGeom | handle of the geometry to get envelope from.
  psEnvelope | the structure in which to place the results.

Since
  OGR 1.9.0

int OGR_G_GetGeometryCount | ( | OGRGeometryH | hGeom | ) |

Fetch the number of elements in a geometry or number of geometries in container.

Only geometries of type wkbPolygon[25D], wkbMultiPoint[25D], wkbMultiLineString[25D], wkbMultiPolygon[25D] or wkbGeometryCollection[25D] may return a valid value. Other geometry types will silently return 0.

For a polygon, the returned number is the number of rings (exterior ring + interior rings).

Parameters

  hGeom | single geometry or geometry container from which to get the number of elements.

Returns
  the number of elements.

const char* OGR_G_GetGeometryName | ( | OGRGeometryH | hGeom | ) |

Fetch WKT name for geometry type.

There is no SFCOM analog to this function.

This function is the same as the CPP method OGRGeometry::getGeometryName().

Parameters

  hGeom | handle on the geometry to get name from.

Returns
  name used for this geometry type in well known text format.

OGRGeometryH OGR_G_GetGeometryRef | ( | OGRGeometryH | hGeom,
|  | int | iSubGeom
| ) |  |

Fetch geometry from a geometry container.

This function returns an handle to a geometry within the container. The returned geometry remains owned by the container, and should not be modified. The handle is only valid until the next change to the geometry container. Use OGR_G_Clone() to make a copy.

This function relates to the SFCOM IGeometryCollection::get_Geometry() method.

This function is the same as the CPP method OGRGeometryCollection::getGeometryRef().

For a polygon, OGR_G_GetGeometryRef(iSubGeom) returns the exterior ring if iSubGeom == 0, and the interior rings for iSubGeom > 0.

Parameters

  hGeom | handle to the geometry container from which to get a geometry from.
  iSubGeom | the index of the geometry to fetch, between 0 and getNumGeometries() - 1.

Returns
  handle to the requested geometry.

OGRwkbGeometryType OGR_G_GetGeometryType | ( | OGRGeometryH | hGeom | ) |

Fetch geometry type.

Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result.

This function is the same as the CPP method OGRGeometry::getGeometryType().

Parameters

  hGeom | handle on the geometry to get type from.

Returns
  the geometry type code.

OGRGeometryH OGR_G_GetLinearGeometry | ( | OGRGeometryH | hGeom,
|  | double | dfMaxAngleStepSizeDegrees,
|  | char ** | papszOptions
| ) |  |

Return, possibly approximate, linear version of this geometry.

Returns a geometry that has no CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE in it, by approximating curve geometries.

The ownership of the returned geometry belongs to the caller.

The reverse function is OGR_G_GetCurveGeometry().

This method relates to the ISO SQL/MM Part 3 ICurve::CurveToLine() and CurvePolygon::CurvePolyToPoly() methods.

This function is the same as C++ method OGRGeometry::getLinearGeometry().

Parameters

  hGeom | the geometry to operate on.
  dfMaxAngleStepSizeDegrees | the largest step in degrees along the arc, zero to use the default setting.
  papszOptions | options as a null-terminated list of strings or NULL. See OGRGeometryFactory::curveToLineString() for valid options.

Returns
  a new geometry.

Since
  GDAL 2.0

double OGR_G_GetM | ( | OGRGeometryH | hGeom,
|  | int | i
| ) |  |

Fetch the m coordinate of a point from a geometry.

Parameters

  hGeom | handle to the geometry from which to get the M coordinate.
  i | point to get the M coordinate.

Returns
  the M coordinate of this point.

void OGR_G_GetPoint | ( | OGRGeometryH | hGeom,
|  | int | i,
|  | double * | pdfX,
|  | double * | pdfY,
|  | double * | pdfZ
| ) |  |

Fetch a point in line string or a point geometry.

Parameters

  hGeom | handle to the geometry from which to get the coordinates.
  i | the vertex to fetch, from 0 to getNumPoints()-1, zero for a point.
  pdfX | value of x coordinate.
  pdfY | value of y coordinate.
  pdfZ | value of z coordinate.

int OGR_G_GetPointCount | ( | OGRGeometryH | hGeom | ) |

Fetch number of points from a geometry.

Only wkbPoint[25D] or wkbLineString[25D] may return a valid value. Other geometry types will silently return 0.

Parameters

  hGeom | handle to the geometry from which to get the number of points.

Returns
  the number of points.

int OGR_G_GetPoints | ( | OGRGeometryH | hGeom,
|  | void * | pabyX,
|  | int | nXStride,
|  | void * | pabyY,
|  | int | nYStride,
|  | void * | pabyZ,
|  | int | nZStride
| ) |  |

Returns all points of line string.

This method copies all points into user arrays. The user provides the stride between 2 consecutive elements of the array.

On some CPU architectures, care must be taken so that the arrays are properly aligned.

Parameters

  hGeom | handle to the geometry from which to get the coordinates.
  pabyX | a buffer of at least (sizeof(double) * nXStride * nPointCount) bytes, may be NULL.
  nXStride | the number of bytes between 2 elements of pabyX.
  pabyY | a buffer of at least (sizeof(double) * nYStride * nPointCount) bytes, may be NULL.
  nYStride | the number of bytes between 2 elements of pabyY.
  pabyZ | a buffer of at last size (sizeof(double) * nZStride * nPointCount) bytes, may be NULL.
  nZStride | the number of bytes between 2 elements of pabyZ.

Returns
  the number of points

Since
  OGR 1.9.0

int OGR_G_GetPointsZM | ( | OGRGeometryH | hGeom,
|  | void * | pabyX,
|  | int | nXStride,
|  | void * | pabyY,
|  | int | nYStride,
|  | void * | pabyZ,
|  | int | nZStride,
|  | void * | pabyM,
|  | int | nMStride
| ) |  |

Returns all points of line string.

This method copies all points into user arrays. The user provides the stride between 2 consecutive elements of the array.

On some CPU architectures, care must be taken so that the arrays are properly aligned.

Parameters

  hGeom | handle to the geometry from which to get the coordinates.
  pabyX | a buffer of at least (sizeof(double) * nXStride * nPointCount) bytes, may be NULL.
  nXStride | the number of bytes between 2 elements of pabyX.
  pabyY | a buffer of at least (sizeof(double) * nYStride * nPointCount) bytes, may be NULL.
  nYStride | the number of bytes between 2 elements of pabyY.
  pabyZ | a buffer of at last size (sizeof(double) * nZStride * nPointCount) bytes, may be NULL.
  nZStride | the number of bytes between 2 elements of pabyZ.
  pabyM | a buffer of at last size (sizeof(double) * nMStride * nPointCount) bytes, may be NULL.
  nMStride | the number of bytes between 2 elements of pabyM.

Returns
  the number of points

Since
  OGR 1.9.0

void OGR_G_GetPointZM | ( | OGRGeometryH | hGeom,
|  | int | i,
|  | double * | pdfX,
|  | double * | pdfY,
|  | double * | pdfZ,
|  | double * | pdfM
| ) |  |

Fetch a point in line string or a point geometry.

Parameters

  hGeom | handle to the geometry from which to get the coordinates.
  i | the vertex to fetch, from 0 to getNumPoints()-1, zero for a point.
  pdfX | value of x coordinate.
  pdfY | value of y coordinate.
  pdfZ | value of z coordinate.
  pdfM | value of m coordinate.

OGRSpatialReferenceH OGR_G_GetSpatialReference | ( | OGRGeometryH | hGeom | ) |

Returns spatial reference system for geometry.

This function relates to the SFCOM IGeometry::get_SpatialReference() method.

This function is the same as the CPP method OGRGeometry::getSpatialReference().

Parameters

  hGeom | handle on the geometry to get spatial reference from.

Returns
  a reference to the spatial reference geometry.

double OGR_G_GetX | ( | OGRGeometryH | hGeom,
|  | int | i
| ) |  |

Fetch the x coordinate of a point from a geometry.

Parameters

  hGeom | handle to the geometry from which to get the x coordinate.
  i | point to get the x coordinate.

Returns
  the X coordinate of this point.

double OGR_G_GetY | ( | OGRGeometryH | hGeom,
|  | int | i
| ) |  |

Fetch the x coordinate of a point from a geometry.

Parameters

  hGeom | handle to the geometry from which to get the y coordinate.
  i | point to get the Y coordinate.

Returns
  the Y coordinate of this point.

double OGR_G_GetZ | ( | OGRGeometryH | hGeom,
|  | int | i
| ) |  |

Fetch the z coordinate of a point from a geometry.

Parameters

  hGeom | handle to the geometry from which to get the Z coordinate.
  i | point to get the Z coordinate.

Returns
  the Z coordinate of this point.

int OGR_G_HasCurveGeometry | ( | OGRGeometryH | hGeom,
|  | int | bLookForNonLinear
| ) |  |

Returns if this geometry is or has curve geometry.

Returns if a geometry is or has CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE in it.

If bLookForNonLinear is set to TRUE, it will be actually looked if the geometry or its subgeometries are or contain a non-linear geometry in them. In which case, if the method returns TRUE, it means that OGR_G_GetLinearGeometry() would return an approximate version of the geometry. Otherwise, OGR_G_GetLinearGeometry() would do a conversion, but with just converting container type, like COMPOUNDCURVE -> LINESTRING, MULTICURVE -> MULTILINESTRING or MULTISURFACE -> MULTIPOLYGON, resulting in a "loss-less" conversion.

This function is the same as C++ method OGRGeometry::hasCurveGeometry().

Parameters

  hGeom | the geometry to operate on.
  bLookForNonLinear | set it to TRUE to check if the geometry is or contains a CIRCULARSTRING.

Returns
  TRUE if this geometry is or has curve geometry.

Since
  GDAL 2.0

OGRErr OGR_G_ImportFromWkb | ( | OGRGeometryH | hGeom,
|  | unsigned char * | pabyData,
|  | int | nSize
| ) |  |

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type.

This function relates to the SFCOM IWks::ImportFromWKB() method.

This function is the same as the CPP method OGRGeometry::importFromWkb().

Parameters

  hGeom | handle on the geometry to assign the well know binary data to.
  pabyData | the binary input data.
  nSize | the size of pabyData in bytes, or zero if not known.

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

OGRErr OGR_G_ImportFromWkt | ( | OGRGeometryH | hGeom,
|  | char ** | ppszSrcText
| ) |  |

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type.

This function relates to the SFCOM IWks::ImportFromWKT() method.

This function is the same as the CPP method OGRGeometry::importFromWkt().

Parameters

  hGeom | handle on the geometry to assign well know text data to.
  ppszSrcText | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

OGRGeometryH OGR_G_Intersection | ( | OGRGeometryH | hThis,
|  | OGRGeometryH | hOther
| ) |  |

Compute intersection.

Generates a new geometry which is the region of intersection of the two geometries operated on. The OGR_G_Intersects() function can be used to test if two geometries intersect.

This function is the same as the C++ method OGRGeometry::Intersection().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hThis | the geometry.
  hOther | the other geometry.

Returns
  a new geometry representing the intersection or NULL if there is no intersection or an error occurs.

int OGR_G_Intersects | ( | OGRGeometryH | hGeom,
|  | OGRGeometryH | hOtherGeom
| ) |  |

Do these features intersect?

Determines whether two geometries intersect. If GEOS is enabled, then this is done in rigorous fashion otherwise TRUE is returned if the envelopes (bounding boxes) of the two geometries overlap.

This function is the same as the CPP method OGRGeometry::Intersects.

Parameters

  hGeom | handle on the first geometry.
  hOtherGeom | handle on the other geometry to test against.

Returns
  TRUE if the geometries intersect, otherwise FALSE.

int OGR_G_Is3D | ( | OGRGeometryH | hGeom | ) |

See whether this geometry has Z coordinates.

This function is the same as the CPP method OGRGeometry::Is3D().

Parameters

  hGeom | handle on the geometry to check whether it has Z coordinates.

Returns
  TRUE if the geometry has Z coordinates.

Since
  GDAL 2.1

int OGR_G_IsEmpty | ( | OGRGeometryH | hGeom | ) |

Test if the geometry is empty.

This method is the same as the CPP method OGRGeometry::IsEmpty().

Parameters

  hGeom | The Geometry to test.

Returns
  TRUE if the geometry has no points, otherwise FALSE.

int OGR_G_IsMeasured | ( | OGRGeometryH | hGeom | ) |

See whether this geometry is measured.

This function is the same as the CPP method OGRGeometry::IsMeasured().

Parameters

  hGeom | handle on the geometry to check whether it is measured.

Returns
  TRUE if the geometry has M coordinates.

Since
  GDAL 2.1

int OGR_G_IsRing | ( | OGRGeometryH | hGeom | ) |

Test if the geometry is a ring.

This function is the same as the C++ method OGRGeometry::IsRing().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always return FALSE.

Parameters

  hGeom | The Geometry to test.

Returns
  TRUE if the geometry has no points, otherwise FALSE.

int OGR_G_IsSimple | ( | OGRGeometryH | hGeom | ) |

Returns TRUE if the geometry is simple.

Returns TRUE if the geometry has no anomalous geometric points, such as self intersection or self tangency. The description of each instantiable geometric class will include the specific conditions that cause an instance of that class to be classified as not simple.

This function is the same as the C++ method OGRGeometry::IsSimple() method.

If OGR is built without the GEOS library, this function will always return FALSE.

Parameters

  hGeom | The Geometry to test.

Returns
  TRUE if object is simple, otherwise FALSE.

int OGR_G_IsValid | ( | OGRGeometryH | hGeom | ) |

Test if the geometry is valid.

This function is the same as the C++ method OGRGeometry::IsValid().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always return FALSE.

Parameters

  hGeom | The Geometry to test.

Returns
  TRUE if the geometry has no points, otherwise FALSE.

double OGR_G_Length | ( | OGRGeometryH | hGeom | ) |

Compute length of a geometry.

Computes the length for OGRCurve or MultiCurve objects. Undefined for all other geometry types (returns zero).

This function utilizes the C++ get_Length() method.

Parameters

  hGeom | the geometry to operate on.

Returns
  the length or 0.0 for unsupported geometry types.

Since
  OGR 1.8.0

int OGR_G_Overlaps | ( | OGRGeometryH | hThis,
|  | OGRGeometryH | hOther
| ) |  |

Test for overlap.

Tests if this geometry and the other geometry overlap, that is their intersection has a non-zero area.

This function is the same as the C++ method OGRGeometry::Overlaps().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hThis | the geometry to compare.
  hOther | the other geometry to compare.

Returns
  TRUE if they are overlapping, otherwise FALSE.

OGRGeometryH OGR_G_PointOnSurface | ( | OGRGeometryH | hGeom | ) |

Returns a point guaranteed to lie on the surface.

This method relates to the SFCOM ISurface::get_PointOnSurface() method however the current implementation based on GEOS can operate on other geometry types than the types that are supported by SQL/MM-Part 3 : surfaces (polygons) and multisurfaces (multipolygons).

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  hGeom | the geometry to operate on.

Returns
  a point guaranteed to lie on the surface or NULL if an error occurred.

Since
  OGR 1.10

OGRGeometryH OGR_G_Polygonize | ( | OGRGeometryH | hTarget | ) |

Polygonizes a set of sparse edges.

A new geometry object is created and returned containing a collection of reassembled Polygons: NULL will be returned if the input collection doesn't corresponds to a MultiLinestring, or when reassembling Edges into Polygons is impossible due to topological inconsistencies.

This function is the same as the C++ method OGRGeometry::Polygonize().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hTarget | The Geometry to be polygonized.

Returns
  a handle to a newly allocated geometry now owned by the caller, or NULL on failure.

Since
  OGR 1.9.0

OGRErr OGR_G_RemoveGeometry | ( | OGRGeometryH | hGeom,
|  | int | iGeom,
|  | int | bDelete
| ) |  |

Remove a geometry from an exiting geometry container.

Removing a geometry will cause the geometry count to drop by one, and all "higher" geometries will shuffle down one in index.

There is no SFCOM analog to this method.

This function is the same as the CPP method OGRGeometryCollection::removeGeometry().

Parameters

  hGeom | the existing geometry to delete from.
  iGeom | the index of the geometry to delete. A value of -1 is a special flag meaning that all geometries should be removed.
  bDelete | if TRUE the geometry will be destroyed, otherwise it will not. The default is TRUE as the existing geometry is considered to own the geometries in it.

Returns
  OGRERR_NONE if successful, or OGRERR_FAILURE if the index is out of range.

void OGR_G_Segmentize | ( | OGRGeometryH | hGeom,
|  | double | dfMaxLength
| ) |  |

Modify the geometry such it has no segment longer then the given distance.

Interpolated points will have Z and M values (if needed) set to 0. Distance computation is performed in 2d only.

This function is the same as the CPP method OGRGeometry::segmentize().

Parameters

  hGeom | handle on the geometry to segmentize
  dfMaxLength | the maximum distance between 2 points after segmentization

void OGR_G_Set3D | ( | OGRGeometryH | hGeom,
|  | int | bIs3D
| ) |  |

Add or remove the Z coordinate dimension.

This method adds or removes the explicit Z coordinate dimension. Removing the Z coordinate dimension of a geometry will remove any existing Z values. Adding the Z dimension to a geometry collection, a compound curve, a polygon, etc. will affect the children geometries.

Parameters

  hGeom | handle on the geometry to set or unset the Z dimension.
  bIs3D | Should the geometry have a Z dimension, either TRUE or FALSE.

Since
  GDAL 2.1

void OGR_G_SetCoordinateDimension | ( | OGRGeometryH | hGeom,
|  | int | nNewDimension
| ) |  |

Set the coordinate dimension.

This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. Setting the dimension of a geometry collection, a compound curve, a polygon, etc. will affect the children geometries. This will also remove the M dimension if present before this call.

Deprecated:
  use OGR_G_Set3D() or OGR_G_SetMeasured().

Parameters

  hGeom | handle on the geometry to set the dimension of the coordinates.
  nNewDimension | New coordinate dimension value, either 2 or 3.

void OGR_G_SetMeasured | ( | OGRGeometryH | hGeom,
|  | int | bIsMeasured
| ) |  |

Add or remove the M coordinate dimension.

This method adds or removes the explicit M coordinate dimension. Removing the M coordinate dimension of a geometry will remove any existing M values. Adding the M dimension to a geometry collection, a compound curve, a polygon, etc. will affect the children geometries.

Parameters

  hGeom | handle on the geometry to set or unset the M dimension.
  bIsMeasured | Should the geometry have a M dimension, either TRUE or FALSE.

Since
  GDAL 2.1

void OGR_G_SetPoint | ( | OGRGeometryH | hGeom,
|  | int | i,
|  | double | dfX,
|  | double | dfY,
|  | double | dfZ
| ) |  |

Set the location of a vertex in a point or linestring geometry.

If iPoint is larger than the number of existing points in the linestring, the point count will be increased to accommodate the request.

Parameters

  hGeom | handle to the geometry to add a vertex to.
  i | the index of the vertex to assign (zero based) or zero for a point.
  dfX | input X coordinate to assign.
  dfY | input Y coordinate to assign.
  dfZ | input Z coordinate to assign (defaults to zero).

void OGR_G_SetPoint_2D | ( | OGRGeometryH | hGeom,
|  | int | i,
|  | double | dfX,
|  | double | dfY
| ) |  |

Set the location of a vertex in a point or linestring geometry.

If iPoint is larger than the number of existing points in the linestring, the point count will be increased to accommodate the request.

Parameters

  hGeom | handle to the geometry to add a vertex to.
  i | the index of the vertex to assign (zero based) or zero for a point.
  dfX | input X coordinate to assign.
  dfY | input Y coordinate to assign.

void OGR_G_SetPointCount | ( | OGRGeometryH | hGeom,
|  | int | nNewPointCount
| ) |  |

Set number of points in a geometry.

This method primary exists to preset the number of points in a linestring geometry before setPoint() is used to assign them to avoid reallocating the array larger with each call to addPoint().

Parameters

  hGeom | handle to the geometry.
  nNewPointCount | the new number of points for geometry.

void OGR_G_SetPointM | ( | OGRGeometryH | hGeom,
|  | int | i,
|  | double | dfX,
|  | double | dfY,
|  | double | dfM
| ) |  |

Set the location of a vertex in a point or linestring geometry.

If iPoint is larger than the number of existing points in the linestring, the point count will be increased to accommodate the request.

Parameters

  hGeom | handle to the geometry to add a vertex to.
  i | the index of the vertex to assign (zero based) or zero for a point.
  dfX | input X coordinate to assign.
  dfY | input Y coordinate to assign.
  dfM | input M coordinate to assign.

void OGR_G_SetPoints | ( | OGRGeometryH | hGeom,
|  | int | nPointsIn,
|  | void * | pabyX,
|  | int | nXStride,
|  | void * | pabyY,
|  | int | nYStride,
|  | void * | pabyZ,
|  | int | nZStride
| ) |  |

Assign all points in a point or a line string geometry.

This method clear any existing points assigned to this geometry, and assigns a whole new set.

Parameters

  hGeom | handle to the geometry to set the coordinates.
  nPointsIn | number of points being passed in padfX and padfY.
  pabyX | list of X coordinates (double values) of points being assigned.
  nXStride | the number of bytes between 2 elements of pabyX.
  pabyY | list of Y coordinates (double values) of points being assigned.
  nYStride | the number of bytes between 2 elements of pabyY.
  pabyZ | list of Z coordinates (double values) of points being assigned (defaults to NULL for 2D objects).
  nZStride | the number of bytes between 2 elements of pabyZ.

void OGR_G_SetPointsZM | ( | OGRGeometryH | hGeom,
|  | int | nPointsIn,
|  | void * | pabyX,
|  | int | nXStride,
|  | void * | pabyY,
|  | int | nYStride,
|  | void * | pabyZ,
|  | int | nZStride,
|  | void * | pabyM,
|  | int | nMStride
| ) |  |

Assign all points in a point or a line string geometry.

This method clear any existing points assigned to this geometry, and assigns a whole new set.

Parameters

  hGeom | handle to the geometry to set the coordinates.
  nPointsIn | number of points being passed in padfX and padfY.
  pabyX | list of X coordinates (double values) of points being assigned.
  nXStride | the number of bytes between 2 elements of pabyX.
  pabyY | list of Y coordinates (double values) of points being assigned.
  nYStride | the number of bytes between 2 elements of pabyY.
  pabyZ | list of Z coordinates (double values) of points being assigned (if not NULL, upgrades the geometry to have Z coordinate).
  nZStride | the number of bytes between 2 elements of pabyZ.
  pabyM | list of M coordinates (double values) of points being assigned (if not NULL, upgrades the geometry to have M coordinate).
  nMStride | the number of bytes between 2 elements of pabyM.

void OGR_G_SetPointZM | ( | OGRGeometryH | hGeom,
|  | int | i,
|  | double | dfX,
|  | double | dfY,
|  | double | dfZ,
|  | double | dfM
| ) |  |

Set the location of a vertex in a point or linestring geometry.

If iPoint is larger than the number of existing points in the linestring, the point count will be increased to accommodate the request.

Parameters

  hGeom | handle to the geometry to add a vertex to.
  i | the index of the vertex to assign (zero based) or zero for a point.
  dfX | input X coordinate to assign.
  dfY | input Y coordinate to assign.
  dfZ | input Z coordinate to assign.
  dfM | input M coordinate to assign.

OGRGeometryH OGR_G_Simplify | ( | OGRGeometryH | hThis,
|  | double | dTolerance
| ) |  |

Compute a simplified geometry.

This function is the same as the C++ method OGRGeometry::Simplify().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hThis | the geometry.
  dTolerance | the distance tolerance for the simplification.

Returns
  the simplified geometry or NULL if an error occurs.

Since
  OGR 1.8.0

OGRGeometryH OGR_G_SimplifyPreserveTopology | ( | OGRGeometryH | hThis,
|  | double | dTolerance
| ) |  |

Simplify the geometry while preserving topology.

This function is the same as the C++ method OGRGeometry::SimplifyPreserveTopology().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hThis | the geometry.
  dTolerance | the distance tolerance for the simplification.

Returns
  the simplified geometry or NULL if an error occurs.

Since
  OGR 1.9.0

OGRGeometryH OGR_G_SymDifference | ( | OGRGeometryH | hThis,
|  | OGRGeometryH | hOther
| ) |  |

Compute symmetric difference.

Generates a new geometry which is the symmetric difference of this geometry and the other geometry.

This function is the same as the C++ method OGRGeometry::SymmetricDifference().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hThis | the geometry.
  hOther | the other geometry.

Returns
  a new geometry representing the symmetric difference or NULL if the difference is empty or an error occurs.

Since
  OGR 1.8.0

int OGR_G_Touches | ( | OGRGeometryH | hThis,
|  | OGRGeometryH | hOther
| ) |  |

Test for touching.

Tests if this geometry and the other geometry are touching.

This function is the same as the C++ method OGRGeometry::Touches().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hThis | the geometry to compare.
  hOther | the other geometry to compare.

Returns
  TRUE if they are touching, otherwise FALSE.

OGRErr OGR_G_Transform | ( | OGRGeometryH | hGeom,
|  | OGRCoordinateTransformationH | hTransform
| ) |  |

Apply arbitrary coordinate transformation to geometry.

This function will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this function does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This function is the same as the CPP method OGRGeometry::transform.

Parameters

  hGeom | handle on the geometry to apply the transform to.
  hTransform | handle on the transformation to apply.

Returns
  OGRERR_NONE on success or an error code.

OGRErr OGR_G_TransformTo | ( | OGRGeometryH | hGeom,
|  | OGRSpatialReferenceH | hSRS
| ) |  |

Transform geometry to new spatial reference system.

This function will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

This function will only work if the geometry already has an assigned spatial reference system, and if it is transformable to the target coordinate system.

Because this function requires internal creation and initialization of an OGRCoordinateTransformation object it is significantly more expensive to use this function to transform many geometries than it is to create the OGRCoordinateTransformation in advance, and call transform() with that transformation. This function exists primarily for convenience when only transforming a single geometry.

This function is the same as the CPP method OGRGeometry::transformTo.

Parameters

  hGeom | handle on the geometry to apply the transform to.
  hSRS | handle on the spatial reference system to apply.

Returns
  OGRERR_NONE on success, or an error code.

OGRGeometryH OGR_G_Union | ( | OGRGeometryH | hThis,
|  | OGRGeometryH | hOther
| ) |  |

Compute union.

Generates a new geometry which is the region of union of the two geometries operated on.

This function is the same as the C++ method OGRGeometry::Union().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hThis | the geometry.
  hOther | the other geometry.

Returns
  a new geometry representing the union or NULL if an error occurs.

OGRGeometryH OGR_G_UnionCascaded | ( | OGRGeometryH | hThis | ) |

Compute union using cascading.

This function is the same as the C++ method OGRGeometry::UnionCascaded().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hThis | the geometry.

Returns
  a new geometry representing the union or NULL if an error occurs.

OGRGeometryH OGR_G_Value | ( | OGRGeometryH | hGeom,
|  | double | dfDistance
| ) |  |

Fetch point at given distance along curve.

This function relates to the SF COM ICurve::get_Value() method.

This function is the same as the C++ method OGRCurve::Value().

Parameters

  hGeom | curve geometry.
  dfDistance | distance along the curve at which to sample position. This distance should be between zero and get_Length() for this curve.

Returns
  a point or NULL.

Since
  GDAL 2.0

int OGR_G_Within | ( | OGRGeometryH | hThis,
|  | OGRGeometryH | hOther
| ) |  |

Test for containment.

Tests if this geometry is within the other geometry.

This function is the same as the C++ method OGRGeometry::Within().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  hThis | the geometry to compare.
  hOther | the other geometry to compare.

Returns
  TRUE if hThis is within hOther, otherwise FALSE.

int OGR_G_WkbSize | ( | OGRGeometryH | hGeom | ) |

Returns size of related binary representation.

This function returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This function relates to the SFCOM IWks::WkbSize() method.

This function is the same as the CPP method OGRGeometry::WkbSize().

Parameters

  hGeom | handle on the geometry to get the binary size from.

Returns
  size of binary representation in bytes.

const char* OGR_GetFieldSubTypeName | ( | OGRFieldSubType | eSubType | ) |

Fetch human readable name for a field subtype.

This function is the same as the CPP method OGRFieldDefn::GetFieldSubTypeName().

Parameters

  eSubType | the field subtype to get name for.

Returns
  the name.

Since
  GDAL 2.0

const char* OGR_GetFieldTypeName | ( | OGRFieldType | eType | ) |

Fetch human readable name for a field type.

This function is the same as the CPP method OGRFieldDefn::GetFieldTypeName().

Parameters

  eType | the field type to get name for.

Returns
  the name.

OGRGeomFieldDefnH OGR_GFld_Create | ( | const char * | pszName,
|  | OGRwkbGeometryType | eType
| ) |  |

Create a new field geometry definition.

This function is the same as the CPP method OGRGeomFieldDefn::OGRGeomFieldDefn().

Parameters

  pszName | the name of the new field definition.
  eType | the type of the new field definition.

Returns
  handle to the new field definition.

Since
  GDAL 1.11

void OGR_GFld_Destroy | ( | OGRGeomFieldDefnH | hDefn | ) |

Destroy a geometry field definition.

Parameters

  hDefn | handle to the geometry field definition to destroy.

Since
  GDAL 1.11

const char* OGR_GFld_GetNameRef | ( | OGRGeomFieldDefnH | hDefn | ) |

Fetch name of this field.

This function is the same as the CPP method OGRGeomFieldDefn::GetNameRef().

Parameters

  hDefn | handle to the geometry field definition.

Returns
  the name of the geometry field definition.

Since
  GDAL 1.11

OGRSpatialReferenceH OGR_GFld_GetSpatialRef | ( | OGRGeomFieldDefnH | hDefn | ) |

Fetch spatial reference system of this field.

This function is the same as the C++ method OGRGeomFieldDefn::GetSpatialRef().

Parameters

  hDefn | handle to the geometry field definition

Returns
  field spatial reference system.

Since
  GDAL 1.11

OGRwkbGeometryType OGR_GFld_GetType | ( | OGRGeomFieldDefnH | hDefn | ) |

Fetch geometry type of this field.

This function is the same as the CPP method OGRGeomFieldDefn::GetType().

Parameters

  hDefn | handle to the geometry field definition to get type from.

Returns
  field geometry type.

Since
  GDAL 1.11

int OGR_GFld_IsIgnored | ( | OGRGeomFieldDefnH | hDefn | ) |

Return whether this field should be omitted when fetching features.

This method is the same as the C++ method OGRGeomFieldDefn::IsIgnored().

Parameters

  hDefn | handle to the geometry field definition

Returns
  ignore state

Since
  GDAL 1.11

int OGR_GFld_IsNullable | ( | OGRGeomFieldDefnH | hDefn | ) |

Return whether this geometry field can receive null values.

By default, fields are nullable.

Even if this method returns FALSE (i.e not-nullable field), it doesn't mean that OGRFeature::IsFieldSet() will necessary return TRUE, as fields can be temporary unset and null/not-null validation is usually done when OGRLayer::CreateFeature()/SetFeature() is called.

Note that not-nullable geometry fields might also contain 'empty' geometries.

This method is the same as the C++ method OGRGeomFieldDefn::IsNullable().

Parameters

  hDefn | handle to the field definition

Returns
  TRUE if the field is authorized to be null.

Since
  GDAL 2.0

void OGR_GFld_SetIgnored | ( | OGRGeomFieldDefnH | hDefn,
|  | int | ignore
| ) |  |

Set whether this field should be omitted when fetching features.

This method is the same as the C++ method OGRGeomFieldDefn::SetIgnored().

Parameters

  hDefn | handle to the geometry field definition
  ignore | ignore state

Since
  GDAL 1.11

void OGR_GFld_SetName | ( | OGRGeomFieldDefnH | hDefn,
|  | const char * | pszName
| ) |  |

Reset the name of this field.

This function is the same as the CPP method OGRGeomFieldDefn::SetName().

Parameters

  hDefn | handle to the geometry field definition to apply the new name to.
  pszName | the new name to apply.

Since
  GDAL 1.11

void OGR_GFld_SetNullable | ( | OGRGeomFieldDefnH | hDefn,
|  | int | bNullableIn
| ) |  |

Set whether this geometry field can receive null values.

By default, fields are nullable, so this method is generally called with FALSE to set a not-null constraint.

Drivers that support writing not-null constraint will advertize the GDAL_DCAP_NOTNULL_GEOMFIELDS driver metadata item.

This method is the same as the C++ method OGRGeomFieldDefn::SetNullable().

Parameters

  hDefn | handle to the field definition
  bNullableIn | FALSE if the field must have a not-null constraint.

Since
  GDAL 2.0

void OGR_GFld_SetSpatialRef | ( | OGRGeomFieldDefnH | hDefn,
|  | OGRSpatialReferenceH | hSRS
| ) |  |

Set the spatial reference of this field.

This function is the same as the C++ method OGRGeomFieldDefn::SetSpatialRef().

This function drops the reference of the previously set SRS object and acquires a new reference on the passed object (if non-NULL).

Parameters

  hDefn | handle to the geometry field definition
  hSRS | the new SRS to apply.

Since
  GDAL 1.11

void OGR_GFld_SetType | ( | OGRGeomFieldDefnH | hDefn,
|  | OGRwkbGeometryType | eType
| ) |  |

Set the geometry type of this field.

This should never be done to an OGRGeomFieldDefn that is already part of an OGRFeatureDefn.

This function is the same as the CPP method OGRGeomFieldDefn::SetType().

Parameters

  hDefn | handle to the geometry field definition to set type to.
  eType | the new field geometry type.

Since
  GDAL 1.11

OGRErr OGR_L_AlterFieldDefn | ( | OGRLayerH | hLayer,
|  | int | iField,
|  | OGRFieldDefnH | hNewFieldDefn,
|  | int | nFlags
| ) |  |

Alter the definition of an existing field on a layer.

You must use this to alter the definition of an existing field of a real layer. Internally the OGRFeatureDefn for the layer will be updated to reflect the altered field. Applications should never modify the OGRFeatureDefn used by a layer directly.

This function should not be called while there are feature objects in existence that were obtained or created with the previous layer definition.

Not all drivers support this function. You can query a layer to check if it supports it with the OLCAlterFieldDefn capability. Some drivers may only support this method while there are still no features in the layer. When it is supported, the existing features of the backing file/database should be updated accordingly. Some drivers might also not support all update flags.

This function is the same as the C++ method OGRLayer::AlterFieldDefn().

Parameters

  hLayer | handle to the layer.
  iField | index of the field whose definition must be altered.
  hNewFieldDefn | new field definition
  nFlags | combination of ALTER_NAME_FLAG, ALTER_TYPE_FLAG, ALTER_WIDTH_PRECISION_FLAG, ALTER_NULLABLE_FLAG and ALTER_DEFAULT_FLAG to indicate which of the name and/or type and/or width and precision fields and/or nullability from the new field definition must be taken into account.

Returns
  OGRERR_NONE on success.

Since
  OGR 1.9.0

OGRErr OGR_L_Clip | ( | OGRLayerH | pLayerInput,
|  | OGRLayerH | pLayerMethod,
|  | OGRLayerH | pLayerResult,
|  | char ** | papszOptions,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressArg
| ) |  |

Clip off areas that are not covered by the method layer.

The result layer contains features whose geometries represent areas that are in the input layer and in the method layer. The features in the result layer have the (possibly clipped) areas of features in the input layer and the attributes from the same features. The schema of the result layer can be set by the user or, if it is empty, is initialized to contain all fields in the input layer.

Note
  For best performance use the minimum amount of features in the method layer and copy it into a memory layer.
  This method relies on GEOS support. Do not use unless the GEOS support is compiled in.

The recognized list of options is :

- SKIP_FAILURES=YES/NO. Set it to YES to go on, even when a feature could not be inserted or a GEOS call failed.
- PROMOTE_TO_MULTI=YES/NO. Set it to YES to convert Polygons into MultiPolygons, or LineStrings to MultiLineStrings.
- INPUT_PREFIX=string. Set a prefix for the field names that will be created from the fields of the input layer.
- METHOD_PREFIX=string. Set a prefix for the field names that will be created from the fields of the method layer.

This function is the same as the C++ method OGRLayer::Clip().

Parameters

  pLayerInput | the input layer. Should not be NULL.
  pLayerMethod | the method layer. Should not be NULL.
  pLayerResult | the layer where the features resulting from the operation are inserted. Should not be NULL. See above the note about the schema.
  papszOptions | NULL terminated list of options (may be NULL).
  pfnProgress | a GDALProgressFunc() compatible callback function for reporting progress or NULL.
  pProgressArg | argument to be passed to pfnProgress. May be NULL.

Returns
  an error code if there was an error or the execution was interrupted, OGRERR_NONE otherwise.

Note
  The first geometry field is always used.

Since
  OGR 1.10

OGRErr OGR_L_CommitTransaction | ( | OGRLayerH | hLayer | ) |

For datasources which support transactions, CommitTransaction commits a transaction.

If no transaction is active, or the commit fails, will return OGRERR_FAILURE. Datasources which do not support transactions will always return OGRERR_NONE.

This function is the same as the C++ method OGRLayer::CommitTransaction().

Parameters

  hLayer | handle to the layer

Returns
  OGRERR_NONE on success.

OGRErr OGR_L_CreateFeature | ( | OGRLayerH | hLayer,
|  | OGRFeatureH | hFeat
| ) |  |

Create and write a new feature within a layer.

The passed feature is written to the layer as a new feature, rather than overwriting an existing one. If the feature has a feature id other than OGRNullFID, then the native implementation may use that as the feature id of the new feature, but not necessarily. Upon successful return the passed feature will have been updated with the new feature id.

This function is the same as the C++ method OGRLayer::CreateFeature().

Parameters

  hLayer | handle to the layer to write the feature to.
  hFeat | the handle of the feature to write to disk.

Returns
  OGRERR_NONE on success.

OGRErr OGR_L_CreateField | ( | OGRLayerH | hLayer,
|  | OGRFieldDefnH | hField,
|  | int | bApproxOK
| ) |  |

Create a new field on a layer.

You must use this to create new fields on a real layer. Internally the OGRFeatureDefn for the layer will be updated to reflect the new field. Applications should never modify the OGRFeatureDefn used by a layer directly.

This function should not be called while there are feature objects in existence that were obtained or created with the previous layer definition.

Not all drivers support this function. You can query a layer to check if it supports it with the OLCCreateField capability. Some drivers may only support this method while there are still no features in the layer. When it is supported, the existing features of the backing file/database should be updated accordingly.

Drivers may or may not support not-null constraints. If they support creating fields with not-null constraints, this is generally before creating any feature to the layer.

This function is the same as the C++ method OGRLayer::CreateField().

Parameters

  hLayer | handle to the layer to write the field definition.
  hField | handle of the field definition to write to disk.
  bApproxOK | If TRUE, the field may be created in a slightly different form depending on the limitations of the format driver.

Returns
  OGRERR_NONE on success.

OGRErr OGR_L_CreateGeomField | ( | OGRLayerH | hLayer,
|  | OGRGeomFieldDefnH | hField,
|  | int | bApproxOK
| ) |  |

Create a new geometry field on a layer.

You must use this to create new geometry fields on a real layer. Internally the OGRFeatureDefn for the layer will be updated to reflect the new field. Applications should never modify the OGRFeatureDefn used by a layer directly.

This function should not be called while there are feature objects in existence that were obtained or created with the previous layer definition.

Not all drivers support this function. You can query a layer to check if it supports it with the OLCCreateField capability. Some drivers may only support this method while there are still no features in the layer. When it is supported, the existing features of the backing file/database should be updated accordingly.

Drivers may or may not support not-null constraints. If they support creating fields with not-null constraints, this is generally before creating any feature to the layer.

This function is the same as the C++ method OGRLayer::CreateField().

Parameters

  hLayer | handle to the layer to write the field definition.
  hField | handle of the geometry field definition to write to disk.
  bApproxOK | If TRUE, the field may be created in a slightly different form depending on the limitations of the format driver.

Returns
  OGRERR_NONE on success.

Since
  OGR 1.11

OGRErr OGR_L_DeleteFeature | ( | OGRLayerH | hLayer,
|  | GIntBig | nFID
| ) |  |

Delete feature from layer.

The feature with the indicated feature id is deleted from the layer if supported by the driver. Most drivers do not support feature deletion, and will return OGRERR_UNSUPPORTED_OPERATION. The OGR_L_TestCapability() function may be called with OLCDeleteFeature to check if the driver supports feature deletion.

This method is the same as the C++ method OGRLayer::DeleteFeature().

Parameters

  hLayer | handle to the layer
  nFID | the feature id to be deleted from the layer

Returns
  OGRERR_NONE if the operation works, otherwise an appropriate error code (e.g OGRERR_NON_EXISTING_FEATURE if the feature does not exist).

OGRErr OGR_L_DeleteField | ( | OGRLayerH | hLayer,
|  | int | iField
| ) |  |

Delete an existing field on a layer.

You must use this to delete existing fields on a real layer. Internally the OGRFeatureDefn for the layer will be updated to reflect the deleted field. Applications should never modify the OGRFeatureDefn used by a layer directly.

This function should not be called while there are feature objects in existence that were obtained or created with the previous layer definition.

Not all drivers support this function. You can query a layer to check if it supports it with the OLCDeleteField capability. Some drivers may only support this method while there are still no features in the layer. When it is supported, the existing features of the backing file/database should be updated accordingly.

This function is the same as the C++ method OGRLayer::DeleteField().

Parameters

  hLayer | handle to the layer.
  iField | index of the field to delete.

Returns
  OGRERR_NONE on success.

Since
  OGR 1.9.0

OGRErr OGR_L_Erase | ( | OGRLayerH | pLayerInput,
|  | OGRLayerH | pLayerMethod,
|  | OGRLayerH | pLayerResult,
|  | char ** | papszOptions,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressArg
| ) |  |

Remove areas that are covered by the method layer.

The result layer contains features whose geometries represent areas that are in the input layer but not in the method layer. The features in the result layer have attributes from the input layer. The schema of the result layer can be set by the user or, if it is empty, is initialized to contain all fields in the input layer.

Note
  For best performance use the minimum amount of features in the method layer and copy it into a memory layer.
  This method relies on GEOS support. Do not use unless the GEOS support is compiled in.

The recognized list of options is :

- SKIP_FAILURES=YES/NO. Set it to YES to go on, even when a feature could not be inserted or a GEOS call failed.
- PROMOTE_TO_MULTI=YES/NO. Set it to YES to convert Polygons into MultiPolygons, or LineStrings to MultiLineStrings.
- INPUT_PREFIX=string. Set a prefix for the field names that will be created from the fields of the input layer.
- METHOD_PREFIX=string. Set a prefix for the field names that will be created from the fields of the method layer.

This function is the same as the C++ method OGRLayer::Erase().

Parameters

  pLayerInput | the input layer. Should not be NULL.
  pLayerMethod | the method layer. Should not be NULL.
  pLayerResult | the layer where the features resulting from the operation are inserted. Should not be NULL. See above the note about the schema.
  papszOptions | NULL terminated list of options (may be NULL).
  pfnProgress | a GDALProgressFunc() compatible callback function for reporting progress or NULL.
  pProgressArg | argument to be passed to pfnProgress. May be NULL.

Returns
  an error code if there was an error or the execution was interrupted, OGRERR_NONE otherwise.

Note
  The first geometry field is always used.

Since
  OGR 1.10

int OGR_L_FindFieldIndex | ( | OGRLayerH | hLayer,
|  | const char * | ,
|  | int | bExactMatch
| ) |  |

Find the index of field in a layer.

The returned number is the index of the field in the layers, or -1 if the field doesn't exist.

If bExactMatch is set to FALSE and the field doesn't exists in the given form the driver might apply some changes to make it match, like those it might do if the layer was created (eg. like LAUNDER in the OCI driver).

This method is the same as the C++ method OGRLayer::FindFieldIndex().

Returns
  field index, or -1 if the field doesn't exist

OGRErr OGR_L_GetExtent | ( | OGRLayerH | hLayer,
|  | OGREnvelope * | psExtent,
|  | int | bForce
| ) |  |

Fetch the extent of this layer.

Returns the extent (MBR) of the data in the layer. If bForce is FALSE, and it would be expensive to establish the extent then OGRERR_FAILURE will be returned indicating that the extent isn't know. If bForce is TRUE then some implementations will actually scan the entire layer once to compute the MBR of all the features in the layer.

Depending on the drivers, the returned extent may or may not take the spatial filter into account. So it is safer to call OGR_L_GetExtent() without setting a spatial filter.

Layers without any geometry may return OGRERR_FAILURE just indicating that no meaningful extents could be collected.

Note that some implementations of this method may alter the read cursor of the layer.

This function is the same as the C++ method OGRLayer::GetExtent().

Parameters

  hLayer | handle to the layer from which to get extent.
  psExtent | the structure in which the extent value will be returned.
  bForce | Flag indicating whether the extent should be computed even if it is expensive.

Returns
  OGRERR_NONE on success, OGRERR_FAILURE if extent not known.

OGRErr OGR_L_GetExtentEx | ( | OGRLayerH | hLayer,
|  | int | iGeomField,
|  | OGREnvelope * | psExtent,
|  | int | bForce
| ) |  |

Fetch the extent of this layer, on the specified geometry field.

Returns the extent (MBR) of the data in the layer. If bForce is FALSE, and it would be expensive to establish the extent then OGRERR_FAILURE will be returned indicating that the extent isn't know. If bForce is TRUE then some implementations will actually scan the entire layer once to compute the MBR of all the features in the layer.

Depending on the drivers, the returned extent may or may not take the spatial filter into account. So it is safer to call OGR_L_GetExtent() without setting a spatial filter.

Layers without any geometry may return OGRERR_FAILURE just indicating that no meaningful extents could be collected.

Note that some implementations of this method may alter the read cursor of the layer.

This function is the same as the C++ method OGRLayer::GetExtent().

Parameters

  hLayer | handle to the layer from which to get extent.
  iGeomField | the index of the geometry field on which to compute the extent.
  psExtent | the structure in which the extent value will be returned.
  bForce | Flag indicating whether the extent should be computed even if it is expensive.

Returns
  OGRERR_NONE on success, OGRERR_FAILURE if extent not known.

OGRFeatureH OGR_L_GetFeature | ( | OGRLayerH | hLayer,
|  | GIntBig | nFeatureId
| ) |  |

Fetch a feature by its identifier.

This function will attempt to read the identified feature. The nFID value cannot be OGRNullFID. Success or failure of this operation is unaffected by the spatial or attribute filters (and specialized implementations in drivers should make sure that they do not take into account spatial or attribute filters).

If this function returns a non-NULL feature, it is guaranteed that its feature id (OGR_F_GetFID()) will be the same as nFID.

Use OGR_L_TestCapability(OLCRandomRead) to establish if this layer supports efficient random access reading via OGR_L_GetFeature(); however, the call should always work if the feature exists as a fallback implementation just scans all the features in the layer looking for the desired feature.

Sequential reads (with OGR_L_GetNextFeature()) are generally considered interrupted by a OGR_L_GetFeature() call.

The returned feature should be free with OGR_F_Destroy().

This function is the same as the C++ method OGRLayer::GetFeature( ).

Parameters

  hLayer | handle to the layer that owned the feature.
  nFeatureId | the feature id of the feature to read.

Returns
  an handle to a feature now owned by the caller, or NULL on failure.

GIntBig OGR_L_GetFeatureCount | ( | OGRLayerH | hLayer,
|  | int | bForce
| ) |  |

Fetch the feature count in this layer.

Returns the number of features in the layer. For dynamic databases the count may not be exact. If bForce is FALSE, and it would be expensive to establish the feature count a value of -1 may be returned indicating that the count isn't know. If bForce is TRUE some implementations will actually scan the entire layer once to count objects.

The returned count takes the spatial filter into account.

Note that some implementations of this method may alter the read cursor of the layer.

This function is the same as the CPP OGRLayer::GetFeatureCount().

Note: since GDAL 2.0, this method returns a GIntBig (previously a int)

Parameters

  hLayer | handle to the layer that owned the features.
  bForce | Flag indicating whether the count should be computed even if it is expensive.

Returns
  feature count, -1 if count not known.

const char * OGR_L_GetFIDColumn | ( | OGRLayerH | hLayer | ) |

This method returns the name of the underlying database column being used as the FID column, or "" if not supported.

This method is the same as the C++ method OGRLayer::GetFIDColumn()

Parameters

  hLayer | handle to the layer

Returns
  fid column name.

const char * OGR_L_GetGeometryColumn | ( | OGRLayerH | hLayer | ) |

This method returns the name of the underlying database column being used as the geometry column, or "" if not supported.

For layers with multiple geometry fields, this method only returns the geometry type of the first geometry column. For other columns, use OGR_GFld_GetNameRef(OGR_FD_GetGeomFieldDefn(OGR_L_GetLayerDefn(hLayer), i)).

This method is the same as the C++ method OGRLayer::GetGeometryColumn()

Parameters

  hLayer | handle to the layer

Returns
  geometry column name.

OGRwkbGeometryType OGR_L_GetGeomType | ( | OGRLayerH | hLayer | ) |

Return the layer geometry type.

This returns the same result as OGR_FD_GetGeomType(OGR_L_GetLayerDefn(hLayer)), but for a few drivers, calling OGR_L_GetGeomType() directly can avoid lengthy layer definition initialization.

For layers with multiple geometry fields, this method only returns the geometry type of the first geometry column. For other columns, use OGR_GFld_GetType(OGR_FD_GetGeomFieldDefn(OGR_L_GetLayerDefn(hLayer), i)). For layers without any geometry field, this method returns wkbNone.

This function is the same as the C++ method OGRLayer::GetGeomType().

Parameters

  hLayer | handle to the layer.

Returns
  the geometry type

Since
  OGR 1.8.0

OGRFeatureDefnH OGR_L_GetLayerDefn | ( | OGRLayerH | hLayer | ) |

Fetch the schema information for this layer.

The returned handle to the OGRFeatureDefn is owned by the OGRLayer, and should not be modified or freed by the application. It encapsulates the attribute schema of the features of the layer.

This function is the same as the C++ method OGRLayer::GetLayerDefn().

Parameters

  hLayer | handle to the layer to get the schema information.

Returns
  an handle to the feature definition.

const char * OGR_L_GetName | ( | OGRLayerH | hLayer | ) |

Return the layer name.

This returns the same content as OGR_FD_GetName(OGR_L_GetLayerDefn(hLayer)), but for a few drivers, calling OGR_L_GetName() directly can avoid lengthy layer definition initialization.

This function is the same as the C++ method OGRLayer::GetName().

Parameters

  hLayer | handle to the layer.

Returns
  the layer name (must not been freed)

Since
  OGR 1.8.0

OGRFeatureH OGR_L_GetNextFeature | ( | OGRLayerH | hLayer | ) |

Fetch the next available feature from this layer.

The returned feature becomes the responsibility of the caller to delete with OGR_F_Destroy(). It is critical that all features associated with an OGRLayer (more specifically an OGRFeatureDefn) be deleted before that layer/datasource is deleted.

Only features matching the current spatial filter (set with SetSpatialFilter()) will be returned.

This function implements sequential access to the features of a layer. The OGR_L_ResetReading() function can be used to start at the beginning again.

Features returned by OGR_GetNextFeature() may or may not be affected by concurrent modifications depending on drivers. A guaranteed way of seeing modifications in effect is to call OGR_L_ResetReading() on layers where OGR_GetNextFeature() has been called, before reading again. Structural changes in layers (field addition, deletion, ...) when a read is in progress may or may not be possible depending on drivers. If a transaction is committed/aborted, the current sequential reading may or may not be valid after that operation and a call to OGR_L_ResetReading() might be needed.

This function is the same as the C++ method OGRLayer::GetNextFeature().

Parameters

  hLayer | handle to the layer from which feature are read.

Returns
  an handle to a feature, or NULL if no more features are available.

OGRGeometryH OGR_L_GetSpatialFilter | ( | OGRLayerH | hLayer | ) |

This function returns the current spatial filter for this layer.

The returned pointer is to an internally owned object, and should not be altered or deleted by the caller.

This function is the same as the C++ method OGRLayer::GetSpatialFilter().

Parameters

  hLayer | handle to the layer to get the spatial filter from.

Returns
  an handle to the spatial filter geometry.

OGRSpatialReferenceH OGR_L_GetSpatialRef | ( | OGRLayerH | hLayer | ) |

Fetch the spatial reference system for this layer.

The returned object is owned by the OGRLayer and should not be modified or freed by the application.

This function is the same as the C++ method OGRLayer::GetSpatialRef().

Parameters

  hLayer | handle to the layer to get the spatial reference from.

Returns
  spatial reference, or NULL if there isn't one.

OGRErr OGR_L_Identity | ( | OGRLayerH | pLayerInput,
|  | OGRLayerH | pLayerMethod,
|  | OGRLayerH | pLayerResult,
|  | char ** | papszOptions,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressArg
| ) |  |

Identify the features of this layer with the ones from the identity layer.

The result layer contains features whose geometries represent areas that are in the input layer. The features in the result layer have attributes from both input and method layers. The schema of the result layer can be set by the user or, if it is empty, is initialized to contain all fields in input and method layers.

Note
  If the schema of the result is set by user and contains fields that have the same name as a field in input and in method layer, then the attribute in the result feature will get the value from the feature of the method layer (even if it is undefined).
  For best performance use the minimum amount of features in the method layer and copy it into a memory layer.
  This method relies on GEOS support. Do not use unless the GEOS support is compiled in.

The recognized list of options is :

- SKIP_FAILURES=YES/NO. Set it to YES to go on, even when a feature could not be inserted or a GEOS call failed.
- PROMOTE_TO_MULTI=YES/NO. Set it to YES to convert Polygons into MultiPolygons, or LineStrings to MultiLineStrings.
- INPUT_PREFIX=string. Set a prefix for the field names that will be created from the fields of the input layer.
- METHOD_PREFIX=string. Set a prefix for the field names that will be created from the fields of the method layer.
- USE_PREPARED_GEOMETRIES=YES/NO. Set to NO to not use prepared geometries to pretest intersection of features of method layer with features of this layer.
- KEEP_LOWER_DIMENSION_GEOMETRIES=YES/NO. Set to NO to skip result features with lower dimension geometry that would otherwise be added to the result layer. The default is to add but only if the result layer has an unknown geometry type.

This function is the same as the C++ method OGRLayer::Identity().

Parameters

  pLayerInput | the input layer. Should not be NULL.
  pLayerMethod | the method layer. Should not be NULL.
  pLayerResult | the layer where the features resulting from the operation are inserted. Should not be NULL. See above the note about the schema.
  papszOptions | NULL terminated list of options (may be NULL).
  pfnProgress | a GDALProgressFunc() compatible callback function for reporting progress or NULL.
  pProgressArg | argument to be passed to pfnProgress. May be NULL.

Returns
  an error code if there was an error or the execution was interrupted, OGRERR_NONE otherwise.

Note
  The first geometry field is always used.

Since
  OGR 1.10

OGRErr OGR_L_Intersection | ( | OGRLayerH | pLayerInput,
|  | OGRLayerH | pLayerMethod,
|  | OGRLayerH | pLayerResult,
|  | char ** | papszOptions,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressArg
| ) |  |

Intersection of two layers.

The result layer contains features whose geometries represent areas that are common between features in the input layer and in the method layer. The features in the result layer have attributes from both input and method layers. The schema of the result layer can be set by the user or, if it is empty, is initialized to contain all fields in the input and method layers.

Note
  If the schema of the result is set by user and contains fields that have the same name as a field in input and in method layer, then the attribute in the result feature will get the value from the feature of the method layer.
  For best performance use the minimum amount of features in the method layer and copy it into a memory layer.
  This method relies on GEOS support. Do not use unless the GEOS support is compiled in.

The recognized list of options is :

- SKIP_FAILURES=YES/NO. Set it to YES to go on, even when a feature could not be inserted or a GEOS call failed.
- PROMOTE_TO_MULTI=YES/NO. Set it to YES to convert Polygons into MultiPolygons, or LineStrings to MultiLineStrings.
- INPUT_PREFIX=string. Set a prefix for the field names that will be created from the fields of the input layer.
- METHOD_PREFIX=string. Set a prefix for the field names that will be created from the fields of the method layer.
- USE_PREPARED_GEOMETRIES=YES/NO. Set to NO to not use prepared geometries to pretest intersection of features of method layer with features of this layer.
- PRETEST_CONTAINMENT=YES/NO. Set to YES to pretest the containment of features of method layer within the features of this layer. This will speed up the method significantly in some cases. Requires that the prepared geometries are in effect.
- KEEP_LOWER_DIMENSION_GEOMETRIES=YES/NO. Set to NO to skip result features with lower dimension geometry that would otherwise be added to the result layer. The default is to add but only if the result layer has an unknown geometry type.

This function is the same as the C++ method OGRLayer::Intersection().

Parameters

  pLayerInput | the input layer. Should not be NULL.
  pLayerMethod | the method layer. Should not be NULL.
  pLayerResult | the layer where the features resulting from the operation are inserted. Should not be NULL. See above the note about the schema.
  papszOptions | NULL terminated list of options (may be NULL).
  pfnProgress | a GDALProgressFunc() compatible callback function for reporting progress or NULL.
  pProgressArg | argument to be passed to pfnProgress. May be NULL.

Returns
  an error code if there was an error or the execution was interrupted, OGRERR_NONE otherwise.

Note
  The first geometry field is always used.

Since
  OGR 1.10

OGRErr OGR_L_ReorderField | ( | OGRLayerH | hLayer,
|  | int | iOldFieldPos,
|  | int | iNewFieldPos
| ) |  |

Reorder an existing field on a layer.

This function is a convenience wrapper of OGR_L_ReorderFields() dedicated to move a single field.

You must use this to reorder existing fields on a real layer. Internally the OGRFeatureDefn for the layer will be updated to reflect the reordering of the fields. Applications should never modify the OGRFeatureDefn used by a layer directly.

This function should not be called while there are feature objects in existence that were obtained or created with the previous layer definition.

The field definition that was at initial position iOldFieldPos will be moved at position iNewFieldPos, and elements between will be shuffled accordingly.

For example, let suppose the fields were "0","1","2","3","4" initially. ReorderField(1, 3) will reorder them as "0","2","3","1","4".

Not all drivers support this function. You can query a layer to check if it supports it with the OLCReorderFields capability. Some drivers may only support this method while there are still no features in the layer. When it is supported, the existing features of the backing file/database should be updated accordingly.

This function is the same as the C++ method OGRLayer::ReorderField().

Parameters

  hLayer | handle to the layer.
  iOldFieldPos | previous position of the field to move. Must be in the range [0,GetFieldCount()-1].
  iNewFieldPos | new position of the field to move. Must be in the range [0,GetFieldCount()-1].

Returns
  OGRERR_NONE on success.

Since
  OGR 1.9.0

OGRErr OGR_L_ReorderFields | ( | OGRLayerH | hLayer,
|  | int * | panMap
| ) |  |

Reorder all the fields of a layer.

You must use this to reorder existing fields on a real layer. Internally the OGRFeatureDefn for the layer will be updated to reflect the reordering of the fields. Applications should never modify the OGRFeatureDefn used by a layer directly.

This function should not be called while there are feature objects in existence that were obtained or created with the previous layer definition.

panMap is such that,for each field definition at position i after reordering, its position before reordering was panMap[i].

For example, let suppose the fields were "0","1","2","3","4" initially. ReorderFields([0,2,3,1,4]) will reorder them as "0","2","3","1","4".

Not all drivers support this function. You can query a layer to check if it supports it with the OLCReorderFields capability. Some drivers may only support this method while there are still no features in the layer. When it is supported, the existing features of the backing file/database should be updated accordingly.

This function is the same as the C++ method OGRLayer::ReorderFields().

Parameters

  hLayer | handle to the layer.
  panMap | an array of GetLayerDefn()->OGRFeatureDefn::GetFieldCount() elements which is a permutation of [0, GetLayerDefn()->OGRFeatureDefn::GetFieldCount()-1].

Returns
  OGRERR_NONE on success.

Since
  OGR 1.9.0

void OGR_L_ResetReading | ( | OGRLayerH | hLayer | ) |

Reset feature reading to start on the first feature.

This affects GetNextFeature().

This function is the same as the C++ method OGRLayer::ResetReading().

Parameters

  hLayer | handle to the layer on which features are read.

OGRErr OGR_L_RollbackTransaction | ( | OGRLayerH | hLayer | ) |

For datasources which support transactions, RollbackTransaction will roll back a datasource to its state before the start of the current transaction.

If no transaction is active, or the rollback fails, will return OGRERR_FAILURE. Datasources which do not support transactions will always return OGRERR_NONE.

This function is the same as the C++ method OGRLayer::RollbackTransaction().

Parameters

  hLayer | handle to the layer

Returns
  OGRERR_NONE on success.

OGRErr OGR_L_SetAttributeFilter | ( | OGRLayerH | hLayer,
|  | const char * | pszQuery
| ) |  |

Set a new attribute query.

This function sets the attribute query string to be used when fetching features via the OGR_L_GetNextFeature() function. Only features for which the query evaluates as true will be returned.

The query string should be in the format of an SQL WHERE clause. For instance "population > 1000000 and population < 5000000" where population is an attribute in the layer. The query format is a restricted form of SQL WHERE clause as defined "eq_format=restricted_where" about half way through this document:

http://ogdi.sourceforge.net/prop/6.2.CapabilitiesMetadata.html

Note that installing a query string will generally result in resetting the current reading position (ala OGR_L_ResetReading()).

This function is the same as the C++ method OGRLayer::SetAttributeFilter().

Parameters

  hLayer | handle to the layer on which attribute query will be executed.
  pszQuery | query in restricted SQL WHERE format, or NULL to clear the current query.

Returns
  OGRERR_NONE if successfully installed, or an error code if the query expression is in error, or some other failure occurs.

OGRErr OGR_L_SetFeature | ( | OGRLayerH | hLayer,
|  | OGRFeatureH | hFeat
| ) |  |

Rewrite an existing feature.

This function will write a feature to the layer, based on the feature id within the OGRFeature.

Use OGR_L_TestCapability(OLCRandomWrite) to establish if this layer supports random access writing via OGR_L_SetFeature().

This function is the same as the C++ method OGRLayer::SetFeature().

Parameters

  hLayer | handle to the layer to write the feature.
  hFeat | the feature to write.

Returns
  OGRERR_NONE if the operation works, otherwise an appropriate error code (e.g OGRERR_NON_EXISTING_FEATURE if the feature does not exist).

OGRErr OGR_L_SetIgnoredFields | ( | OGRLayerH | ,
|  | const char ** | papszFields
| ) |  |

Set which fields can be omitted when retrieving features from the layer.

If the driver supports this functionality (testable using OLCIgnoreFields capability), it will not fetch the specified fields in subsequent calls to GetFeature() / GetNextFeature() and thus save some processing time and/or bandwidth.

Besides field names of the layers, the following special fields can be passed: "OGR_GEOMETRY" to ignore geometry and "OGR_STYLE" to ignore layer style.

By default, no fields are ignored.

This method is the same as the C++ method OGRLayer::SetIgnoredFields()

Parameters

  papszFields | an array of field names terminated by NULL item. If NULL is passed, the ignored list is cleared.

Returns
  OGRERR_NONE if all field names have been resolved (even if the driver does not support this method)

OGRErr OGR_L_SetNextByIndex | ( | OGRLayerH | hLayer,
|  | GIntBig | nIndex
| ) |  |

Move read cursor to the nIndex'th feature in the current resultset.

This method allows positioning of a layer such that the GetNextFeature() call will read the requested feature, where nIndex is an absolute index into the current result set. So, setting it to 3 would mean the next feature read with GetNextFeature() would have been the 4th feature to have been read if sequential reading took place from the beginning of the layer, including accounting for spatial and attribute filters.

Only in rare circumstances is SetNextByIndex() efficiently implemented. In all other cases the default implementation which calls ResetReading() and then calls GetNextFeature() nIndex times is used. To determine if fast seeking is available on the current layer use the TestCapability() method with a value of OLCFastSetNextByIndex.

This method is the same as the C++ method OGRLayer::SetNextByIndex()

Parameters

  hLayer | handle to the layer
  nIndex | the index indicating how many steps into the result set to seek.

Returns
  OGRERR_NONE on success or an error code.

void OGR_L_SetSpatialFilter | ( | OGRLayerH | hLayer,
|  | OGRGeometryH | hGeom
| ) |  |

Set a new spatial filter.

This function set the geometry to be used as a spatial filter when fetching features via the OGR_L_GetNextFeature() function. Only features that geometrically intersect the filter geometry will be returned.

Currently this test is may be inaccurately implemented, but it is guaranteed that all features who's envelope (as returned by OGR_G_GetEnvelope()) overlaps the envelope of the spatial filter will be returned. This can result in more shapes being returned that should strictly be the case.

This function makes an internal copy of the passed geometry. The passed geometry remains the responsibility of the caller, and may be safely destroyed.

For the time being the passed filter geometry should be in the same SRS as the layer (as returned by OGR_L_GetSpatialRef()). In the future this may be generalized.

This function is the same as the C++ method OGRLayer::SetSpatialFilter.

Parameters

  hLayer | handle to the layer on which to set the spatial filter.
  hGeom | handle to the geometry to use as a filtering region. NULL may be passed indicating that the current spatial filter should be cleared, but no new one instituted.

void OGR_L_SetSpatialFilterEx | ( | OGRLayerH | hLayer,
|  | int | iGeomField,
|  | OGRGeometryH | hGeom
| ) |  |

Set a new spatial filter.

This function set the geometry to be used as a spatial filter when fetching features via the OGR_L_GetNextFeature() function. Only features that geometrically intersect the filter geometry will be returned.

Currently this test is may be inaccurately implemented, but it is guaranteed that all features who's envelope (as returned by OGR_G_GetEnvelope()) overlaps the envelope of the spatial filter will be returned. This can result in more shapes being returned that should strictly be the case.

This function makes an internal copy of the passed geometry. The passed geometry remains the responsibility of the caller, and may be safely destroyed.

For the time being the passed filter geometry should be in the same SRS as the geometry field definition it corresponds to (as returned by GetLayerDefn()->OGRFeatureDefn::GetGeomFieldDefn(iGeomField)->GetSpatialRef()). In the future this may be generalized.

Note that only the last spatial filter set is applied, even if several successive calls are done with different iGeomField values.

This function is the same as the C++ method OGRLayer::SetSpatialFilter.

Parameters

  hLayer | handle to the layer on which to set the spatial filter.
  iGeomField | index of the geometry field on which the spatial filter operates.
  hGeom | handle to the geometry to use as a filtering region. NULL may be passed indicating that the current spatial filter should be cleared, but no new one instituted.

Since
  GDAL 1.11

void OGR_L_SetSpatialFilterRect | ( | OGRLayerH | hLayer,
|  | double | dfMinX,
|  | double | dfMinY,
|  | double | dfMaxX,
|  | double | dfMaxY
| ) |  |

Set a new rectangular spatial filter.

This method set rectangle to be used as a spatial filter when fetching features via the OGR_L_GetNextFeature() method. Only features that geometrically intersect the given rectangle will be returned.

The x/y values should be in the same coordinate system as the layer as a whole (as returned by OGRLayer::GetSpatialRef()). Internally this method is normally implemented as creating a 5 vertex closed rectangular polygon and passing it to OGRLayer::SetSpatialFilter(). It exists as a convenience.

The only way to clear a spatial filter set with this method is to call OGRLayer::SetSpatialFilter(NULL).

This method is the same as the C++ method OGRLayer::SetSpatialFilterRect().

Parameters

  hLayer | handle to the layer on which to set the spatial filter.
  dfMinX | the minimum X coordinate for the rectangular region.
  dfMinY | the minimum Y coordinate for the rectangular region.
  dfMaxX | the maximum X coordinate for the rectangular region.
  dfMaxY | the maximum Y coordinate for the rectangular region.

void OGR_L_SetSpatialFilterRectEx | ( | OGRLayerH | hLayer,
|  | int | iGeomField,
|  | double | dfMinX,
|  | double | dfMinY,
|  | double | dfMaxX,
|  | double | dfMaxY
| ) |  |

Set a new rectangular spatial filter.

This method set rectangle to be used as a spatial filter when fetching features via the OGR_L_GetNextFeature() method. Only features that geometrically intersect the given rectangle will be returned.

The x/y values should be in the same coordinate system as as the geometry field definition it corresponds to (as returned by GetLayerDefn()->OGRFeatureDefn::GetGeomFieldDefn(iGeomField)->GetSpatialRef()). Internally this method is normally implemented as creating a 5 vertex closed rectangular polygon and passing it to OGRLayer::SetSpatialFilter(). It exists as a convenience.

The only way to clear a spatial filter set with this method is to call OGRLayer::SetSpatialFilter(NULL).

This method is the same as the C++ method OGRLayer::SetSpatialFilterRect().

Parameters

  hLayer | handle to the layer on which to set the spatial filter.
  iGeomField | index of the geometry field on which the spatial filter operates.
  dfMinX | the minimum X coordinate for the rectangular region.
  dfMinY | the minimum Y coordinate for the rectangular region.
  dfMaxX | the maximum X coordinate for the rectangular region.
  dfMaxY | the maximum Y coordinate for the rectangular region.

Since
  GDAL 1.11

OGRErr OGR_L_StartTransaction | ( | OGRLayerH | hLayer | ) |

For datasources which support transactions, StartTransaction creates a transaction.

If starting the transaction fails, will return OGRERR_FAILURE. Datasources which do not support transactions will always return OGRERR_NONE.

Note: as of GDAL 2.0, use of this API is discouraged when the dataset offers dataset level transaction with GDALDataset::StartTransaction(). The reason is that most drivers can only offer transactions at dataset level, and not layer level. Very few drivers really support transactions at layer scope.

This function is the same as the C++ method OGRLayer::StartTransaction().

Parameters

  hLayer | handle to the layer

Returns
  OGRERR_NONE on success.

OGRErr OGR_L_SymDifference | ( | OGRLayerH | pLayerInput,
|  | OGRLayerH | pLayerMethod,
|  | OGRLayerH | pLayerResult,
|  | char ** | papszOptions,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressArg
| ) |  |

Symmetrical difference of two layers.

The result layer contains features whose geometries represent areas that are in either in the input layer or in the method layer but not in both. The features in the result layer have attributes from both input and method layers. For features which represent areas that are only in the input or in the method layer the respective attributes have undefined values. The schema of the result layer can be set by the user or, if it is empty, is initialized to contain all fields in the input and method layers.

Note
  If the schema of the result is set by user and contains fields that have the same name as a field in input and in method layer, then the attribute in the result feature will get the value from the feature of the method layer (even if it is undefined).
  For best performance use the minimum amount of features in the method layer and copy it into a memory layer.
  This method relies on GEOS support. Do not use unless the GEOS support is compiled in.

The recognized list of options is :

- SKIP_FAILURES=YES/NO. Set it to YES to go on, even when a feature could not be inserted or a GEOS call failed.
- PROMOTE_TO_MULTI=YES/NO. Set it to YES to convert Polygons into MultiPolygons, or LineStrings to MultiLineStrings.
- INPUT_PREFIX=string. Set a prefix for the field names that will be created from the fields of the input layer.
- METHOD_PREFIX=string. Set a prefix for the field names that will be created from the fields of the method layer.

This function is the same as the C++ method OGRLayer::SymDifference().

Parameters

  pLayerInput | the input layer. Should not be NULL.
  pLayerMethod | the method layer. Should not be NULL.
  pLayerResult | the layer where the features resulting from the operation are inserted. Should not be NULL. See above the note about the schema.
  papszOptions | NULL terminated list of options (may be NULL).
  pfnProgress | a GDALProgressFunc() compatible callback function for reporting progress or NULL.
  pProgressArg | argument to be passed to pfnProgress. May be NULL.

Returns
  an error code if there was an error or the execution was interrupted, OGRERR_NONE otherwise.

Note
  The first geometry field is always used.

Since
  OGR 1.10

OGRErr OGR_L_SyncToDisk | ( | OGRLayerH | hLayer | ) |

Flush pending changes to disk.

This call is intended to force the layer to flush any pending writes to disk, and leave the disk file in a consistent state. It would not normally have any effect on read-only datasources.

Some layers do not implement this method, and will still return OGRERR_NONE. The default implementation just returns OGRERR_NONE. An error is only returned if an error occurs while attempting to flush to disk.

In any event, you should always close any opened datasource with OGR_DS_Destroy() that will ensure all data is correctly flushed.

This method is the same as the C++ method OGRLayer::SyncToDisk()

Parameters

  hLayer | handle to the layer

Returns
  OGRERR_NONE if no error occurs (even if nothing is done) or an error code.

int OGR_L_TestCapability | ( | OGRLayerH | hLayer,
|  | const char * | pszCap
| ) |  |

Test if this layer supported the named capability.

The capability codes that can be tested are represented as strings, but #defined constants exists to ensure correct spelling. Specific layer types may implement class specific capabilities, but this can't generally be discovered by the caller.

- OLCRandomRead / "RandomRead": TRUE if the GetFeature() method is implemented in an optimized way for this layer, as opposed to the default implementation using ResetReading() and GetNextFeature() to find the requested feature id.

- OLCSequentialWrite / "SequentialWrite": TRUE if the CreateFeature() method works for this layer. Note this means that this particular layer is writable. The same OGRLayer class may returned FALSE for other layer instances that are effectively read-only.

- OLCRandomWrite / "RandomWrite": TRUE if the SetFeature() method is operational on this layer. Note this means that this particular layer is writable. The same OGRLayer class may returned FALSE for other layer instances that are effectively read-only.

- OLCFastSpatialFilter / "FastSpatialFilter": TRUE if this layer implements spatial filtering efficiently. Layers that effectively read all features, and test them with the OGRFeature intersection methods should return FALSE. This can be used as a clue by the application whether it should build and maintain its own spatial index for features in this layer.

- OLCFastFeatureCount / "FastFeatureCount": TRUE if this layer can return a feature count (via OGR_L_GetFeatureCount()) efficiently, i.e. without counting the features. In some cases this will return TRUE until a spatial filter is installed after which it will return FALSE.

- OLCFastGetExtent / "FastGetExtent": TRUE if this layer can return its data extent (via OGR_L_GetExtent()) efficiently, i.e. without scanning all the features. In some cases this will return TRUE until a spatial filter is installed after which it will return FALSE.

- OLCFastSetNextByIndex / "FastSetNextByIndex": TRUE if this layer can perform the SetNextByIndex() call efficiently, otherwise FALSE.

- OLCCreateField / "CreateField": TRUE if this layer can create new fields on the current layer using CreateField(), otherwise FALSE.

- OLCCreateGeomField / "CreateGeomField": (GDAL >= 1.11) TRUE if this layer can create new geometry fields on the current layer using CreateGeomField(), otherwise FALSE.

- OLCDeleteField / "DeleteField": TRUE if this layer can delete existing fields on the current layer using DeleteField(), otherwise FALSE.

- OLCReorderFields / "ReorderFields": TRUE if this layer can reorder existing fields on the current layer using ReorderField() or ReorderFields(), otherwise FALSE.

- OLCAlterFieldDefn / "AlterFieldDefn": TRUE if this layer can alter the definition of an existing field on the current layer using AlterFieldDefn(), otherwise FALSE.

- OLCDeleteFeature / "DeleteFeature": TRUE if the DeleteFeature() method is supported on this layer, otherwise FALSE.

- OLCStringsAsUTF8 / "StringsAsUTF8": TRUE if values of OFTString fields are assured to be in UTF-8 format. If FALSE the encoding of fields is uncertain, though it might still be UTF-8.

- OLCTransactions / "Transactions": TRUE if the StartTransaction(), CommitTransaction() and RollbackTransaction() methods work in a meaningful way, otherwise FALSE.

- OLCCurveGeometries / "CurveGeometries": TRUE if this layer supports writing curve geometries or may return such geometries. (GDAL 2.0).

This function is the same as the C++ method OGRLayer::TestCapability().

Parameters

  hLayer | handle to the layer to get the capability from.
  pszCap | the name of the capability to test.

Returns
  TRUE if the layer has the requested capability, or FALSE otherwise. OGRLayers will return FALSE for any unrecognized capabilities.

OGRErr OGR_L_Union | ( | OGRLayerH | pLayerInput,
|  | OGRLayerH | pLayerMethod,
|  | OGRLayerH | pLayerResult,
|  | char ** | papszOptions,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressArg
| ) |  |

Union of two layers.

The result layer contains features whose geometries represent areas that are in either in the input layer, in the method layer, or in both. The features in the result layer have attributes from both input and method layers. For features which represent areas that are only in the input or in the method layer the respective attributes have undefined values. The schema of the result layer can be set by the user or, if it is empty, is initialized to contain all fields in the input and method layers.

Note
  If the schema of the result is set by user and contains fields that have the same name as a field in input and in method layer, then the attribute in the result feature will get the value from the feature of the method layer (even if it is undefined).
  For best performance use the minimum amount of features in the method layer and copy it into a memory layer.
  This method relies on GEOS support. Do not use unless the GEOS support is compiled in.

The recognized list of options is :

- SKIP_FAILURES=YES/NO. Set it to YES to go on, even when a feature could not be inserted or a GEOS call failed.
- PROMOTE_TO_MULTI=YES/NO. Set it to YES to convert Polygons into MultiPolygons, or LineStrings to MultiLineStrings.
- INPUT_PREFIX=string. Set a prefix for the field names that will be created from the fields of the input layer.
- METHOD_PREFIX=string. Set a prefix for the field names that will be created from the fields of the method layer.
- USE_PREPARED_GEOMETRIES=YES/NO. Set to NO to not use prepared geometries to pretest intersection of features of method layer with features of this layer.
- KEEP_LOWER_DIMENSION_GEOMETRIES=YES/NO. Set to NO to skip result features with lower dimension geometry that would otherwise be added to the result layer. The default is to add but only if the result layer has an unknown geometry type.

This function is the same as the C++ method OGRLayer::Union().

Parameters

  pLayerInput | the input layer. Should not be NULL.
  pLayerMethod | the method layer. Should not be NULL.
  pLayerResult | the layer where the features resulting from the operation are inserted. Should not be NULL. See above the note about the schema.
  papszOptions | NULL terminated list of options (may be NULL).
  pfnProgress | a GDALProgressFunc() compatible callback function for reporting progress or NULL.
  pProgressArg | argument to be passed to pfnProgress. May be NULL.

Returns
  an error code if there was an error or the execution was interrupted, OGRERR_NONE otherwise.

Note
  The first geometry field is always used.

Since
  OGR 1.10

OGRErr OGR_L_Update | ( | OGRLayerH | pLayerInput,
|  | OGRLayerH | pLayerMethod,
|  | OGRLayerH | pLayerResult,
|  | char ** | papszOptions,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressArg
| ) |  |

Update this layer with features from the update layer.

The result layer contains features whose geometries represent areas that are either in the input layer or in the method layer. The features in the result layer have areas of the features of the method layer or those ares of the features of the input layer that are not covered by the method layer. The features of the result layer get their attributes from the input layer. The schema of the result layer can be set by the user or, if it is empty, is initialized to contain all fields in the input layer.

Note
  If the schema of the result is set by user and contains fields that have the same name as a field in the method layer, then the attribute in the result feature the originates from the method layer will get the value from the feature of the method layer.
  For best performance use the minimum amount of features in the method layer and copy it into a memory layer.
  This method relies on GEOS support. Do not use unless the GEOS support is compiled in.

The recognized list of options is :

- SKIP_FAILURES=YES/NO. Set it to YES to go on, even when a feature could not be inserted or a GEOS call failed.
- PROMOTE_TO_MULTI=YES/NO. Set it to YES to convert Polygons into MultiPolygons, or LineStrings to MultiLineStrings.
- INPUT_PREFIX=string. Set a prefix for the field names that will be created from the fields of the input layer.
- METHOD_PREFIX=string. Set a prefix for the field names that will be created from the fields of the method layer.

This function is the same as the C++ method OGRLayer::Update().

Parameters

  pLayerInput | the input layer. Should not be NULL.
  pLayerMethod | the method layer. Should not be NULL.
  pLayerResult | the layer where the features resulting from the operation are inserted. Should not be NULL. See above the note about the schema.
  papszOptions | NULL terminated list of options (may be NULL).
  pfnProgress | a GDALProgressFunc() compatible callback function for reporting progress or NULL.
  pProgressArg | argument to be passed to pfnProgress. May be NULL.

Returns
  an error code if there was an error or the execution was interrupted, OGRERR_NONE otherwise.

Note
  The first geometry field is always used.

Since
  OGR 1.10

int OGR_RawField_IsNull | ( | const OGRField * | puField | ) |

Returns whether a raw field is null.

Note: this function is rather low-level and should be rarely used in client code. Use instead OGR_F_IsFieldNull().

Parameters

  puField | pointer to raw field.

Since
  GDAL 2.2

int OGR_RawField_IsUnset | ( | const OGRField * | puField | ) |

Returns whether a raw field is unset.

Note: this function is rather low-level and should be rarely used in client code. Use instead OGR_F_IsFieldSet().

Parameters

  puField | pointer to raw field.

Since
  GDAL 2.2

void OGR_RawField_SetNull | ( | OGRField * | puField | ) |

Mark a raw field as null.

This should be called on a un-initialized field. In particular this will not free any memory dynamically allocated.

Note: this function is rather low-level and should be rarely used in client code. Use instead OGR_F_SetFieldNull().

Parameters

  puField | pointer to raw field.

Since
  GDAL 2.2

void OGR_RawField_SetUnset | ( | OGRField * | puField | ) |

Mark a raw field as unset.

This should be called on a un-initialized field. In particular this will not free any memory dynamically allocated.

Note: this function is rather low-level and should be rarely used in client code. Use instead OGR_F_UnsetField().

Parameters

  puField | pointer to raw field.

Since
  GDAL 2.2

int OGR_SM_AddPart | ( | OGRStyleMgrH | hSM,
|  | OGRStyleToolH | hST
| ) |  |

Add a part (style tool) to the current style.

This function is the same as the C++ method OGRStyleMgr::AddPart().

Parameters

  hSM | handle to the style manager.
  hST | the style tool defining the part to add.

Returns
  TRUE on success, FALSE on errors.

int OGR_SM_AddStyle | ( | OGRStyleMgrH | hSM,
|  | const char * | pszStyleName,
|  | const char * | pszStyleString
| ) |  |

Add a style to the current style table.

This function is the same as the C++ method OGRStyleMgr::AddStyle().

Parameters

  hSM | handle to the style manager.
  pszStyleName | the name of the style to add.
  pszStyleString | the style string to use, or NULL to use the style stored in the manager.

Returns
  TRUE on success, FALSE on errors.

OGRStyleMgrH OGR_SM_Create | ( | OGRStyleTableH | hStyleTable | ) |

OGRStyleMgr factory.

This function is the same as the C++ method OGRStyleMgr::OGRStyleMgr().

Parameters

  hStyleTable | pointer to OGRStyleTable or NULL if not working with a style table.

Returns
  an handle to the new style manager object.

void OGR_SM_Destroy | ( | OGRStyleMgrH | hSM | ) |

Destroy Style Manager.

This function is the same as the C++ method OGRStyleMgr::~OGRStyleMgr().

Parameters

  hSM | handle to the style manager to destroy.

OGRStyleToolH OGR_SM_GetPart | ( | OGRStyleMgrH | hSM,
|  | int | nPartId,
|  | const char * | pszStyleString
| ) |  |

Fetch a part (style tool) from the current style.

This function is the same as the C++ method OGRStyleMgr::GetPart().

This function instantiates a new object that should be freed with OGR_ST_Destroy().

Parameters

  hSM | handle to the style manager.
  nPartId | the part number (0-based index).
  pszStyleString | (optional) the style string on which to operate. If NULL then the current style string stored in the style manager is used.

Returns
  OGRStyleToolH of the requested part (style tools) or NULL on error.

int OGR_SM_GetPartCount | ( | OGRStyleMgrH | hSM,
|  | const char * | pszStyleString
| ) |  |

Get the number of parts in a style.

This function is the same as the C++ method OGRStyleMgr::GetPartCount().

Parameters

  hSM | handle to the style manager.
  pszStyleString | (optional) the style string on which to operate. If NULL then the current style string stored in the style manager is used.

Returns
  the number of parts (style tools) in the style.

const char* OGR_SM_InitFromFeature | ( | OGRStyleMgrH | hSM,
|  | OGRFeatureH | hFeat
| ) |  |

Initialize style manager from the style string of a feature.

This function is the same as the C++ method OGRStyleMgr::InitFromFeature().

Parameters

  hSM | handle to the style manager.
  hFeat | handle to the new feature from which to read the style.

Returns
  a reference to the style string read from the feature, or NULL in case of error.

int OGR_SM_InitStyleString | ( | OGRStyleMgrH | hSM,
|  | const char * | pszStyleString
| ) |  |

Initialize style manager from the style string.

This function is the same as the C++ method OGRStyleMgr::InitStyleString().

Parameters

  hSM | handle to the style manager.
  pszStyleString | the style string to use (can be NULL).

Returns
  TRUE on success, FALSE on errors.

OGRStyleToolH OGR_ST_Create | ( | OGRSTClassId | eClassId | ) |

OGRStyleTool factory.

This function is a constructor for OGRStyleTool derived classes.

Parameters

  eClassId | subclass of style tool to create. One of OGRSTCPen (1), OGRSTCBrush (2), OGRSTCSymbol (3) or OGRSTCLabel (4).

Returns
  an handle to the new style tool object or NULL if the creation failed.

void OGR_ST_Destroy | ( | OGRStyleToolH | hST | ) |

Destroy Style Tool.

Parameters

  hST | handle to the style tool to destroy.

double OGR_ST_GetParamDbl | ( | OGRStyleToolH | hST,
|  | int | eParam,
|  | int * | bValueIsNull
| ) |  |

Get Style Tool parameter value as a double.

Maps to the OGRStyleTool subclasses' GetParamDbl() methods.

Parameters

  hST | handle to the style tool.
  eParam | the parameter id from the enumeration corresponding to the type of this style tool (one of the OGRSTPenParam, OGRSTBrushParam, OGRSTSymbolParam or OGRSTLabelParam enumerations)
  bValueIsNull | pointer to an integer that will be set to TRUE or FALSE to indicate whether the parameter value is NULL.

Returns
  the parameter value as double and sets bValueIsNull.

int OGR_ST_GetParamNum | ( | OGRStyleToolH | hST,
|  | int | eParam,
|  | int * | bValueIsNull
| ) |  |

Get Style Tool parameter value as an integer.

Maps to the OGRStyleTool subclasses' GetParamNum() methods.

Parameters

  hST | handle to the style tool.
  eParam | the parameter id from the enumeration corresponding to the type of this style tool (one of the OGRSTPenParam, OGRSTBrushParam, OGRSTSymbolParam or OGRSTLabelParam enumerations)
  bValueIsNull | pointer to an integer that will be set to TRUE or FALSE to indicate whether the parameter value is NULL.

Returns
  the parameter value as integer and sets bValueIsNull.

const char* OGR_ST_GetParamStr | ( | OGRStyleToolH | hST,
|  | int | eParam,
|  | int * | bValueIsNull
| ) |  |

Get Style Tool parameter value as string.

Maps to the OGRStyleTool subclasses' GetParamStr() methods.

Parameters

  hST | handle to the style tool.
  eParam | the parameter id from the enumeration corresponding to the type of this style tool (one of the OGRSTPenParam, OGRSTBrushParam, OGRSTSymbolParam or OGRSTLabelParam enumerations)
  bValueIsNull | pointer to an integer that will be set to TRUE or FALSE to indicate whether the parameter value is NULL.

Returns
  the parameter value as string and sets bValueIsNull.

int OGR_ST_GetRGBFromString | ( | OGRStyleToolH | hST,
|  | const char * | pszColor,
|  | int * | pnRed,
|  | int * | pnGreen,
|  | int * | pnBlue,
|  | int * | pnAlpha
| ) |  |

Return the r,g,b,a components of a color encoded in #RRGGBB[AA] format.

Maps to OGRStyleTool::GetRGBFromString().

Parameters

  hST | handle to the style tool.
  pszColor | the color to parse
  pnRed | pointer to an int in which the red value will be returned
  pnGreen | pointer to an int in which the green value will be returned
  pnBlue | pointer to an int in which the blue value will be returned
  pnAlpha | pointer to an int in which the (optional) alpha value will be returned

Returns
  TRUE if the color could be successfully parsed, or FALSE in case of errors.

const char* OGR_ST_GetStyleString | ( | OGRStyleToolH | hST | ) |

Get the style string for this Style Tool.

Maps to the OGRStyleTool subclasses' GetStyleString() methods.

Parameters

  hST | handle to the style tool.

Returns
  the style string for this style tool or "" if the hST is invalid.

OGRSTClassId OGR_ST_GetType | ( | OGRStyleToolH | hST | ) |

Determine type of Style Tool.

Parameters

  hST | handle to the style tool.

Returns
  the style tool type, one of OGRSTCPen (1), OGRSTCBrush (2), OGRSTCSymbol (3) or OGRSTCLabel (4). Returns OGRSTCNone (0) if the OGRStyleToolH is invalid.

OGRSTUnitId OGR_ST_GetUnit | ( | OGRStyleToolH | hST | ) |

Get Style Tool units.

Parameters

  hST | handle to the style tool.

Returns
  the style tool units.

void OGR_ST_SetParamDbl | ( | OGRStyleToolH | hST,
|  | int | eParam,
|  | double | dfValue
| ) |  |

Set Style Tool parameter value from a double.

Maps to the OGRStyleTool subclasses' SetParamDbl() methods.

Parameters

  hST | handle to the style tool.
  eParam | the parameter id from the enumeration corresponding to the type of this style tool (one of the OGRSTPenParam, OGRSTBrushParam, OGRSTSymbolParam or OGRSTLabelParam enumerations)
  dfValue | the new parameter value

void OGR_ST_SetParamNum | ( | OGRStyleToolH | hST,
|  | int | eParam,
|  | int | nValue
| ) |  |

Set Style Tool parameter value from an integer.

Maps to the OGRStyleTool subclasses' SetParamNum() methods.

Parameters

  hST | handle to the style tool.
  eParam | the parameter id from the enumeration corresponding to the type of this style tool (one of the OGRSTPenParam, OGRSTBrushParam, OGRSTSymbolParam or OGRSTLabelParam enumerations)
  nValue | the new parameter value

void OGR_ST_SetParamStr | ( | OGRStyleToolH | hST,
|  | int | eParam,
|  | const char * | pszValue
| ) |  |

Set Style Tool parameter value from a string.

Maps to the OGRStyleTool subclasses' SetParamStr() methods.

Parameters

  hST | handle to the style tool.
  eParam | the parameter id from the enumeration corresponding to the type of this style tool (one of the OGRSTPenParam, OGRSTBrushParam, OGRSTSymbolParam or OGRSTLabelParam enumerations)
  pszValue | the new parameter value

void OGR_ST_SetUnit | ( | OGRStyleToolH | hST,
|  | OGRSTUnitId | eUnit,
|  | double | dfGroundPaperScale
| ) |  |

Set Style Tool units.

This function is the same as OGRStyleTool::SetUnit()

Parameters

  hST | handle to the style tool.
  eUnit | the new unit.
  dfGroundPaperScale | ground to paper scale factor.

int OGR_STBL_AddStyle | ( | OGRStyleTableH | hStyleTable,
|  | const char * | pszName,
|  | const char * | pszStyleString
| ) |  |

Add a new style in the table.

No comparison will be done on the Style string, only on the name. This function is the same as the C++ method OGRStyleTable::AddStyle().

Parameters

  hStyleTable | handle to the style table.
  pszName | the name the style to add.
  pszStyleString | the style string to add.

Returns
  TRUE on success, FALSE on error

OGRStyleTableH OGR_STBL_Create | ( | void |  | ) |

OGRStyleTable factory.

This function is the same as the C++ method OGRStyleTable::OGRStyleTable().

Returns
  an handle to the new style table object.

void OGR_STBL_Destroy | ( | OGRStyleTableH | hSTBL | ) |

Destroy Style Table.

Parameters

  hSTBL | handle to the style table to destroy.

const char* OGR_STBL_Find | ( | OGRStyleTableH | hStyleTable,
|  | const char * | pszName
| ) |  |

Get a style string by name.

This function is the same as the C++ method OGRStyleTable::Find().

Parameters

  hStyleTable | handle to the style table.
  pszName | the name of the style string to find.

Returns
  the style string matching the name or NULL if not found or error.

const char* OGR_STBL_GetLastStyleName | ( | OGRStyleTableH | hStyleTable | ) |

Get the style name of the last style string fetched with OGR_STBL_GetNextStyle.

This function is the same as the C++ method OGRStyleTable::GetStyleName().

Parameters

  hStyleTable | handle to the style table.

Returns
  the Name of the last style string or NULL on error.

const char* OGR_STBL_GetNextStyle | ( | OGRStyleTableH | hStyleTable | ) |

Get the next style string from the table.

This function is the same as the C++ method OGRStyleTable::GetNextStyle().

Parameters

  hStyleTable | handle to the style table.

Returns
  the next style string or NULL on error.

int OGR_STBL_LoadStyleTable | ( | OGRStyleTableH | hStyleTable,
|  | const char * | pszFilename
| ) |  |

Load a style table from a file.

This function is the same as the C++ method OGRStyleTable::LoadStyleTable().

Parameters

  hStyleTable | handle to the style table.
  pszFilename | the name of the file to load from.

Returns
  TRUE on success, FALSE on error

void OGR_STBL_ResetStyleStringReading | ( | OGRStyleTableH | hStyleTable | ) |

Reset the next style pointer to 0.

This function is the same as the C++ method OGRStyleTable::ResetStyleStringReading().

Parameters

  hStyleTable | handle to the style table.

int OGR_STBL_SaveStyleTable | ( | OGRStyleTableH | hStyleTable,
|  | const char * | pszFilename
| ) |  |

Save a style table to a file.

This function is the same as the C++ method OGRStyleTable::SaveStyleTable().

Parameters

  hStyleTable | handle to the style table.
  pszFilename | the name of the file to save to.

Returns
  TRUE on success, FALSE on error

OGRGeometryH OGRBuildPolygonFromEdges | ( | OGRGeometryH | hLines,
|  | int | bBestEffort,
|  | int | bAutoClose,
|  | double | dfTolerance,
|  | OGRErr * | peErr
| ) |  |

Build a ring from a bunch of arcs.

Parameters

  hLines | handle to an OGRGeometryCollection (or OGRMultiLineString) containing the line string geometries to be built into rings.
  bBestEffort | not yet implemented???.
  bAutoClose | indicates if the ring should be close when first and last points of the ring are the same.
  dfTolerance | tolerance into which two arcs are considered close enough to be joined.
  peErr | OGRERR_NONE on success, or OGRERR_FAILURE on failure.

Returns
  an handle to the new geometry, a polygon.

void OGRCleanupAll | ( | void |  | ) |

Clean-up all drivers (including raster ones starting with GDAL 2.0.

See GDALDestroyDriverManager()

OGRSFDriverH OGRGetDriver | ( | int | iDriver | ) |

Fetch the indicated driver.

NOTE: Starting with GDAL 2.0, it is NOT safe to cast the returned handle to OGRSFDriver*. If a C++ object is needed, the handle should be cast to GDALDriver*.

Deprecated:
  Use GDALGetDriver() in GDAL 2.0

Parameters

  iDriver | the driver index, from 0 to GetDriverCount()-1.

Returns
  handle to the driver, or NULL if iDriver is out of range.

OGRSFDriverH OGRGetDriverByName | ( | const char * | pszName | ) |

Fetch the indicated driver.

NOTE: Starting with GDAL 2.0, it is NOT safe to cast the returned handle to OGRSFDriver*. If a C++ object is needed, the handle should be cast to GDALDriver*.

Deprecated:
  Use GDALGetDriverByName() in GDAL 2.0

Parameters

  pszName | the driver name

Returns
  the driver, or NULL if no driver with that name is found

int OGRGetDriverCount | ( | void |  | ) |

Fetch the number of registered drivers.

Deprecated:
  Use GDALGetDriverCount() in GDAL 2.0

Returns
  the drivers count.

int OGRGetNonLinearGeometriesEnabledFlag | ( | void |  | ) |

Get flag to enable/disable returning non-linear geometries in the C API.

return TRUE if non-linear geometries might be returned (default value is TRUE).

Since
  GDAL 2.0

See also
  OGRSetNonLinearGeometriesEnabledFlag()

OGRDataSourceH OGROpen | ( | const char * | pszName,
|  | int | bUpdate,
|  | OGRSFDriverH * | pahDriverList
| ) |  |

Open a file / data source with one of the registered drivers.

This function loops through all the drivers registered with the driver manager trying each until one succeeds with the given data source.

If this function fails, CPLGetLastErrorMsg() can be used to check if there is an error message explaining why.

For drivers supporting the VSI virtual file API, it is possible to open a file in a .zip archive (see VSIInstallZipFileHandler()), in a .tar/.tar.gz/.tgz archive (see VSIInstallTarFileHandler()) or on a HTTP / FTP server (see VSIInstallCurlFileHandler())

NOTE: Starting with GDAL 2.0, it is NOT safe to cast the returned handle to OGRDataSource*. If a C++ object is needed, the handle should be cast to GDALDataset*. Similarly, the returned OGRSFDriverH handle should be cast to GDALDriver*, and NOT* OGRSFDriver*.

Deprecated:
  Use GDALOpenEx() in GDAL 2.0

Parameters

  pszName | the name of the file, or data source to open.
  bUpdate | FALSE for read-only access (the default) or TRUE for read-write access.
  pahDriverList | if non-NULL, this argument will be updated with a pointer to the driver which was used to open the data source.

Returns
  NULL on error or if the pass name is not supported by this driver, otherwise an handle to a GDALDataset. This GDALDataset should be closed by deleting the object when it is no longer needed.

Example:

      OGRDataSourceH        hDS;
      OGRSFDriverH        *pahDriver;

      hDS = OGROpen( "polygon.shp", 0, pahDriver );
      if( hDS == NULL )
      {
          return;
      }

      ... use the data source ...

      OGRReleaseDataSource( hDS );

OGRDataSourceH OGROpenShared | ( | const char * | pszName,
|  | int | bUpdate,
|  | OGRSFDriverH * | pahDriverList
| ) |  |

Open a file / data source with one of the registered drivers if not already opened, or increment reference count of already opened data source previously opened with OGROpenShared()

This function loops through all the drivers registered with the driver manager trying each until one succeeds with the given data source.

If this function fails, CPLGetLastErrorMsg() can be used to check if there is an error message explaining why.

NOTE: Starting with GDAL 2.0, it is NOT safe to cast the returned handle to OGRDataSource*. If a C++ object is needed, the handle should be cast to GDALDataset*. Similarly, the returned OGRSFDriverH handle should be cast to GDALDriver*, and NOT* OGRSFDriver*.

Deprecated:
  Use GDALOpenEx() in GDAL 2.0

Parameters

  pszName | the name of the file, or data source to open.
  bUpdate | FALSE for read-only access (the default) or TRUE for read-write access.
  pahDriverList | if non-NULL, this argument will be updated with a pointer to the driver which was used to open the data source.

Returns
  NULL on error or if the pass name is not supported by this driver, otherwise an handle to a GDALDataset. This GDALDataset should be closed by deleting the object when it is no longer needed.

Example:

      OGRDataSourceH  hDS;
      OGRSFDriverH        *pahDriver;

      hDS = OGROpenShared( "polygon.shp", 0, pahDriver );
      if( hDS == NULL )
      {
          return;
      }

      ... use the data source ...

      OGRReleaseDataSource( hDS );

int OGRRegisterAll | ( | void |  | ) |

Register all drivers.

Deprecated:
  Use GDALAllRegister() in GDAL 2.0

OGRErr OGRReleaseDataSource | ( | OGRDataSourceH | hDS | ) |

Drop a reference to this datasource, and if the reference count drops to zero close (destroy) the datasource.

Internally this actually calls the OGRSFDriverRegistrar::ReleaseDataSource() method. This method is essentially a convenient alias.

Deprecated:
  Use GDALClose() in GDAL 2.0

Parameters

  hDS | handle to the data source to release

Returns
  OGRERR_NONE on success or an error code.

void OGRSetNonLinearGeometriesEnabledFlag | ( | int | bFlag | ) |

Set flag to enable/disable returning non-linear geometries in the C API.

This flag has only an effect on the OGR_F_GetGeometryRef(), OGR_F_GetGeomFieldRef(), OGR_L_GetGeomType(), OGR_GFld_GetType() and OGR_FD_GetGeomType() C API, and corresponding methods in the SWIG bindings. It is meant as making it simple for applications using the OGR C API not to have to deal with non-linear geometries, even if such geometries might be returned by drivers. In which case, they will be transformed into their closest linear geometry, by doing linear approximation, with OGR_G_ForceTo().

Libraries should generally not use that method, since that could interfere with other libraries or applications.

Note that it does not affect the behaviour of the C++ API.

Parameters

  bFlag | TRUE if non-linear geometries might be returned (default value). FALSE to ask for non-linear geometries to be approximated as linear geometries.

Returns
  a point or NULL.

Since
  GDAL 2.0

Generated for GDAL by 1.8.9.1.